#ifndef __EFFETS_H
#define __EFFETS_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
//#include <unistd.h>

#include "SDL.h"
#include "SDL_image.h"
#include "smpeg.h"

#define uchar unsigned char

// et aussi les macros gniales...
#define PATH_2D "../data/2d/"
#define PATH_3D "../data/3d/"
#define PATH_ZIK "../data/zik/"
#define PATH_OTHER "../data/other/"


#include "f3Dutils.h"
#include "obj1.h" 	// pour l'effet de scroll
#include "obj2.h"
#include "obj3.h"
#include "obj4.h"
#include "blend.h"

#include "lettres.h"
#include "move_tex.h"
#include "greets.h"
#include "parts.h"
#include "toto.h"
#include "waves.h"

#include "conf.h"



// flou 
void plouf(Uint32 *buffer, Uint32 *buftmp );
void plouf2( Uint32 *buffer, Uint32 *image, int grandeur );

// ici on met les headers de touts les effets appels par le main...
void effet1();
void testbitmap (int argc, char *argv[]);
void testload (SDL_Surface *image);
// void plane();
// void cube(SDL_Event &event, SDL_Surface *screen);
int load_l3d();

void line(Uint32 *screen, int xd, int yd, int xf, int yf, Uint32 col);
void line2(Uint32 *screen, int xd, int yd, int xf, int yf, Uint32 col);
void ced(Uint32 *buffer);
void ced_init();

// routine de zoom +/- gnrique
void zoom(Uint32 *src, Uint32 *dst, int SW, int DW,
					int sx1, int sx2, int dx1, int dx2, 
					int sy1, int sy2, int dy1, int dy2);

// appel logo
void logodemo(Uint32 *buffer, Uint32 time,
	Logo &logo1, Logo &logo2, Logo &logo3, Logo &logo4);

// et aussi les routines en asm
void mmx_blur (void *, int taille) asm ("mmx_blur");
void asm_plot (Uint8 *src, int ratio, int compl_ratio, Uint8 *pvalscolor,
           int c, Uint8 *dest) asm ("asm_plot");
void mmx_plot (void *src, void *pvalscolor, void *dest, 
	       int *dist_tab, int pvalsradius, 
	       int *angle_tab, int mask_nspoke, int *spoke) 
	asm ("mmx_plot");
void asm_emms () asm ("asm_emms");

void mmx_scroll (int itime, int rtime, void *buftmp,
		 void *pfond, int taille) asm ("mmx_scroll");

void mmx_scroll2 (int itime, int rtime, Uint32 *buftmp,
		 Uint32 *pfond, int taille, int degrade) asm ("mmx_scroll2");

int mmx_scroll3 (int itime, int rtime, Uint32 *buftmp,
		 Uint8 *pfond, int taille, int degrade, Uint32 *colors) asm ("mmx_scroll3");

// sature un groupe de pixel
void mmx_sat (Uint32 *buftmp, int taille, Uint32 sat, Uint32 ajout1) asm ("mmx_sat"); 

// copie un groupe de 2pixel
void mmx_quadcpy (void *src, void *dst, int dbtaille) asm ("mmx_quadcpy");
// efface un groupe de 2pixel
void mmx_quaddel (void *dst, int dbtaille, Uint32 col) asm ("mmx_quaddel");
// copie en ajout
void mmx_addcol (void *src, void *dst, int dbtaille, int d) asm ("mmx_addcol");

// un blur
void mmx_blur2 (Uint32 *dest, Uint32 *src, int xnb, int ynb,
		int xsadd, int xdadd, int ysoffadd) asm("mmx_blur2");

// copy en negatif (sub?)
void mmx_quadnegsub (void *src, void *dst, int dbtaille, Uint32 mask) asm ("mmx_quadnegsub");

// lettres
void mmx_lettre (void *src, void *dst, int dbtaille, Uint32 mask, Uint32 alpha) asm ("mmx_lettre");

//pour la rasterization
void mmx_scanit(int l, int iVx, int iVy, int wtex, 
		int iVXpad, int iVYpad, Uint32 *screen, Uint32 *tex, Uint32 d2) asm ("mmx_scanit");

//pour la rasterization avec transparence et bilinear_filtering
void mmx_scanit_filt(int l, int iVx, int iVy, int wtex, 
		int iVXpad, int iVYpad, Uint32 *screen, Uint32 *tex, Uint32 d2) asm ("mxscan3");


//pour la rasterization sans transparence
void mmx_scanit_notrans(int l, int iVx, int iVy, int wtex, 
		int iVXpad, int iVYpad, Uint32 *screen, Uint32 *tex) asm ("mxscan2");

// affichage d'un pixel en ajout (particules)
int mmx_findColorAdd(int sc, int dc, int csub) asm ("mmx_findColorAdd");

//pour le bilinear filtering
void mmx_pixfilt(Uint32 *screen, Uint32 *pa, Uint32 *pc, int dx, int dy, int d2) asm ("mmx_pixfilt");
void mmx_pixfilt_add(Uint32 *screen, Uint32 *pa, Uint32 *pc, int dx, int dy, int d2) asm ("mmx_pixfilt_add");

void mmx_pixfilt2(Uint32 *screen, Uint32* soff, int W, int z, int dy, int d2, int zx, int xcount) asm ("mmx_pixfilt2");

#undef  CLAMP  // pomp de la glib
#define CLAMP(x, low, high)  (((x) > (high)) ? (high) : (((x) < (low)) ? (low) : (x)))

#define LOCK
#ifdef LOCK
	#define LOCK_SURFACE(screen) /*SDL_LockSurface(screen)*/;
	#define UNLOCK_SURFACE(screen) /*SDL_UnlockSurface(screen)*/;
#endif

#define AMASK 0xFF000000
#define RMASK 0xFF0000
#define GMASK 0xFF00
#define BMASK 0xFF

#define ASHFT (24)
#define RSHFT (16)
#define GSHFT (8)
#define BSHFT (0)



#endif // __EFFETS_H
