// Etoile
// Une toile qui brule en faisant un fire 

#ifndef ETOILE_H
#define ETOILE_H

class Plan;
class Etoile 
{
 public:
  Etoile(Plan *plan_, vector<Vect> pos_,
	 vector<Vect> rot_, Sable &sable1);
  ~Etoile();
  void go( Uint32* buffer, Uint32 time, bool debug_cam );
 private:
  float *x_star;
  float *y_star;

  fVector *vstar;
  char *lsrc;

  float ax, ay, az, w;

  static const float R = 50.0;
  static const int NBSTAR = 5;

  static const int SCREENWIDTH = 640;
  static const int SCREENHEIGHT = 480;

  Plan *plan;
  Uint32 *buff;

  void blur (Uint32 *src, Uint32 *dst);
  bool xin(int x);
  bool yin(int y);

  vector<Vect> pos;
  vector<Vect> rot;
  
  void line(Uint32 *screen, int xd, int yd, 
	    int xf, int yf, Uint32 col);
  
  void LowDrawAlpha(Uint32 *screen, Uint32 *soff,
		    const int ycount, const int xcount);
  Uint32 cmerge(const int src, const int dst, 
		const int ALPHA);
  
  static const int NBS = 50;
  Sable *tsable[NBS*5]; // tableau de nb_sable ptr sur Sable
  int bruit[NBS*5];

};

#endif ETOILE_H
