/*
 *  16.16 FixedPoint
 *  Asm Optimized
 */

#ifndef _F3DUTILS_H_
#define _F3DUTILS_H_

//#include <stdio.h>
//#include <math.h>

#define MAX_TRIG        1024

// Macros for Vector access
#define VECT_X      0
#define VECT_Y      1
#define VECT_Z      2

typedef float fIangle;
typedef float fVector[3];     // Vector
typedef float fMatrix[12];    // Matrix[3][4]
typedef int iVector[3];	      // Vecteur entier

union Vect {
  fVector v;
  float x,y,z;
};

/* Trigo */
#ifndef FTRIGO_C
#define FTRIGO_C
extern float fSinTab[1024];
extern float fCosTab[1024];
extern float fTanTab[1024];
#endif
void f_CosSin(fIangle theta, float *Cos, float *Sin);
float f_Tan(fIangle theta);

/* Vectors */
void  f_printvector(fVector v);
void  f_make_vector(fVector v, float x, float y, float z);
void  f_VectCopy(fVector sv, fVector dv);
void  f_VectAdd(fVector v1, fVector v2, fVector dv);
void  f_VectSub(fVector v1, fVector v2, fVector dv);
float f_VectLen(fVector v);
float f_VectLen_2(fVector v);
float f_VectDist(fVector v1, fVector v2);
float f_VectDist_2(fVector v1, fVector v2);
void  f_ScaleVect(fVector v, float factor);
void  f_NormalizeVect(fVector v);
float f_DotProduct(fVector v1, fVector v2);
void  f_CrossProduct(fVector v1, fVector v2, fVector dv);
float f_CrossZProduct(fVector v1, fVector v2);

/* Vectors Int */

/* 16:16 */
void fulliVector(iVector dst, fVector src);

/* Matrix */
void f_printmatrix(fMatrix m);
void f_make_identity_matrix(fMatrix m);
void f_make_scale_matrix(fMatrix m, fVector sv);
void f_make_trans_matrix(fMatrix m, fVector tv);
void f_make_xrot_matrix(fMatrix m, fIangle theta);
void f_make_yrot_matrix(fMatrix m, fIangle theta);
void f_make_zrot_matrix(fMatrix m, fIangle theta);
void f_MatrixCopy(fMatrix sm, fMatrix dm);
void f_ConcatMatrices(fMatrix m1, fMatrix m2, fMatrix dm);
void f_trans_matrix(fMatrix m, fVector dv);
void f_trans_matrix(fMatrix m, float x, float y, float z );
void f_append_xrot_matrix(fMatrix m, fIangle theta);
void f_append_yrot_matrix(fMatrix m, fIangle theta);
void f_append_zrot_matrix(fMatrix m, fIangle theta);
void f_XformVector(fMatrix m, fVector sv, fVector dv);
void f_transpose_matrix(fMatrix &m);
void f_make_xyzrot_matrix(fMatrix m, fIangle ax, fIangle ay, fIangle az);

#endif
/* _F3DUTILS_ */

