#ifndef LANDSCAPE_H
#define LANDSCAPE_H


// constructeur
class Landscape
{
 public:
  Landscape();
  ~Landscape();
  void go(Uint32 *screen, Uint32 time);
  void palais(Uint32 *buffer);
 private:

  static const int SCREENWIDTH  = 640;
  static const int SCREENHEIGHT = 480;
  static const float FOV=M_PI/4.0;   // half of the xy field of view 
  // (This is based on the 0-2048 convention)

  void LoadTexture(const char *path, SDL_Surface *&tex);
  void LoadTexture8(const char *path, uchar *&tex, Uint32 *col);

  Uint32 ConvertPixel(const Uint32 src,  const Uint32 srcformat, 
		      const Uint32 srcshift, const Uint32 SHIFT);

  void View ();
  void line(int ixpl, int iypl, 
	    int ixpr, int iypr, int t);

  void sky(Uint32 time);
  void prep_uv();

  Uint32 col[256];
  uchar *tmap;
  uchar *hmap;
  float tu[640*280];
  SDL_Surface *skyt;
  SDL_Surface *texture;
  SDL_Surface *spalais;

  float x0, y0, height, yangle;
  Uint32 *screen;
  int *ymap; // last Y used
  int *iymap; // last ytext used
  int *ixmap; // last xtext used
  bool *trace;

  // pour le ciel
  float R;

};

#endif // LANDSCAPE_H
