#ifndef __OBJ2_H
#define __OBJ2_H

// logo1
class Z1 
{
	public:
		Z1(); // constructeur
		~Z1(); // destructeur
		void go(Uint32 *buffer, Uint32 time);
		SDL_Surface *surf1, *surf2, *surf3, *surf4;
		SDL_Surface *fin1; 
	private:
		int CX,CY; // pour centrer l'image
		int SIZE, SIZ2;
		int FOCUS;

		float  tz, step;
		Uint32 pal1[1024];

		// sqrt
		int pcalcx[640*480]; 
		int pcalcy[640*480];
		int pcalcz[640*480];
		// calcule le perlin noise
		void perlin(uchar *src1, const int step=32, const int RANGE=256);
		// fait la somme des textures
		void Z1::somme(uchar *buffer, uchar *src1, uchar *src2, uchar *src3, 
				uchar *src4);
		// calcule racines
		void Z1::racine();
};


#include "lib3ds/file.h"
#include "lib3ds/mesh.h"
#include "lib3ds/node.h"
#include "lib3ds/vector.h"
#include "f3Dutils.h"
#include "Render.h"
#include "Object.h"
#include "3DPath.h"
#include "waves.h"

#include <vector>
// 3d ced
class _3D
{
	public:
		_3D(Render *rd);
		~_3D();
		void go(Uint32 *screen, Uint32 time);
	private:
		Render *rd;
		Object *avion1;
		Object *avion2;
		// Path path;
		
		// Utils vars 
		//fMatrix m,rm,tm,trans;
		//fVector vid;
		//fVector *ncube;
		//int x,y,z,pos;
		//float xangle, yangle, zangle;
};

class move_cam
{
	public:
		move_cam(Render *rd);
		~move_cam();
		void go(Uint32 time);
	private:
		Render *rd;
		Path path;
};

class scroll_miroir
{
 public:
	scroll_miroir(Render *rd);
	~scroll_miroir();
	void go(Uint32 *screen, Uint32 time);
 private:
	waves *wave;
	Render *rd;
	int sprite;
	int flaque;
	SDL_Surface *sdl_sprite;
	SDL_Surface *sdl_flaque;
	SDL_Surface *temp;
	SDL_Surface *wavetemp;
};

class generique
{
 public:
	generique(Render *rd);
	~generique();
	void go(Uint32 *screen, Uint32 time);
 private:
	Uint32 lastcall;
	Render *rd;
	int cache;
	int scroll;
};

class fireball
{
 public:
	fireball(Render *rd);
	~fireball();
	void go(Uint32 *screen, Uint32 time);
	void make(Uint32 time, Uint32 life);
 private:
	Uint32 lastcall;
	Render *rd;
	int sprite;
	struct info {
		Uint32 life;
		Uint32 born;
		float decalx;
		float decaly;
		float decalz;
		float rot;
	};
	vector<info> stars;
};

class fantomes
{
 public:
	fantomes(Render *rd);
	~fantomes();
	void go(Uint32 *screen, Uint32 time);
 private:
	Render *rd;
	int sprite1;
	int sprite2;
};

class sarah_feu
{
 public:
	sarah_feu(Render *rd);
	~sarah_feu();
	void go(Uint32 *screen, Uint32 time);
 private:
	Uint32 launchtime;
	Render *rd;
	int sprite1;
	int sprite2;
};
class diapofin
{
 public:
	diapofin(Render *rd);
	~diapofin();
	void go(Uint32 *screen, Uint32 time);
 private:
	Uint32 launchtime;
	Render *rd;
	int sprite1;
	int sprite2;
	int sprite3;
	int sprite4;
	int sprite5;
	int sprite6;
};

class marche
{
 public:
	marche(Render *rd);
	~marche();
	void go(Uint32 *screen, Uint32 time);
 private:
	Uint32 launchtime;
	Render *rd;
	int sprite1;
	int sprite2;
	int sprite3;
	int sprite4;
};

// 3d ced
class stargate
{
	public:
		stargate(); // constructeur
		~stargate(); // destructeur
		void go(Uint32 *screen, Uint32 time);
	private:
		SDL_Surface *myloadedtexture;
		SDL_Surface *mytexture;
		// Utils vars 
		fMatrix m,rm,tm,trans;
		fVector ntri[4];
		iVector intri[4];
		int x,y,z,pos;
		float xangle, yangle, zangle;
};

#endif // __OBJ2_H
// end of obj2.h

