#ifndef PARTS_H
#define PARTS_H

const int MIPMAP=0X1;

class parts
{
 public:
	
	parts(Render *rd, char* path = PATH_2D "sprite2.png");
	~parts();
	void go( Uint32 *buffer, Uint32 time );
	
	static parts *getInstance();
	
	void putPart2(Uint32*pscreen, iVector pos);

	// Affiche une particule depuis son centre
	void putPart(Uint32* pscreen, int X, int Y, const int Z, const int INV_POWA, const int options = MIPMAP);

 private:

	void LowDrawAlpha(Uint32 doff, Uint32 soff, 
			  const int ycount, const int xcount, 
			  const int xsadd, const int xdadd );

	void LowDrawAlphaAdd(Uint32 doff, Uint32 soff, 
			     const int ycount, const int xcount, 
			     const int xdadd,
			     const int z,    // 256*trop grand
			     const int csub);

	void LowDrawAlphaAddMipMap(Uint32 doff, Uint32 soff, Uint32 soff2,
				   const int ycount, const int xcount, 
				   const int xdadd,
				   const int z,    // 256*trop grand
				   const int csub, const int depth);

	void LowDrawAlphaAddBiFilt(Uint32 doff, Uint32 soff, 
			     const int ycount, const int xcount, 
			     const int xdadd,
			     const int z,    // 256*trop grand
			     const int csub);

	int CalcMip(int Z, float &fZ, int &depth) const;

	bool prep_draw( int &X, int &Y, Uint32 &doff, 
		       Uint32 &soff, int &ycount, int &xcount, int &xdadd,
		       float &fZ, Uint32 &soff2);

	bool do_clip(int &sleft, int &sright, int &count,
		     int &dleft_add, int &dright_add,
		     int &t, const int SIZE,
		     const int DRIGHT_LIM, const int DLEFT_LIM=0);

	inline Uint32 cmerge(const int src, const int dst, const int ALPHA) const;
	inline Uint32 cadd(const int src, const int dst, int sub) const ;
	inline Uint32 findColorAdd(const Uint32 sc, const Uint32 dc, const Uint32 csub) const;

        float Xcam, Ycam, Zcam;
        float Xang, Yang, Zang;
        SDL_Surface *partex, *partex2;
	static const int NB_MIP = 6;
	SDL_Surface *StarMip[NB_MIP];  // pour le MipMapping
	Uint32 *pscreen; // pointeur sur ecran
	//int X, Y; // sprite position
	static const int NB_PLOT = 500;
	fVector plot[NB_PLOT];
	Render *rd;
};

#endif PARTS_H
