// Le plan infini

#ifndef PLAN_H
#define PLAN_H

// constantes
#define STEP 32
#define STEP_SHIFT 5
#define SHIFT1 0
#define SHIFT2 10
#define MUL1 1024.0
#define ADD_ROUND MUL1/2
#define HAUTEUR ((480/STEP)+1)
#define LARGEUR ((640/STEP)+1)

// structure de la camera
typedef struct T_camera {
	double poscam[3];			// position de la camera
	double rotcam[3];			// rotation par rapport au repre principal
	double focus;				// focus de la camera
	int addy;
} T_camera;

// classe du plan
class Plan
{
	public:
		Plan(); // constructeur (charge textures)
		~Plan(); // destruction
		// damier(); // par Ced
		void plan_txt(Uint32 *buffer); // plan textur
		void mouse(SDL_Event event); // chope la souris
		void coord(Uint32 time); // bougeage de camera
                void do_lignes(Uint32 *buffer);
		void getMouse(fVector lposcam_, fVector lrotcam_);
		SDL_Surface *text1; // la texture du sol
	private:
		T_camera cam0; // la camera
		fMatrix rm; // rotation
		// donnes du plan textur
		float uvprecalc[HAUTEUR*LARGEUR*2]; // u,v 
		float lprecalc[HAUTEUR*LARGEUR]; // light
		Uint32 src2[64*64]; // mapp pour le mipmapp

		const static int nmipmap = 4;
		Uint32 *mipmap[nmipmap];

		// donnes du damier
		float poscamadd[3], rotcamadd[3];
		fVector lposcam, lrotcam;
		fVector lposcamadd;
		float lzrotadd;

		// autre
		int ifrot; // souris appuye ou non
		float mouse_rotx,mouse_roty; // rotation souris

		// fonctions 
		void fillvect (double *vect, double x,double y,double z);
		void normvect (double *vect, double *norm);
		void rot (double *rot, double *vect);
		void rotate_cam (double *dircamx, double *dircamy, double *dircamz, 
				 T_camera &cam);
		void putpixel1 (Uint32 *src, Uint32 *dest, int offsetd2,
				 Uint32 xf, Uint32 yf, Uint32 lf);
		void putpixel2 (Uint32 *src, Uint32 *dest, int offsetd2,
				 Uint32 xf, Uint32 yf, Uint32 lf);
		void interp(int x1, int x2, int x3, int x4, 
				int y1, int y2, int y3, int y4,
				int l1, int l2, int l3, int l4, 
				int offsetd1,
				Uint32 *dest, Uint32 *src);
		void do_map(Uint32 *dest, Uint32 *src, T_camera &cam);
		void prep_mipmap();
};

#endif //  PLAN_H
