// parsetime.h

#ifndef TIMEPARSE_H
#define TIMEPARSE_H

#include <string>
#include <list>
#include <vector>

#include "f3Dutils.h"

// #define DEBUG_TPARSE

struct TTime {
  TTime(int de, int du) : debut(de), duree(du) {}
  int debut, duree;
};

struct Func {
  Func(string name, int de, int du) : 
    fname(name), timing(de, du)
  {}
  string fname;  // function name
  TTime timing;
};

class Timeparse
{
 public:
  Timeparse(char *file);
  bool findTime(const int time, list<Func>::iterator &ifunc );

  list<Func> lfunc;
  vector<Vect> vpos;
  vector<Vect> vrot;
};

#endif // TIMEPARSE_H
