// waves.h - Fait des vagues.
#ifndef __waves_h
#define __waves_h

// Classe pour un effet de vagues sur une image.
class waves
{
public:
    // Constructeur. L'effet travaillera sur une image de taille W x H. La
    // vague est centr en CX x CY, avec une longueur de vague L et une
    // vitesse S. La vague a une amplitude de A pixels.
    waves (int w, int h, int cx, int cy, int l, int s, int a);
    // Fait le menage.
    ~waves (void);
    // Calcule l'effet au temps T dans l'image DST  partir de SRC.
    void go (Uint32 *src, Uint32 *dst, Uint32 t);
private:
    Sint32 *sintbl;
    Uint8 *dtbl;
    int speed;
    int width;
    int size;
    int ampl;
};

#endif // __waves_h
