; Les fonctions 3D en assembleur

BITS 32

global mmx_scanit
global mxscan2
global mxscan3
global mmx_pixfilt_add
global mmx_pixfilt

; Affiche un raster avec transparence
;void scanit(int off, int l, int iVx, int iVy, int wtex, 
;					  int iVXpad, int iVYpad, Uint32 *screen, Uint32 *tex, Uint32 d2)

; 8 :  l
; 12 : iVx
; 16 : iVy
; 20 : wtex
; 24 : iVXpad
; 28 : iVYpad
; 32 : screen
; 36 : tex
; 40 : d2
mmx_scanit:
	push ebp
	mov ebp,esp
	push edi 
	push esi
	push ecx
	push ebx

	mov ecx,[ebp+8]
	movd mm1,[ebp+12] ; mm1 : iVx
	movd mm2,[ebp+16] ; mm2 : iVy
	movd mm3,[ebp+20] ; mm3 : wtex
	movd mm4,[ebp+24] ; mm4 : iVXpad
	movd mm5,[ebp+28] ; mm5 : iVYpad

	mov edi,[ebp+32]
	mov esi,[ebp+36]
	movd mm6,[ebp+40]

	mov eax,1
	movd mm0,eax ; mm0 : 1

	punpckldq mm5,mm4 ; mm5 : iVXpad | iVYpad
	punpckldq mm2,mm1 ; mm2 :    iVx |    iVy
	punpckldq mm3,mm0 ; mm3 :      1 |   wtex
	; punpckldq mm6,mm6
	packssdw mm3,mm3
 
scanlp1:

	movq mm4,mm2      ; mm4 :    iVx |    iVy 
	psrad mm2, 16     ; mm2 :   iVxr |   iVyr
	packssdw mm2,mm2	

	pmaddwd mm2,mm3   ; mm1 : iVxr + wtex*iVyr 
	movd ebx,mm2

	paddd mm4,mm5
	movq mm2,mm4	

	movd mm1,[esi+ebx*4]
	movq mm0,mm6
	movd mm7,[edi]
	psubusb mm1,mm0
	paddusb mm1,mm7
	movd [edi],mm1


	
	add edi,4
	dec ecx
	jnz scanlp1
	
	pop ebx
	pop ecx	
	pop esi
	pop edi
	pop ebp
	ret

; Pareil mais sans transparence
; 8 :  l
; 12 : iVx
; 16 : iVy
; 20 : wtex
; 24 : iVXpad
; 28 : iVYpad
; 32 : screen
; 36 : tex
mxscan2:
	push ebp
	mov ebp,esp
	push edi 
	push esi
	push ecx
	push ebx

	mov ecx,[ebp+8]
	movd mm1,[ebp+12] ; mm1 : iVx
	movd mm2,[ebp+16] ; mm2 : iVy
	movd mm3,[ebp+20] ; mm3 : wtex
	movd mm4,[ebp+24] ; mm4 : iVXpad
	movd mm5,[ebp+28] ; mm5 : iVYpad

	mov edi,[ebp+32]
	mov esi,[ebp+36]

	mov eax,1
	movd mm0,eax ; mm0 : 1

	punpckldq mm5,mm4 ; mm5 : iVXpad | iVYpad
	punpckldq mm2,mm1 ; mm2 :    iVx |    iVy
	punpckldq mm3,mm0 ; mm3 :      1 |   wtex
	; punpckldq mm6,mm6
	packssdw mm3,mm3
 
scanlp2:

	movq mm4,mm2      ; mm4 :    iVx |    iVy 
	psrad mm2, 16     ; mm2 :   iVxr |   iVyr
	packssdw mm2,mm2	

	pmaddwd mm2,mm3   ; mm1 : iVxr + wtex*iVyr 
	movd ebx,mm2

	paddd mm4,mm5
	movq mm2,mm4	

	movd mm1,[esi+ebx*4]
	movd [edi],mm1
	
	add edi,4
	dec ecx
	jnz scanlp2
	
	pop ebx
	pop ecx	
	pop esi
	pop edi
	pop ebp
	ret

; Affiche un raster avec transparence et mipmapping
;void scanit(int off, int l, int iVx, int iVy, int wtex, 
;					  int iVXpad, int iVYpad, Uint32 *screen, Uint32 *tex, Uint32 d2)

; 8 :  l
; 12 : iVx
; 16 : iVy
; 20 : wtex
; 24 : iVXpad
; 28 : iVYpad
; 32 : screen
; 36 : tex
; 40 : d2

_hack dw 1,1,1,1

mxscan3:
	push ebp
	mov ebp,esp
	push edi 
	push esi
	push ecx
	push ebx

	mov ecx,[ebp+8]
	movd mm1,[ebp+12] ; mm1 : iVx
	movd mm2,[ebp+16] ; mm2 : iVy
	movd mm3,[ebp+20] ; mm3 : wtex
	movd mm4,[ebp+24] ; mm4 : iVXpad
	movd mm5,[ebp+28] ; mm5 : iVYpad

	mov edi,[ebp+32]
	mov esi,[ebp+36]
	mov eax,1
	movd mm0,eax ; mm0 : 1
	; mov eax,[ebp+40]

	punpckldq mm5,mm4 ; mm5 : iVXpad | iVYpad
	punpckldq mm2,mm1 ; mm2 :    iVx |    iVy
	punpckldq mm3,mm0 ; mm3 :      1 |   wtex
	packssdw mm3,mm3
 	pxor mm7,mm7
 
scanlp3:

	movq mm4,mm2      ; mm4 :    iVx |    iVy 
	psrad mm2, 16     ; mm2 :   iVxr |   iVyr
	packssdw mm2,mm2	

	pmaddwd mm2,mm3   ; mm2 : iVxr + wtex*iVyr 
	movd ebx,mm2

	paddd mm4,mm5
	movq mm2,mm4	

	; ralise le bilinear-filtering
	; libre: mm0, mm4, mm6, mm7, edx, eax

   ;	add esi,[ebp+20]     ; avance de 1 ligne
   ;	movd mm0,[esi+ebx*4] ; rcupre les deux autres points
	movq mm0,[esi+ebx*4] 	; rcipre le point


	movq mm1, mm0			; mm1: b || a
	punpcklbw mm1, mm7   ; mm1: 0'aa|0'ar||0'ag|0'ab
	punpckhbw mm0, mm7   ; mm0: 0'ba|0'br||0'bg|0'bb  

	movq mm4,mm2			; mm4: iVx || iVy
	psrlq mm4, 32+8		; mm4: 0'0|0'0||0'iVx|iVx'rVx
	movd edx,mm4
	mov eax,255
	and edx,0xFF			; edx: dx
	sub eax,edx				; eax: idx
	movd mm4,edx			; mm4: 0'0|0'0||0'0|0'dx
	punpcklwd mm4,mm4		; mm4: 0'0|0'0||0'dx|0'dx
	punpckldq mm4,mm4		; mm4: 0'dx|0'dx||0'dx|0'dx	
	movq mm6,mm4			; sauve mm4

	pmullw mm0,mm4			; mm0: ba*dx|br*dx||bg*dx|bb*dx

	movd mm4,eax			; mm4: 0'0|0'0||0'0|0'idx
	punpcklwd mm4,mm4		; mm2: 0'0|0'0||0'idx|0'idx
	punpckldq mm4,mm4		; mm2: 0'idx|0'idx||0'idx|0'idx

	pmullw mm1,mm4			; mm1: aa*idx|ar*idx||ag*idx|ab*idx

	paddusw mm0,mm1		; mm0: ba*dx+aa*idx|br*dx+ar*idx ||
								;		 bg*dx+ag*idx|bb*dx+ab*idx

	; fin
	psrlw mm0,8			; mm0 : 0'a|0'r||0'g|0'b
	packuswb mm0,mm0
	movq mm1,mm0


	
	; gre la transparence
	movd mm0,[ebp+40]
	movd mm4,[edi]
	psubusb mm1,mm0
	paddusb mm1,mm4
	movd [edi],mm1	

	add edi,4
	dec ecx
	jnz NEAR scanlp3
	
	pop ebx
	pop ecx	
	pop esi
	pop edi
	pop ebp
	ret


; void pix_filt(Uint32 *screen, Uint32 *pa, Uint32 *pc, int dx, int dy, int d2)

; 8  : screen  
; 12 : pa
; 16 : pc
; 20 : dx
; 24 : dy
; 28 : d2	:	 transparence
; 32 : 
; 36 : 
; 40 : 

align 16
	_FULL dd 0xFFFFFFFF,0xFFFFFFFF

mmx_pixfilt:
	push ebp
	mov ebp,esp
	push esi
	push edi
	push ebx
	
	; used: mm0, mm1, mm2, mm3, mm7, ebx, 

	mov esi, [ebp+12]
	movq mm0, [esi] 		; mm0: b || a

	pxor mm7,mm7	
	movq mm1, mm0			; mm1: b || a
	punpcklbw mm1, mm7   ; mm1: 0'aa|0'ar||0'ag|0'ab
	punpckhbw mm0, mm7   ; mm0: 0'ba|0'br||0'bg|0'bb  
	
	movd mm2,[ebp+20]		; mm2: 0'0|0'0||0'0|0'dx
	mov ebx,255
	sub bl,[ebp+20]		; bx: idx 
	punpcklwd mm2,mm2		; mm2: 0'0|0'0||0'dx|0'dx
	punpckldq mm2,mm2		; mm2: 0'dx|0'dx||0'dx|0'dx
	movq mm3,mm2			; sauve mm2

	pmullw mm0,mm2			; mm0: ba*dx|br*dx||bg*dx|bb*dx  

	movd mm2,ebx			; mm2: 0'0|0'0||0'0|0'idx
	punpcklwd mm2,mm2		; mm2: 0'0|0'0||0'idx|0'idx
	punpckldq mm2,mm2		; mm2: 0'idx|0'idx||0'idx|0'idx

	pmullw mm1,mm2			; mm1: aa*idx|ar*idx||ag*idx|ab*idx

	paddusw mm0,mm1			; mm0: ba*dx+aa*idx|br*dx+ar*idx ||
					;      bg*dx+ag*idx|bb*dx+ab*idx

	mov ebx,255
	sub bl,[ebp+24]		; bx: idy
	movd mm2,ebx			; mm2: 0'0|0'0||0'0|0'idy 
	punpcklwd mm2,mm2		; mm2: 0'0|0'0||0'idy|0'idy
	punpckldq mm2,mm2		; mm2: 0'idy|0'idy||0'idy|0'idy

	psrlw mm0,8
	pmullw mm0,mm2			; mm0: a1*idy|r1*idy||g1*idy|b1*idy

	; deuxime ligne

	mov esi,[ebp+16]
	movq mm1, [esi]		; mm1: d || c
	
	movq mm2,mm1			; mm2: d || c
	punpcklbw mm2, mm7	; mm2: 0'ca|0'cr||0'cg|0'cb
	punpckhbw mm1, mm7	; mm1: 0'da|0'dr||0'dg|0'db

	movd mm3,[ebp+20]		; mm3: 0'0|0'0||0'0|0'dx
	mov ebx,255
	sub bl,[ebp+20]		; bx: idx 
	punpcklwd mm3,mm3		; mm3: 0'0|0'0||0'dx|0'dx
	punpckldq mm3,mm3		; mm3: 0'dx|0'dx||0'dx|0'dx

	pmullw mm1,mm3			; mm1: da*dx|dr*dx||dg*dx|db*dx  

	movd mm3,ebx			; mm3: 0'0|0'0||0'dx|0'idx
	punpcklwd mm3,mm3		; mm3: 0'0|0'0||0'idx|0'idx
	punpckldq mm3,mm3		; mm3: 0'idx|0'idx||0'idx|0'idx

	pmullw mm2,mm3			; mm2: ca*idx|cr*idx||cg*idx|cb*idx

	paddusw mm1,mm2		; mm1: da*dx+ca*idx|dr*dx+cr*idx ||
								;		 dg*dx+cg*idx|db*dx+cb*idx

	movd mm3, [ebp+24]	; mm3: 0'0|0'0||0'0|0'dy
	punpcklwd mm3,mm3		; mm3: 0'0|0'0||0'dy|0'dy
	punpckldq mm3,mm3		; mm3: 0'dy|0'dy||0'dy|0'dy

	psrlw mm1,8
	pmullw mm1,mm3			; mm1: a2*dy|r2*dy||g2*dy|b2*dy

	paddusw mm0,mm1		; mm0: a|r||g|b

	psrlw mm0,8			; mm0 : 0'a|0'r||0'g|0'b
	packuswb mm0,mm0

	mov edi,[ebp+8]
	movd [edi],mm0

	pop ebx
	pop edi
	pop esi
	pop ebp
	ret

mmx_pixfilt_add:
	push ebp
	mov ebp,esp
	push esi
	push edi
	push ebx
	
	; used: mm0, mm1, mm2, mm3, mm7, ebx, 

	mov esi, [ebp+12]
	movq mm0, [esi] 	; mm0: b || a

	pxor mm7,mm7	
	movq mm1, mm0		; mm1: b || a
	punpcklbw mm1, mm7	; mm1: 0'aa|0'ar||0'ag|0'ab
	punpckhbw mm0, mm7	; mm0: 0'ba|0'br||0'bg|0'bb  
	
	movd mm2,[ebp+20]	; mm2: 0'0|0'0||0'0|0'dx
	mov ebx,255
	sub bl,[ebp+20]		; bx: idx 
	punpcklwd mm2,mm2	; mm2: 0'0|0'0||0'dx|0'dx
	punpckldq mm2,mm2	; mm2: 0'dx|0'dx||0'dx|0'dx
	movq mm3,mm2		; sauve mm2

	pmullw mm0,mm2		; mm0: ba*dx|br*dx||bg*dx|bb*dx  

	movd mm2,ebx		; mm2: 0'0|0'0||0'0|0'idx
	punpcklwd mm2,mm2	; mm2: 0'0|0'0||0'idx|0'idx
	punpckldq mm2,mm2	; mm2: 0'idx|0'idx||0'idx|0'idx

	pmullw mm1,mm2		; mm1: aa*idx|ar*idx||ag*idx|ab*idx

	paddusw mm0,mm1		; mm0: ba*dx+aa*idx|br*dx+ar*idx ||
				;      bg*dx+ag*idx|bb*dx+ab*idx

	mov ebx,255
	sub bl,[ebp+24]		; bx: idy
	movd mm2,ebx		; mm2: 0'0|0'0||0'0|0'idy 
	punpcklwd mm2,mm2	; mm2: 0'0|0'0||0'idy|0'idy
	punpckldq mm2,mm2	; mm2: 0'idy|0'idy||0'idy|0'idy

	psrlw mm0,8
	pmullw mm0,mm2		; mm0: a1*idy|r1*idy||g1*idy|b1*idy

	; deuxime ligne

	mov esi,[ebp+16]
	movq mm1, [esi]		; mm1: d || c
	
	movq mm2,mm1		; mm2: d || c
	punpcklbw mm2, mm7	; mm2: 0'ca|0'cr||0'cg|0'cb
	punpckhbw mm1, mm7	; mm1: 0'da|0'dr||0'dg|0'db

	movd mm3,[ebp+20]	; mm3: 0'0|0'0||0'0|0'dx
	mov ebx,255
	sub bl,[ebp+20]		; bx: idx 
	punpcklwd mm3,mm3	; mm3: 0'0|0'0||0'dx|0'dx
	punpckldq mm3,mm3	; mm3: 0'dx|0'dx||0'dx|0'dx

	pmullw mm1,mm3		; mm1: da*dx|dr*dx||dg*dx|db*dx  

	movd mm3,ebx		; mm3: 0'0|0'0||0'dx|0'idx
	punpcklwd mm3,mm3	; mm3: 0'0|0'0||0'idx|0'idx
	punpckldq mm3,mm3	; mm3: 0'idx|0'idx||0'idx|0'idx

	pmullw mm2,mm3		; mm2: ca*idx|cr*idx||cg*idx|cb*idx

	paddusw mm1,mm2		; mm1: da*dx+ca*idx|dr*dx+cr*idx ||
				; dg*dx+cg*idx|db*dx+cb*idx

	movd mm3, [ebp+24]	; mm3: 0'0|0'0||0'0|0'dy
	punpcklwd mm3,mm3	; mm3: 0'0|0'0||0'dy|0'dy
	punpckldq mm3,mm3	; mm3: 0'dy|0'dy||0'dy|0'dy

	psrlw mm1,8
	pmullw mm1,mm3		; mm1: a2*dy|r2*dy||g2*dy|b2*dy

	paddusw mm0,mm1		; mm0: a|r||g|b

	psrlw mm0,8		; mm0 : 0'a|0'r||0'g|0'b
	packuswb mm0,mm0

	
	;  s'occupe de la transparence
	mov edi,[ebp+8]
	movd mm1, [edi]		;  screen
	movd mm2, [ebp+28]	;  d2
	psubusb mm0,mm2

	paddusb mm1,mm0		;  ajoute couleur 
	;;  transparence mm1
	;;  normal mm0
	movd [edi],mm1

	pop ebx
	pop edi
	pop esi
	pop ebp
	ret
	
; end of 3D.asm
