#include "blend.h"
#include "SDL.h"

TBlender blender[] = {
  mmx_blend_rgba_to_rgba,
  mmx_blend_rgba_to_rgb,
  mmx_add_blend_rgba_to_rgb,
  mmx_add_blend_rgba_to_rgba
};

void mmxblend(void *src, int src_w, int src_h,
	      void *dst, int dst_w, int dst_h,
	      int sx, int sy, int dx, int dy,
	      int w, int h, int what, int a )
{
   if (sx < 0)
     {
	w += sx;
	dx -= sx;
	sx = 0;
     }
   if (sy < 0)
     {
	h += sy;
	dy -= sy;
	sy = 0;
     }
   if (dx < 0)
     {
	w += dx;
	sx -= dx;
	dx = 0;
     }
   if (dy < 0)
     {
	h += dy;
	sy -= dy;
	dy = 0;
     }
   if ((w <= 0) || (h <= 0))
      return;
   if ((sx + w) > src_w)
      w = src_w - sx;
   if ((sy + h) > src_h)
      h = src_h - sy;
   if ((dx + w) > dst_w)
      w = dst_w - dx;
   if ((dy + h) > dst_h)
      h = dst_h - dy;   
   if ((w <= 0) || (h <= 0))
      return;

   blender[what]((Uint32*)src + (sy * src_w) + sx, src_w, 
		 (Uint32*)dst + (dy * dst_w) + dx, dst_w, w, h, a );
}

