#include <string>
#include <stdio.h>
#include "conf.h"

/*
	tabsize: 4
	shiftwidth: 4
*/

DOTCONF_CB(FULL_SCREEN);
DOTCONF_CB(WHICH_PART);
DOTCONF_CB(TAVANCE);
DOTCONF_CB(SOUND);

static Conf* me;

static configoption_t options[] = {
  {"FULL_SCREEN", ARG_TOGGLE, FULL_SCREEN, NULL, 0},
  {"WHICH_PART", ARG_STR, WHICH_PART, NULL, 0}, // c'est naze, mais c'est historique...
  {"TAVANCE", ARG_INT, TAVANCE, NULL, 0},
  {"SOUND", ARG_INT, SOUND, NULL, 0},
  LAST_OPTION
};

DOTCONF_CB(SOUND)
{
  const int res = cmd->data.value;
  printf ("[SOUND] %d\n", res);
  me->setSND(res);
  return NULL;
}

DOTCONF_CB(TAVANCE)
{
  const int res = cmd->data.value;
  printf ("[TAVANCE] %d\n", res);
  me->setTA(res);
  return NULL;
}

DOTCONF_CB(FULL_SCREEN)
{
  const int res = cmd->data.value;
  printf ("[FULL_SCREEN] %ld\n", cmd->data.value);
  if (res)
    me->setFS(true);
  else 
    me->setFS(false);
  return NULL;
}

DOTCONF_CB(WHICH_PART)
{
  const string sWP = cmd->data.str;
  printf("[WHICH_PART] %s\n", cmd->data.str);
  me->setWP(sWP[0] - '0');
  return NULL;
}


// Constructeur du truc
//int main(int argc, char **argv)
Conf::Conf(char* chemin)
{
  me = this;
  configfile_t *configfile;

  FS = false;
  WP = 1;
  TAVANCE = 0;
  SND = false;

  printf("Reading the configuration with CASE_INSENSITIVE enabled\n");

  configfile = dotconf_create(chemin, options, 0, CASE_INSENSITIVE);
  if (dotconf_command_loop(configfile) == 0)
    fprintf(stderr, "Error reading config file\n");
  dotconf_cleanup(configfile);
}
