// plane

#include <stdio.h>
#include <stdlib.h>
#include <math.h>  
#include "effets.h"
#include "SDL.h"   
#include "SDL_image.h"

#define FOCAL 256

float cube_tex[] = 
{
	1, -1, -1,	// 1
	1,  1, -1,	// 2
 -1,  1, -1,	// 3
 -1, -1, -1,	// 4
  1, -1,  1,	// 5
	1,  1,  1,	// 6
 -1,  1,  1,	// 7
 -1, -1,  1 	// 8
};

int cube_pix[8*2];

int cube_tri[] = {
	1,2,3,
	3,4,1,
	5,6,2,
	2,1,5,
	8,7,6,
	6,5,8,
	4,3,7,
	7,8,4,
	5,1,4,
	4,8,5,
	2,6,7,
	7,3,2
};

int text_pos[] = {
	127,0, 		127,127, 			0,127,
	0,127, 	  0,0,          127,0
};

void line(Uint32 *screen, int xd, int yd, int xf, int yf, Uint32 col);

void swap (int &a, int &b)
{
	int c = a;
	a = b;
	b = c;
}

#define inf(a,b) a<b?a:b
#define sup(a,b) a>b?a:b

void aff_tri(Uint32 *dest, int ex1, int ey1, int ex2, int ey2, int ex3, 
				 int ey3, Uint32 col)
{
	int x1=ex1,x2=ex2,x3=ex3;
	int y1=ey1,y2=ey2,y3=ey3;
	int y,x;
	int offset,offset2;
	float dx1=0,dx2=0;
	float xg=0,xd=0;

	// on trie suivant Y
	if (y1>y2) { swap(y1,y2); swap(x1,x2); }
	if (y1>y3) { swap(y1,y3); swap(x1,x3); }
	if (y2>y3) { swap(y2,y3); swap(x2,x3); }

	// calcul du premier point
	offset = x1 + y1*640;
	offset2 = offset;

	// traverse sur premire partie

	if (y3==y1) {return;}
 	dx2 = (float) (x3-x1) / (float) (y3-y1);
	if (y2!=y1) {
  	dx1 = (float) (x2-x1) / (float) (y2-y1);
  	for (y=y1; y<y2; y++) {
  		for (x= 0; x<=fabs(xg-xd); x++) { 
  			dest[offset2++] = col;
  		}
  		offset += 640;
  		xg += dx1; xd += dx2;
  		offset2 = offset;
  		if (xg<xd) offset2 += (int) xg;
  		else offset2+=(int) xd;
  	}
	}
	else {
		if (x2<x1) {
			offset = x2 + 640 * y2;
			offset2 = offset;
			xd = x1 - x2;
		} else {
			xg = x2 - x1;
		}
	}
	// deuxime partie
	if (y3!=y2) {
  	dx1 = (float) (x3-x2) / (float) (y3-y2);
  	for (y=y2; y<=y3; y++) {
  		for (x= 0; x<= fabs(xd-xg); x++) { 
  			dest[offset2++] = col;	
  		}
  		offset += 640;
  		xg += dx1; xd += dx2;
  		offset2 = offset;
  		if (xg<xd) offset2 += (int) xg;
  		else offset2+= (int) xd;
  	}
	}
}

void aff_tri_text(Uint32 *dest, int ex1, int ey1, int ex2, int ey2, int ex3, 
				 int ey3, Uint32 *text, int tex1, int tey1, int tex2, int tey2, 
				 int tex3, int tey3)
{
	int x1=ex1,x2=ex2,x3=ex3;
	int y1=ey1,y2=ey2,y3=ey3;
	int tx1=tex1,tx2=tex2,tx3=tex3;
	int ty1=tey1,ty2=tey2,ty3=tey3;
	int y,x;
	int offset,offset2;
	float dx1=0,dx2=0;
	float xg=0,xd=0;

	// on trie suivant Y
	if (y1>y2) { swap(y1,y2); swap(x1,x2);swap(ty1,ty2); swap(tx1,tx2);}
	if (y1>y3) { swap(y1,y3); swap(x1,x3);swap(ty1,ty3); swap(tx1,tx3);}
	if (y2>y3) { swap(y2,y3); swap(x2,x3);swap(ty2,ty3); swap(tx2,tx3);}

	float dtxx = (float) ( (tx1-tx3)*(y2-y3) - (tx2-tx3)*(y1-y3) )
							/ (float) ( (x1-x3)*(y2-y3) - (x2-x3)*(y1-y3) );
	float dtxy = (float) ( (ty1-ty3)*(y2-y3) - (ty2-ty3)*(y1-y3) )
							/ (float) ( (x1-x3)*(y2-y3) - (x2-x3)*(y1-y3) );

	float fy3y2 = y3 - y2, fy3y1 = y3 - y1, fy2y1 = y2-y1, 
				fx3x2 = x3 - x2, fx3x1 = x3 - x1, fx2x1 = x2-x1;
				
	// calcul du premier point
	offset = x1 + y1*640;
	offset2 = offset;
	float tx = tx1, ty = ty1, txprime = tx, typrime = ty;

	// traverse sur premire partie

	if ((y3==y1)) {return;}
 	dx2 = fx3x1 / fy3y1;
 	float dtyx = (float) (tx3-tx1) / fy3y1;
  float dtyy = (float) (ty3-ty1) / fy3y1;

	Uint32 col=12;
	if (y2!=y1) {
   	if (fx3x1>fx2x1) { 
   		dtyx = (float) (tx2-tx1) / fy2y1;
  		dtyy = (float) (ty2-ty1) / fy2y1;
  	}
  	dx1 = fx2x1 / fy2y1;
  	for (y=y1; y<y2; y++) {
  		for (x= 0; x<=fabs(xg-xd); x++) { 
 		 		col = text[((int)tx&127) + ((int)ty&127)*128];
  			dest[offset2++] = col;
  			tx += dtxx;
  			ty += dtxy;
  		}
  		offset += 640;
			typrime += dtyy;
			txprime += dtyx;
			tx = txprime;
			ty = typrime;
  		xg += dx1; xd += dx2;
  		offset2 = offset;
  		if (xg<xd) offset2+=(int) xg;
  		else offset2+=(int) xd;
  	}
	}
	else {
		ty = ty2;
		if (x2<x1) {
			offset = x2 + 640 * y2;
			offset2 = offset;
			xd = x1 - x2;
			tx = tx2;
		} else {
			xg = x2 - x1;
			tx = tx1;
		}
		typrime = ty; txprime = tx;
	}
	// deuxime partie
	if (y3!=y2) {
   	if (fx2x1<fx3x1) { 
   		dtyx = (float) (tx3-tx2) / fy3y2;
  		dtyy = (float) (ty3-ty2) / fy3y2;
  	}
  	dx1 = fx3x2 / fy3y2;
  	for (y=y2; y<=y3; y++) {
  		for (x= 0; x<=fabs(xg-xd); x++) { 
 		 		col = text[((int)tx&127) + ((int)ty&127)*128];
  			dest[offset2++] = col;
  			tx += dtxx;
  			ty += dtxy;
  		}
  		offset += 640;
			typrime += dtyy;
			txprime += dtyx;
			tx = txprime;
			ty = typrime;
  		xg += dx1; xd += dx2;
  		offset2 = offset;
  		if (xg<xd) offset2+=(int) xg;
  		else offset2+=(int) xd;
		}
	}
}


int is_visible(int x1, int y1, int x2, int y2, 
							 int x3, int y3)
{
	int dx = x1 - x2;
	int dy = y1 - y2;
	int dX = x2 - x3;
	int dY = y2 - y3;
	int z;
	
	z = dx * dY - dX * dy;
	return (z>0);
}

static
inline void fillvect (float *vect, float x,float y,float z)
{
	*vect = x;
	*(vect+1) = y;
	*(vect+2) = z;
}

static
inline void normvect (double *vect, double *norm)
{
	double tmp_norm;
	tmp_norm = vect[0]*vect[0] + vect[1]*vect[1] + vect[2]*vect[2]; 
	*norm = sqrt(tmp_norm);
	tmp_norm = 1.0/(*norm);
	vect[0] *= tmp_norm; vect[1] *= tmp_norm; vect[2] *= tmp_norm;
}

static
inline void scal_vect (float scal, float *vect)
{
	vect[0] *= scal;
	vect[1] *= scal;
	vect[2] *= scal;
}


static
inline void rot_vect (float *rot, float *vect)
{
	float rx,ry,rz;
	ry = cos(rot[0])*vect[1] - sin(rot[0])*vect[2];
	rz = sin(rot[0])*vect[1] + cos(rot[0])*vect[2];

	rx = cos(rot[1])*vect[0] + sin(rot[1])*rz;
	vect[2] = cos(rot[1])*rz - sin(rot[1])*vect[0];

	vect[0] = cos(rot[2])*rx - sin(rot[2])*ry;
	vect[1] = sin(rot[2])*rx  + cos(rot[2])*ry;
}

static void puttexel(float *texel, Uint32 *dest, Uint32 color, int *pix)
{
	float x1,y1,z1;
	float fxe,fye;
	float invz1;
	int offset,xe,ye;
	x1 = texel[0];
	y1 = texel[1];
	z1 = texel[2] + 129 + 512; // on recentre ca
	
	invz1 = FOCAL/z1;
	fxe = x1*invz1;
	fye = y1*invz1;
	xe = (int) fxe + 320; ye = (int) fye + 240;
	if ((xe<640) && (ye<480) && (xe>=0) && (ye>=0)) {
		offset = xe + ye*640;
		pix[0] = xe; pix[1] = ye;
		//dest[offset] = color;
	}
}

void do_cube(Uint32 *dest, Uint32 *src, float a)
{
	int i,j;
	float *tex = cube_tex;
	float texel2[3*8], *texel=texel2;
	float rot[3];
	int *pix = cube_pix;
	int *tri = cube_tri;
	int x1,y1,x2,y2,x3,y3;

	rot[0] = a/2; rot[1] = a/2; rot[2] = a/2;

	// points
	for (i=0; i<8; i++) {
		for (j=0; j<3; j++) {texel[j] = tex[j];}
		scal_vect(128, texel);	// scale le vect
		rot_vect(rot, texel);  // rotationne le vecteur
		// texel[2] += 129 + 512;		// replace les z
		puttexel(texel, dest, 0xFFFFFF, pix);
		tex += 3; pix+=2; texel+=3;
	}
/*	// faces
	texel = texel2; pix=cube_pix; tri = cube_tri;
	for (i=0; i<12; i++) {
		x1 = pix[(tri[0]-1)*2]; y1 = pix[(tri[0]-1)*2+1];
		x2 = pix[(tri[1]-1)*2]; y2 = pix[(tri[1]-1)*2+1];
		x3 = pix[(tri[2]-1)*2]; y3 = pix[(tri[2]-1)*2+1];
		if (is_visible(x1, y1, x2, y2, x3, y3)) {
			Uint32 color=0x882255;
			if (i&1) color=0x552288;
			aff_tri(dest, x1-100, y1, x2-100, y2, x3-100, y3, color);
		}
		tri += 3;
	}
*/
	// lignes  ct
	texel = texel2; pix=cube_pix; tri = cube_tri;
	for (i=0; i<12; i++) {
		x1 = pix[(tri[0]-1)*2]; y1 = pix[(tri[0]-1)*2+1];
		x2 = pix[(tri[1]-1)*2]; y2 = pix[(tri[1]-1)*2+1];
		x3 = pix[(tri[2]-1)*2]; y3 = pix[(tri[2]-1)*2+1];
			line(dest, x1+100, y1, x2+100, y2, 0x228822);
			line(dest, x2+100, y2, x3+100, y3, 0x228822);
		tri += 3;
	}

	// faces + texture
	texel = texel2; pix=cube_pix; tri = cube_tri;
	for (i=0; i<12; i++) {
		x1 = pix[(tri[0]-1)*2]; y1 = pix[(tri[0]-1)*2+1];
		x2 = pix[(tri[1]-1)*2]; y2 = pix[(tri[1]-1)*2+1];
		x3 = pix[(tri[2]-1)*2]; y3 = pix[(tri[2]-1)*2+1];
		if (is_visible(x1, y1, x2, y2, x3, y3)) {
			Uint32 color=0x882255;
			if (i&1) color=0x552288;
//			aff_tri(dest, x1-100, y1, x2-100, y2, x3-100, y3, color);
			const int *t_pos = text_pos;
			int i6 = (i&1)*6;
			aff_tri_text(dest, x1-100, y1, x2-100, y2, x3-100, 
				 					 y3, src, 	t_pos[i6],t_pos[i6+1], 
															t_pos[i6+2],t_pos[i6+3], 
															t_pos[i6+4],t_pos[i6+5]);
		}
		tri += 3;
	}
}

void cube(SDL_Event &event, SDL_Surface *screen)
{
	SDL_Surface *texture,*texture2;
  Uint32 *buffer,*src;
	int done=0;
	float a = 0;

  // on charge l'image
  texture = IMG_Load (PATH_2D "test2.png"); testload (texture);
  // on la fout dans un buffer
  texture2 = SDL_CreateRGBSurface (SDL_SWSURFACE, 128, 128, 32,0xFF0000,
															 0xFF00, 0xFF,0xFF000000);
  SDL_BlitSurface (texture,NULL, texture2, NULL);

  /* Wait for a keystroke */
  while ( !done ) {
    /* Check for events */
    while ( SDL_PollEvent(&event) ) {
      switch (event.type) {
        case SDL_KEYDOWN:  
          /* Any key press quits the app... */
          done = 1;
          break;   
        case SDL_QUIT:
          done = 1;   
          break;      
        default:      
          break;      
      }
    }
    LOCK_SURFACE (screen);
    LOCK_SURFACE (texture2);
    buffer=(Uint32 *) screen->pixels;
    src = (Uint32 *) texture2->pixels;
		a += 0.1;
	 	do_cube (buffer,src,a);
   	UNLOCK_SURFACE (texture2);
    UNLOCK_SURFACE (screen);
    SDL_UpdateRect(screen, 0, 0, 0, 0);
    SDL_FillRect(screen, NULL, 0);
  } 
}   

/* *************************************************************************
 	 ************************************************************************* */

/*void swap(int &a, int &b)
{
  int t;
  t=a;
  a=b;
  b=t;
}*/

void line(Uint32 *screen, int xd, int yd, int xf, int yf, Uint32 col)
{
  int x,y,delta, index, off;
  int xx, yy;

  if (abs(xf-xd) > abs(yf-yd))
  {
  if (xd > xf) {swap(xd, xf);
               swap(yd, yf);}
  
  if (yf-yd == 0)
    { off=yd*640+xd;
    for (x=xd; x < xf; x++)
    {
      if ((x > 0) && (x < 640) && (yd > 0) && (yd < 480))
          *(screen+off)=col;
      off++;
    }
     
    }
  else {
  delta=(yf-yd)*256/(xf-xd);
  index=yd*256;
  for (x=xd; x<xf; x++)
    {   yy=(index / 256);
        off=yy*640+x;
                if ((x > 0) && (x < 640) && (yy > 0) && (yy < 480))
               *(screen+off)=col;
       index+=delta;       
    }
  }  
  }  
     
     
  if (abs(xf-xd) <= abs(yf-yd))
  {
  if (yd > yf) {swap(xd, xf);
               swap(yd, yf);}

  if (xf-xd == 0)
  { off=yd*640+xd;
      for (y=yd; y< yf; y++)
      {
        if ((xd > 0) && (xd < 640) && (y > 0) && (y < 480))
            *(screen+off)=col;
        off+=640;
      }
  }
  else {
  delta=(xf-xd)*256/(yf-yd);
  index=xd*256;
  xx=xd;
  for (y=yd; y<yf; y++)
    {     xx=index/256; 
          off= xx+y*640; 
                if ((xx > 0) && (xx < 640) && (y > 0) && (y < 480))
            *(screen+off)=col;
       index+=delta;         
    }
  }  
  }  
}    

void tpix(Uint32 *dest, Uint32 color)
{
	Uint32 old=*dest;
	*dest = ( ( ( (old&BMASK) + (color&BMASK) ) / 2 )&BMASK ) +
					( ( ( (old&GMASK) + (color&GMASK) ) / 2 )&GMASK ) +
					( ( ( (old&RMASK) + (color&RMASK) ) / 2 )&RMASK );

}

void line2(Uint32 *screen, int xd, int yd, int xf, int yf, Uint32 col)
{
  int x,y,delta, index, off;
  int xx, yy;

  if (abs(xf-xd) > abs(yf-yd))
  {
  if (xd > xf) {swap(xd, xf);
               swap(yd, yf);}
  
  if (yf-yd == 0)
    { off=yd*640+xd;
    for (x=xd; x < xf; x++)
    {
      if ((x > 0) && (x < 640) && (yd > 0) && (yd < 480))
          tpix(screen+off, col);
      off++;
    }
     
    }
  else {
  delta=(yf-yd)*256/(xf-xd);
  index=yd*256;
  for (x=xd; x<xf; x++)
    {   yy=(index / 256);
        off=yy*640+x;
                if ((x > 0) && (x < 640) && (yy > 0) && (yy < 480))
                tpix(screen+off,col);
       index+=delta;       
    }
  }  
  }  
     
     
  if (abs(xf-xd) <= abs(yf-yd))
  {
  if (yd > yf) {swap(xd, xf);
               swap(yd, yf);}

  if (xf-xd == 0)
  { off=yd*640+xd;
      for (y=yd; y< yf; y++)
      {
        if ((xd > 0) && (xd < 640) && (y > 0) && (y < 480))
            tpix(screen+off,col);
        off+=640;
      }
  }
  else {
  delta=(xf-xd)*256/(yf-yd);
  index=xd*256;
  xx=xd;
  for (y=yd; y<yf; y++)
    {     xx=index/256; 
          off= xx+y*640; 
                if ((xx > 0) && (xx < 640) && (y > 0) && (y < 480))
            tpix(screen+off,col);
       index+=delta;         
    }
  }  
  }  
}    


