// Moteur 3d de Ced

#include <vector>
#include <iostream>

#include <stdlib.h>
#include "effets.h"
#include "Render.h"
#include "lib3ds/material.h"
#include "Object.h"
#include "3DPath.h"

// Constructeur
diapofin::diapofin(Render *rd)
{
	launchtime = 0;
	this->rd = rd;
	sprite1 = rd->bind("smg1.jpg");
	sprite2 = rd->bind("smg2.png");
	sprite3 = rd->bind("smg3.png");
	sprite4 = rd->bind("smg3b.png");
	sprite5 = rd->bind("smg4.png");
	sprite6 = rd->bind("end.jpg");
	
}

// Destructeur
diapofin::~diapofin() { }

static inline Uint32 cmerge(const int src, const int dst, const int ALPHA)
{
        const int ret = ( src*(ALPHA) + dst*(255-ALPHA) ) >> 8;
        //assert (ret >= 0 && ret <= 255);        // to be removed
        return ret;
}

static void LowDrawAlpha(Uint32 *screen, Uint32 *soff,
						 const int ycount, const int xcount)
{
	for (int y=0; y<ycount; y++) {
		for (int x=0; x<xcount; x++) {
			const Uint32 sc = *soff;    // image (source)
			const Uint32 dc = *screen;                // screen (dest)
			Uint32 Rsc = (sc&RMASK) >> RSHFT; Uint32 Gsc = (sc&GMASK) >> GSHFT; 
			Uint32 Bsc = (sc&BMASK) >> BSHFT; 
			const Uint32 ALPHA = (sc&AMASK) >> ASHFT;
			
			Uint32 Rdc = (dc&RMASK) >> RSHFT; Uint32 Gdc = (dc&GMASK) >> GSHFT; 
			Uint32 Bdc = (dc&BMASK) >> BSHFT; 
			
			Uint32 Rfc = cmerge(Rsc, Rdc, ALPHA)<<RSHFT;
			Uint32 Gfc = cmerge(Gsc, Gdc, ALPHA)<<GSHFT;
			Uint32 Bfc = cmerge(Bsc, Bdc, ALPHA)<<BSHFT;
			
			const Uint32 ColorFinal = Rfc + Gfc + Bfc;
			
			*screen = ColorFinal;
			screen++; soff++;
		}
	}
}

// Calcule les coordonnes camera/objets et affichage
void diapofin::go(Uint32 *screen, Uint32 time)
{
	if(!launchtime)launchtime=time;
	Uint32 delta = time-launchtime;

	SDL_Surface *s1 = rd->getTexture(sprite1);
	SDL_Surface *s2 = rd->getTexture(sprite2);
	SDL_Surface *s3 = rd->getTexture(sprite3);
	SDL_Surface *s4 = rd->getTexture(sprite4);
	SDL_Surface *s5 = rd->getTexture(sprite5);
	SDL_Surface *s6 = rd->getTexture(sprite6);

	mmx_quadcpy(s1->pixels,screen,640*480/2);
	
	//LowDrawAlpha(screen, (Uint32*)s1->pixels, 480, 640);

	if( delta>400 && delta<1600) //question apparait
		LowDrawAlpha(screen, (Uint32*)s2->pixels, 480, 640);

	//clignotement
	else if( (delta>1600 && delta<1800) ||
			 (delta>2000 && delta<2200) ||
			 (delta>2400 && delta<2600) )
		mmx_quadcpy(s3->pixels,screen,640*480/2);

	//la vrit apparait !
	else if (delta>2800 && delta<3500)
		LowDrawAlpha(screen, (Uint32*)s4->pixels, 480, 640);

	//une conclusion s'impose
	else if (delta>3500 && delta<4000)
		LowDrawAlpha(screen, (Uint32*)s5->pixels, 480, 640);

	else if (delta>4000)
		mmx_quadcpy(s6->pixels,screen,640*480/2);
	
	asm_emms();
}
