// nova
// 


#include "effets.h"
#include "effet2.h"

t_spoke 	pvals = {
  64,  // que des nombres multiples de 2 !
  20,
  320,240,
  //{0xFF,0x10,0x20, 0} // blue green red alpha
  {0x80,0x10,0xFF, 0} // blue green red alpha
};


static inline 
float gauss ()
{
  const float taille = 6;
  int i;
  float sum = 0;
  for (i=0; i<taille; i++) {
    sum += (float) rand()/ (float) RAND_MAX;
  }
  return sum/taille;
}

static inline
void plot (Uint8 *src, int ratio, int compl_ratio, Uint8 *pvalscolor,
	   int c, Uint8 *dest)
{
  int i;
  int color;
  for (i=0; i<3 ; i++) {
    color = (src[i]*compl_ratio + pvalscolor[i]*ratio)>>8;
    color += c;
    dest[i] = (Uint8) CLAMP (color,0,255);
  }
}


Nova::Nova()
{

  const float INV2PI = 1 / (2 * M_PI); // on inverse le 2PI
  int i,x,y,u,v;
  float dist,angle;
  //float a = -M_PI;

  // on met les piques
  for (int j=0; j<8; j++) {
    tspoke[j] = new int[pvals.nspoke];
    for (i=0; i<pvals.nspoke; i++) {
      tspoke[j][i] = ( (int)  (65535.0 * gauss())>>8 ) & (0xFF);
    }
  }
  tmpspoke = new int[pvals.nspoke];

  // calcule de la table de distance et d'angle
  i = 0;
  for (y=0; y<480; y+=1) {
    for (x=0; x<640; x+=1) {
      u = (x - pvals.xc);
      v = (y - pvals.yc);
      dist = sqrt (u*u + v*v);
      if (dist != 0) {
	dist = (float) (65535/2) / dist;
      } else {
	dist = 65535/2;
      }
      angle = (atan2  (u,v) * INV2PI + .51) * pvals.nspoke * 65536;
      dist_tab[i] =  (int) dist;
      angle_tab[i] =  (int) angle;
      i++;
    }
  }

  // on charge l'image
  SDL_Surface *image;
  image = IMG_Load (PATH_2D "invoc/invoc0.jpg"); testload (image);

  // on la fout dans un buffer
  img2 = SDL_CreateRGBSurface (SDL_SWSURFACE, 640, 480, 32,0xFF0000, 
			       0xFF00, 0xFF,0xFF000000);
  SDL_BlitSurface (image,NULL, img2, NULL);
  SDL_FreeSurface(image);
  tinvoc[0] = img2;

  image = IMG_Load (PATH_2D "invoc/invoc1.jpg"); testload (image);

  // on la fout dans un buffer
  img2 = SDL_CreateRGBSurface (SDL_SWSURFACE, 640, 480, 32,0xFF0000, 
			       0xFF00, 0xFF,0xFF000000);
  SDL_BlitSurface (image,NULL, img2, NULL);
  SDL_FreeSurface(image);
  tinvoc[1] = img2;

  image = IMG_Load (PATH_2D "invoc/invoc2.jpg"); testload (image);

  // on la fout dans un buffer
  img2 = SDL_CreateRGBSurface (SDL_SWSURFACE, 640, 480, 32,0xFF0000, 
			       0xFF00, 0xFF,0xFF000000);
  SDL_BlitSurface (image,NULL, img2, NULL);
  SDL_FreeSurface(image);
  tinvoc[2] = img2;

  image = IMG_Load (PATH_2D "invoc/invoc3.jpg"); testload (image);

  // on la fout dans un buffer
  img2 = SDL_CreateRGBSurface (SDL_SWSURFACE, 640, 480, 32,0xFF0000, 
			       0xFF00, 0xFF,0xFF000000);
  SDL_BlitSurface (image,NULL, img2, NULL);
  SDL_FreeSurface(image);
  tinvoc[3] = img2;

  trans = SDL_CreateRGBSurface (SDL_SWSURFACE, 640, 480, 32,0xFF0000, 
				0xFF00, 0xFF,0xFF000000);
}

Nova::~Nova()
{
  for (int i=0; i<8; i++) { 
    delete[] tspoke[i];
  }
  delete[] tmpspoke;
  //SDL_FreeSurface(img2);
  for (int i=0; i<4; i++) {
    SDL_FreeSurface(tinvoc[i]);
  }
  SDL_FreeSurface(trans);
}

void Nova::go(Uint32 *buffer, int time)
{
  const int DUREE = 2000;
  int td;
  if (time<DUREE) {
    td = 0;
  }
  else {
    td = ( (time/DUREE)%3 ) + 1;
  }
  int td2 = ((td+1)%3)+1;

  int dt = ( (time%DUREE )*256 ) / DUREE;
  int idt = (255 - dt);

  for (int i=0; i<640*480; i++) {
    Uint32 *p1 = (Uint32 *) tinvoc[td]->pixels;
    Uint32 *p2 = (Uint32 *) tinvoc[td2]->pixels;
    Uint32 *dest = (Uint32 *) trans->pixels;
    dest[i] = 
      (((dt* (p1[i]&BMASK) + idt* (p2[i]&BMASK) ) >> 8 )&BMASK) +
      (((dt* (p1[i]&GMASK) + idt* (p2[i]&GMASK) ) >> 8 )&GMASK) + 
      (((dt* (p1[i]&RMASK) + idt* (p2[i]&RMASK) ) >> 8 )&RMASK);
  }
  

  img2 = trans;
  LOCK_SURFACE (img2);
  Uint32 *src = (Uint32 *) img2->pixels;
  // on commence l'effet de la mort !
  const float T = CLAMP((float)time*0.001, 0, 20*M_PI/21);
  pvals.radius =  20*sin(T); //(sin(time*0.005)*20);
  do2 (buffer, src, time);
  UNLOCK_SURFACE (img2);
}

void Nova::do2(Uint32 *buffer, Uint32 *src, int time)
{
  const int DUREE = 1000;
  // int xc = pvals.xc, yc = pvals.yc;
  int toff = (time/DUREE)&7;
  int dt = ((time%DUREE)*256)/DUREE;

  for (int i=0; i<pvals.nspoke; i++) {
    tmpspoke[i] = (tspoke[toff][i]*(256-dt) + 
		   tspoke[(toff+1)&7][i]*dt) >> 8;
  }

  int *spoke = tmpspoke;
  int mask_nspoke = pvals.nspoke-1;
  Uint32 *dest = buffer;
  
  mmx_plot (src, pvals.color, dest, dist_tab, pvals.radius,
	    angle_tab, mask_nspoke, spoke );
  asm_emms();
}
