#include "effets.h"

void f_printvector( fVector v )
{
        printf("v [ %f, %f, %f ]\n", v[0], v[1], v[2] );
}

void f_make_vector(fVector v, float x, float y, float z)
{
    *v++ = x;
    *v++ = y;
    *v   = z;
}

void f_VectCopy(fVector sv, fVector dv)
{
    memcpy(dv, sv, 12);
}

void f_VectAdd(fVector v1, fVector v2, fVector dv)
{
    *dv++ = v1[VECT_X] + v2[VECT_X];
    *dv++ = v1[VECT_Y] + v2[VECT_Y];
    *dv   = v1[VECT_Z] + v2[VECT_Z];
}

void f_VectSub(fVector v1, fVector v2, fVector dv)
{
    *dv++ = v1[VECT_X] - v2[VECT_X];
    *dv++ = v1[VECT_Y] - v2[VECT_Y];
    *dv   = v1[VECT_Z] - v2[VECT_Z];
}

float f_VectLen(fVector v)
{
    return sqrt(((*v) * (*v)) + (v[1] * v[1]) + (v[2] * v[2]));
}

float f_VectLen_2(fVector v)
{
    return (((*v) * (*v)) + (v[1] * v[1]) + (v[2] * v[2]));
}

//distance between 2 vectors
float f_VectDist(fVector v1, fVector v2)
{
  return sqrt( ( ((*v1) - (*v2)) * ((*v1) - (*v2)) ) +
               ( (v1[1] - v2[1]) * (v1[1] - v2[1]) ) +
               ( (v1[2] - v2[2]) * (v1[2] - v2[2]) ) );
}
float f_VectDist_2(fVector v1, fVector v2)
{
    return ( ( ((*v1) - (*v2)) * ((*v1) - (*v2)) ) +
             ( (v1[1] - v2[1]) * (v1[1] - v2[1]) ) +
             ( (v1[2] - v2[2]) * (v1[2] - v2[2]) ) );
}

void f_ScaleVect(fVector v, float factor)
{
    *v++ = (*v) * factor;
    *v++ = (*v) * factor;
    *v   = (*v) * factor;
}

void f_NormalizeVect(fVector v)
{
    float factor;

    factor = 1 / f_VectLen(v);

    *v++ = (*v) * factor;
    *v++ = (*v) * factor;
    *v   = (*v) * factor;
}

float f_DotProduct(fVector v1, fVector v2)
{
    return ( (v1[VECT_X] * v2[VECT_X]) +
             (v1[VECT_Y] * v2[VECT_Y]) +
             (v1[VECT_Z] * v2[VECT_Z]) );
}

void f_CrossProduct(fVector v1, fVector v2, fVector dv)
{
    *dv++ = (v1[VECT_Y] * v2[VECT_Z]) - (v1[VECT_Z] * v2[VECT_Y]);
    *dv++ = (v1[VECT_Z] * v2[VECT_X]) - (v1[VECT_X] * v2[VECT_Z]);
    *dv   = (v1[VECT_X] * v2[VECT_Y]) - (v1[VECT_Y] * v2[VECT_X]);
}

float f_CrossZProduct(fVector v1, fVector v2)
{
    return ((*v1) * v2[VECT_Y]) - (v1[VECT_Y] * (*v2));
}

/* Vectors Int */

/* 16:16 */
void fulliVector(iVector dst, fVector src)
{
  dst[0] = (int) ( src[0] * 16 ) &255;
  dst[1] = (int) ( src[1] * 16 ) &255;
  dst[2] = (int) ( src[2]  ) ;

  dst[0] *= 65536 ;
  dst[1] *= 65536 ;
  dst[2] *= 65536 ;
}
