// face

#include "effets.h"

Face::Face()
{
	SDL_Surface *facetmp;
	facetmp = IMG_Load (PATH_2D "face1.png"); testload (facetmp);
	W = facetmp->w;
	H = facetmp->h;
	face = SDL_CreateRGBSurface (SDL_SWSURFACE, W, H, 32,0xFF0000,
                               0xFF00, 0xFF,0xFF000000);
  SDL_BlitSurface (facetmp,NULL, face, NULL);
	SDL_FreeSurface (facetmp);

	facetmp = IMG_Load (PATH_2D "face2.png"); testload (facetmp);		
	face2 = SDL_CreateRGBSurface (SDL_SWSURFACE, W, H, 32,0xFF0000,
                               0xFF00, 0xFF,0xFF000000);

  SDL_BlitSurface (facetmp,NULL, face2, NULL);
	SDL_FreeSurface (facetmp);	
	
}



Face::~Face()
{
	SDL_FreeSurface(face);
}

void zoom(Uint32 *src, Uint32 *dst, int SW, int DW,
					int sx1, int sx2, int dx1, int dx2, 
					int sy1, int sy2, int dy1, int dy2)
{

	int dx = ( (sx2-sx1) <<8)/ (dx2-dx1);
	int dy = ( (sy2-sy1) <<8)/ (dy2-dy1);

	int X=0, Y=0;

	for (int y=dy1; y<dy2; y++) {	
		X = 0;
		for (int x=dx1; x<dx2; x++) {
			dst[x+y*DW] = src[ (X>>8) + (Y>>8)*SW];
			X += dx;
		}
		Y += dy;
	}
}

void Face::go(Uint32 *buffer, int time, int time2, int type)
{
	LOCK_SURFACE(face);
	LOCK_SURFACE(face2);

	Uint32 *src = (Uint32 *)face->pixels;
	Uint32 *src2= (Uint32 *)face2->pixels;

	int soff = 0, doff=640-W, doff2=0;;

	int MASK = time/2;
	MASK = 255 - CLAMP(MASK,0,255);
	MASK = MASK | (MASK<<8) | (MASK<<16);

	int MASK2 = time2/2;
	MASK2 = 255 - CLAMP(MASK2,0,255);
	MASK2 = MASK2 | (MASK2<<8) | (MASK2<<16);

	for (int y=0; y<480; y++) {
		mmx_addcol (src, buffer+doff2, (640-W)/2, MASK );
		mmx_addcol (src+soff, buffer+doff, W/2, MASK);
		if (type==1) {
			mmx_addcol (src2+soff, buffer+doff, W/2, MASK2);
		}
		
		soff += W; doff+=640; doff2+=640;
	}
	asm_emms();
	UNLOCK_SURFACE(face);	
	UNLOCK_SURFACE(face2);
}

void Face::go2(Uint32 *buffer, Uint32 time, const Uint32 duree)
{
  const Uint32 T1 = duree/6;
  const int PIC1 = 255;     
  const int PIC2 = 128;      const int RPIC2 = 512;
  const int PIC3 = 0;        const int RPIC3 = 0;
  if (time<T1) {
    go(buffer,(time*PIC1)/T1,0);
  } else {
    if (time<2*T1) {
      int t2 = time-T1;
      go(buffer, PIC1 - (t2*(255-PIC2))/T1, (t2*RPIC2)/T1, 1);
    } else {
      int t2 = time-2*T1;
      go(buffer, PIC2 - (t2*(255-PIC3))/T1, 
	 RPIC2 - (t2*(255-RPIC3))/T1, 1);
    }
  }
}

void Face::go3(Uint32 *buffer, Uint32 time, const Uint32 duree)
{
  const Uint32 T1 = duree/4;
  const int PIC1 = 256;
  const int PIC2 = 0;        const int RPIC2 = 256;
  const int PIC3 = 0;        const int RPIC3 = 0;
  if (time<T1) {
    go(buffer,(time*PIC1)/T1,0);
  } else {
    if (time<2*T1) {
      int t2 = time-T1;
      go(buffer, PIC1 - (t2*(255-PIC2))/T1, (t2*RPIC2)/T1, 1);
    } else {
      int t2 = time-2*T1;
      go(buffer, 128 - (t2*(255-PIC3))/T1, 
	 RPIC2 - (t2*(255-RPIC3))/T1, 1);
    }
  }
}

void Face::go5(Uint32 *buffer, Uint32 time)
{
	if (time<512) {
		go(buffer,time,0);
	} else {
		if (time<2048) {
			int t2 = time-1024;
			go(buffer, 1024-t2/4, t2, 1);
		} else {
			int t2 = time-2048;
			go(buffer, 512-t2/16, 1024-t2/4, 1);
		}
	}
}


// debut
void Face::go4(Uint32 *buffer, Uint32 time)
{
		if (time<28000) {
			if ( (time>10000) && (time<10000+500) ) {
				int t3 = time - 10000;
				go(buffer, t3/3,0);
			}
			if ( (time>10500) && (time<10500+500) ) {
				int t3 = time - 10500;
				go(buffer,500/3 - t3/3,0);
			}

			if ( (time>16200) && (time<16200+500) ) {
				int t3 = time - 16200;
				go(buffer, t3/5,0);
			}
			if ( (time>16700) && (time<16700+500) ) {
				int t3 = time - 16700;
				go(buffer,500/5 - t3/5,0);
			}

			if ( (time>22200) && (time<22200+500) ) {
				int t3 = time - 22200;
				go(buffer, t3/5,0);
			}
			if ( (time>22700) && (time<22700+500) ) {
				int t3 = time - 22700;
				go(buffer,500/5 - t3/5,0);
			}			
			
			go(buffer,(int) (time*0.005),0);
		} else {
			int time2=time-28000;
			go(buffer, (int) ( 28000*0.005 - time2 * 0.05 ),0);
		}
}



// endof face.cc
