// Moteur 3d de Ced

#include <vector>
#include <iostream>

#include <stdlib.h>
#include "effets.h"
#include "Render.h"
#include "lib3ds/material.h"
#include "Object.h"
#include "3DPath.h"

static fVector f_pos[4] = {{-128, 128, 0},
						   { 128, 128, 0},
						   { 128,-128, 0},
						   {-128,-128, 0}};
static fVector f_tex[4] = {{ 0.0, 0.0, 0.0},
						   { 1.0, 0.0, 0.0},
						   { 1.0, 1.0, 0.0},
						   { 0.0, 1.0, 0.0}};

// Constructeur
fantomes::fantomes(Render *rd)
{
	this->rd = rd;
	sprite1 = rd->bind("ghost1.jpg");
	sprite2 = rd->bind("ghost2.jpg");
}

// Destructeur
fantomes::~fantomes() { }
static inline Uint32 cmerge(const int src, const int dst, const int ALPHA)
{
        const int ret = ( src*(ALPHA) + dst*(255-ALPHA) ) >> 8;
        //assert (ret >= 0 && ret <= 255);        // to be removed
        return ret;
}

static void LowDrawAlpha(Uint32 *screen, Uint32 *soff,
						 const int ycount, const int xcount,
						 int xsadd, int xdadd)
{
	for (int y=0; y<ycount; y++) {
		for (int x=0; x<xcount; x++) {
			const Uint32 sc = *soff;    // image (source)
			const Uint32 dc = *screen;                // screen (dest)
			Uint32 Rsc = (sc&RMASK) >> RSHFT; Uint32 Gsc = (sc&GMASK) >> GSHFT; 
			Uint32 Bsc = (sc&BMASK) >> BSHFT; 
			const Uint32 ALPHA = (sc&AMASK) >> ASHFT;
			
			Uint32 Rdc = (dc&RMASK) >> RSHFT; Uint32 Gdc = (dc&GMASK) >> GSHFT; 
			Uint32 Bdc = (dc&BMASK) >> BSHFT; 
			
			Uint32 Rfc = cmerge(Rsc, Rdc, ALPHA)<<RSHFT;
			Uint32 Gfc = cmerge(Gsc, Gdc, ALPHA)<<GSHFT;
			Uint32 Bfc = cmerge(Bsc, Bdc, ALPHA)<<BSHFT;
			
			const Uint32 ColorFinal = Rfc + Gfc + Bfc;
			
			*screen = ColorFinal;
			screen++; soff++;
		}
		screen+=xdadd;
		soff+=xsadd;
	}
}

// Calcule les coordonnes camera/objets et affichage
void fantomes::go(Uint32 *screen, Uint32 time)
{
	rd->push_matrix();
	{
		//rd->rotate(((float)time)*M_PI,0.0,0.0);
		//rd->scale(2,2,2);
		rd->translate(0.0,0.0,1000.0);
		rd->push(4, f_pos, f_tex, sprite1, TRANSPARENCY);
		rd->translate(500.0,0.0,0.0);
		rd->push(4, f_pos, f_tex, sprite2, TRANSPARENCY);
	}
	rd->pop_matrix();
	//LowDrawAlpha(screen, (Uint32*)(sarah->pixels), 480, 640);
}
