// Moteur 3d de Ced

#include <vector>
#include <iostream>

#include <stdlib.h>
#include "effets.h"
#include "Render.h"
#include "Object.h"
#include "3DPath.h"

static fVector fb_pos[4] = {{-128, 128, 0},
							{ 128, 128, 0},
							{ 128,-128, 0},
							{-128,-128, 0}};
static fVector fb_tex[4] = {{ 0.0, 0.0, 0.0},
							{ 1.0, 0.0, 0.0},
							{ 1.0, 1.0, 0.0},
							{ 0.0, 1.0, 0.0}};

// Constructeur
fireball::fireball(Render *rd)
{
	this->rd = rd;
	//scrollpix = rd->bind("fireball.png");
	sprite = rd->bind("iceball.png");
	lastcall = 0;
}

// Destructeur
fireball::~fireball() {}

// Calcule les coordonnes camera/objets et affichage
void fireball::go(Uint32 *screen, Uint32 time)
{
	const float dep_x = 0;
	const float dep_y = 0;
	const float dep_z = 5000;
	
	if( rand()%500 < time-lastcall ) make(time,700);
	lastcall = time;
	
	for( Uint32 i=0; i<stars.size(); i++) {

		Uint32 delta = time-stars[i].born;
		Uint32 dietime = stars[i].born+stars[i].life;

		float d = (float)(time - stars[i].born)/(float)stars[i].life;
		if(d>1.0) d=1.0;

		//TODO: utiliser d pour interpoler le depart et l'arrivee
		
		rd->push_matrix();
		rd->translate(dep_x + (stars[i].decalx-dep_x)*d,
					  dep_y + (stars[i].decaly-dep_y)*d,
					  dep_z + (stars[i].decalz-dep_z)*d);
		//cout << "rd->translate(" << dep_x*(1.0-d)+stars[i].decalx*d << ", " << dep_y*(1.0-d)+stars[i].decaly*d <<endl;

		rd->rotate( (float)time/(float)stars[i].rot,
					(float)time/(float)stars[i].rot,  0.0);

		//rd->scale(2,2,2);
		
		rd->push_matrix();
		if(time>dietime) rd->scale((time-dietime)/50.0, 1.0/(((time-dietime)/500.0)+1), 1.0);
		rd->push(4, fb_pos, fb_tex, sprite, TRANSPARENCY);
		rd->pop_matrix();
		
		rd->push_matrix();
		rd->rotate(0.0, M_PI/2.0, 0.0);
		if(time>dietime) rd->scale((time-dietime)/50.0, 1.0/(((time-dietime)/500.0)+1), 1.0);
		rd->push(4, fb_pos, fb_tex, sprite, TRANSPARENCY);
		rd->pop_matrix();
		
		rd->push_matrix();
		rd->rotate(0.0, 0.0, M_PI/2.0);
		if(time>dietime) rd->scale((time-dietime)/50.0, 1.0/(((time-dietime)/500.0)+1), 1.0);
		rd->push(4, fb_pos, fb_tex, sprite, TRANSPARENCY);
		rd->pop_matrix();
		
		rd->pop_matrix();
	}
}

void fireball::make(Uint32 time, Uint32 life)
{
	info ball;
	ball.life = life;
	ball.born = time;
	ball.decalx = -(rand()%500+700);
	ball.decaly = -(rand()%500+500);
	ball.decalz =  (rand()%500+700);
	ball.rot = rand()%200+300;
	stars.push_back(ball);
}

