; 2/3 fonctions en asm

BITS 32

global mmx_blur
global asm_plot
global mmx_plot
global asm_emms
global mmx_scroll
global mmx_scroll2
global mmx_scroll3
global mmx_quadcpy
global mmx_sat
global mmx_blur2
global mmx_quadnegsub
global mmx_quaddel
global mmx_addcol
global mmx_lettre


%define SRC [ebp + 8]
%define PVALSCOLOR [ebp + 12]
%define DEST [ebp + 16]
%define DIST_TAB [ebp + 20]
%define PVALSRADIUS [ebp + 24]
%define ANGLE_TAB [ebp + 28]
%define MASK_NSPOKE [ebp + 32]
%define SPOKE [ebp + 36]
mmx_plot:
	push ebp
	mov ebp, esp
	push esi
	push edi

	mov ecx,640*480*4
	main_mmx_loop:

	; calcul de w1
	mov eax,ecx
	add eax, ANGLE_TAB
	movd mm0,[eax]		  ; mm0 : angle_tab[offset]
	movq mm1,mm0
	psrad mm1,16
	movd mm2, MASK_NSPOKE ; mm2 : mask_nspoke
	pand mm1,mm2		 ; mm1 : i = (angle_tab[offset]>>16])&mask_nspoke
	mov eax,65535
	movd mm3,eax
	pand mm0,mm3
	psrad mm0,8			 ; mm0 : bof
	mov eax,255
	movd mm5, eax
	psubd mm5,mm0		 ; mm5 : 255-bof
	movq mm3, mm1
	mov eax,1
	movd mm4, eax
	paddd mm3, mm4		 ; mm3 : ++i
	pand mm3, mm2
	
	movd eax, mm1
	shl eax,2
	movd ebx, mm3
	shl ebx,2
	add eax, SPOKE
	add ebx, SPOKE
	movd mm1, [eax]	 ; mm1 : spoke [i]
	movd mm3, [ebx]	 ; mm3 : spoke [++i]

	punpcklwd mm1,mm3			; spoke[++i] | spoke [i]
	punpcklwd mm5,mm0			; 	bof	    | 255-bof
	pmaddwd mm5,mm1

	psrld mm5,9+0

	; calcul de w
	mov eax, ecx
	add eax, DIST_TAB		; eax : (dist_tab + offset)
	pxor mm1,mm1
	pxor mm2,mm2
	movd mm1,[eax]
	movd mm2,PVALSRADIUS
	movq mm3, mm1
	pmulhw mm1,mm2
	pmullw mm2,mm3
	punpcklwd mm2,mm1
	paddd mm2,mm2 
	
	; on s'occupe de c
	; movd mm2, W 			; w	
	; movd mm1, W1 		; w1
	movq mm1, mm5			; w1
	psrld mm2,8				; w>>8
	pxor mm7,mm7
	movq mm4, mm2		   ; w

	pmulhw mm2,mm1
	pmullw mm1,mm4
 	punpcklwd mm1,mm2
	psrad mm1,8
	packuswb mm1,mm7		; on clampe
	
	punpcklbw mm1,mm1		; 00'00|00'cc
	punpcklwd mm1,mm1		; 00'00|cc'cc
	punpckldq mm1,mm1		; cc'cc|cc'cc
	
	; on s'occupe des ratios
	movq mm0, mm4	; 00'00|00'0ratio   ratio = w (mm4)
	packuswb mm0,mm7

	mov eax,255				; gard au chaud pour plus tard
	movd mm6, eax
	psubb mm6,mm0			; 00'00|00'0cratio
	
	punpcklwd mm0,mm6 	; 00'00|0cratio'0ratio
	punpckldq mm0,mm0		; 0cratio'0ratio|0cratio'0ratio

	; on s'occupe des couleurs
   mov esi, ecx  			; SRC
	mov edx, ecx			; DEST
	add esi, SRC	
	add edx, DEST
	mov edi, PVALSCOLOR  ; pvalscolor
	movd mm6,[esi]			; xx'xx|alphasrcredsrc'greensrcbluesrc
	movd mm2,[edi]			; xx'xx|alphacolorredcolor'greencolorbluecolor
	punpcklbw mm6,mm7		; 0alphasrc'0redsrc|0greensrc'0bluesrc
	punpcklbw mm2,mm7		; 0alphacol'0redcol|0greencol'0bluecol
	
	movq mm3,mm2			; 0alphacol'0redcol|0greencol'0bluecol
	punpcklwd mm2,mm6		; 0greensrc'0greencol|0bluesrc'0bluecol
	punpckhwd mm3,mm6		; 0alphasrc'0alphacol|0redsrc'0redcol

	pmaddwd mm2,mm0		;          green|blue			
	pmaddwd mm3,mm0		; 			  alpha| red
	psrld mm2, 8			;		
	psrld mm3, 8			;
	packssdw mm2,mm7     ; 00'00|0green'0blue
	packssdw mm3,mm7		; 00'00|0alpha'0red
	punpckldq mm2,mm3		; 0alpha'0red|0green'0blue
	packuswb mm2,mm7		; 00'00|alphared'greenblue
	
	paddusb mm2,mm1

	;; modif rapide
	movd mm1,[edx]
	paddusb mm2,mm1
	
	movd [edx], mm2

	sub ecx,4
	jnz NEAR main_mmx_loop

	pop edi
	pop esi
	pop ebp
	ret
%undef SRC 
%undef DEST 
%undef PVALSCOLOR 
%undef DIST_TAB
%undef PVALSRADIUS
%undef ANGLE_TAB 
%undef MASK_NSPOKE 
%undef SPOKE

asm_plot:
	push ebp
	mov ebp, esp
	pusha
	
	mov esi, [ebp + 8]  ; src
	mov edx, [ebp + 28] ; dest	
	mov edi, [ebp + 20] ; pvalscolor
	mov ecx,3
	@loopi:
		mov eax, [ebp + 16] ; compl_ratio
		mul byte [esi]
		mov ebx,eax
		mov eax, [ebp + 12] ; ratio 
		mul byte [edi]
		add eax,ebx
		shr eax,8
		add eax, [ebp + 24] ; c
		cmp eax,255
		jnge @suite
			mov eax,255
		@suite:
		cmp eax,0
		jge @suite2
			mov eax,0
		@suite2:
		    ;xor al,al
		mov [edx], al
		
		inc edx
		inc edi
		inc esi
		dec ecx
		jnz @loopi
		
	popa
	pop ebp
	ret


asm_emms:
	emms
	ret

; ebp + 8 : destination
; routine de blur par Rawhed/Sensory Overload
mmx_blur:
         push ebp   
         mov ebp,esp
         push edi
         mov edi,[ebp+8]
         mov ecx,[ebp+12]    ;256.000 320x200x4

;         sub ecx,2564
;         add edi,1284

         pxor MM7,MM7            ;=0

         @blur_more:
            movd MM0,[edi-4]    
            movd MM1,[edi+4]    
            movd MM2,[edi-640*4]
            movd MM3,[edi+640*4]

            punpcklbw MM0,MM7
            punpcklbw MM1,MM7
            punpcklbw MM2,MM7
            punpcklbw MM3,MM7

            paddusw MM0,MM1
            paddusw MM0,MM2
            paddusw MM0,MM3

            psrlw MM0,2
            packuswb MM0,MM7

            movd eax,MM0
            stosd
            sub ecx,4
            jnz near @blur_more

         EMMS
         pop edi
         pop ebp
         ret

; 8 : destination
; 12 : src
; 16 : xnb
; 20 : ynb
; 24 : xsadd
; 28 : xdadd
; 32 : ysoffadd
; routine de blur
mmx_blur2:
	push ebp   
	mov ebp,esp
	push edi
	push esi
	push edx
	push ebx

	pxor mm7,mm7
	mov edx,[ebp+32]
	mov esi,[ebp+12]
	mov edi,[ebp+8]

	; for (y=0; y<ynb; y++)
	mov ebx, [ebp+20]
blur20:

	; for (x=0; x<xnb; x++)
	mov ecx,[ebp+16]

blur21:
	movd mm0,[esi+4]
	movd mm1,[esi-4]
	add esi,edx
	movd mm2,[esi]
	sub esi,edx
	sub esi,edx
	movd mm3,[esi]

   punpcklbw MM0,MM7
   punpcklbw MM1,MM7
   punpcklbw MM2,MM7
   punpcklbw MM3,MM7
   
   paddusw MM0,MM1
   paddusw MM0,MM2
   paddusw MM0,MM3

   psrlw MM0,2
; packuswb MM0,MM7	

	movq MM4,MM0

	movd mm0,[esi+4]
	movd mm1,[esi-4]
	add esi,edx
	add esi,edx
	movd mm2,[esi+4]
	movd mm3,[esi-4]
	sub esi,edx

   punpcklbw MM0,MM7
   punpcklbw MM1,MM7
   punpcklbw MM2,MM7
   punpcklbw MM3,MM7
   
   paddusw MM0,MM1
   paddusw MM0,MM2
   paddusw MM0,MM3

   psrlw MM0,2
	
	paddsw MM0,MM4
	paddsw MM0,MM4
	paddSW MM0,MM4
	psrlw MM0,2
	packuswb MM0,MM7	
	movd [edi],MM0

	add edi,4
	add esi,4	
	dec ecx
	jne NEAR blur21

	add esi,[ebp+24]
	add edi,[ebp+28]
	
	dec ebx
	jne NEAR blur20
	
	pop ebx
	pop edx
	pop esi
   pop edi
   pop ebp
   ret


; 8  : itime
; 12 : rtime
; 16 : buftmp (avec le dcalage) 
; 20 : pfond  (avec le dcalage)
; 24 : taille (en pixels)
mmx_scroll:
	push ebp
	mov ebp,esp
	push edi
	push esi

	pxor mm7,mm7			; mm7 : 0
	movd mm0,[ebp+8]     ; mm0 : 00'00|00'0it
	movd mm1,[ebp+12]		; mm1 : 00'00|00'0rt
	mov edi,[ebp+16]
	mov esi,[ebp+20]
	mov ecx,[ebp+24]		; taille

	movd mm0,[ebp+8]     ; mm0 : 00'00|00'0it
	movd mm1,[ebp+12]		; mm1 : 00'00|00'0rt
	punpcklwd mm1,mm1		; mm1 : 00'00 |0rt'0rt
	punpcklwd mm0,mm1		; mm0 : 00 '00 |0rt'0 it
	punpckldq mm0,mm0		; mm0 : 0rt'0it | 0rt'0it

mmx_l1:

	movd mm1,[esi]			; mm1 : 00'00|0 sr 'sg sb
	movd mm2,[esi+4]		; mm2 : 00'00|0 dr 'dg db
	punpcklbw mm1,mm7    ; mm1 : 00'0 sr| 0 sg '0 sb
	punpcklbw mm2,mm7		; mm2 : 00'0 dr| 0 dg '0 db

	movq mm3,mm2			; mm3 : 00'0 dr| 0 dg '0 db
	punpcklwd mm2,mm1		; mm2 : 0 sg'0 dg| 0 sb'0 db
	punpckhwd mm3,mm1		; mm3 : 0  0 0  0| 0 sr'0 dr

	pmaddwd mm3, mm0		; partie haute
	pmaddwd mm2, mm0		; partie basse

	psrld mm3,8
	psrld mm2,8

	packssdw mm2,mm3
	packuswb mm2,mm2		; finish

	movd [edi],mm2

	add edi,4
	add esi,4
	dec ecx
	jne mmx_l1
	
	pop esi
	pop edi
	pop ebp
	ret

; 8 : buftmp (avec le dcalage) 
; 12 : taille (en pixels)
; 16 : sat (degr de saturation) 
; 20 ; ajout1 (pour la multiplication)
mmx_sat:
	push ebp
	mov ebp,esp
	push edi
	push esi
	push eax
	push ecx 

	pxor mm7,mm7			; mm7 : 0
	mov edi,[ebp+8]		; buftmp
	mov ecx,[ebp+12]		; taille
	movd mm2,[ebp+16]
	punpckldq mm2,mm2		; sat
	mov ebx,0x00FF00FF
	movd mm3,ebx
	punpckldq mm3,mm3
	psubusb mm3,mm2		; 255-sat
	movd mm6,[ebp+20]		; ajout1
	punpckldq mm6,mm6

mmx_sat1:
	movd mm0,[edi]       ; 0 | p
	
	; Csat = (A + R + V + B)/4
	punpcklbw mm0,mm7    ; 0a0r|0v0b
	movq mm1,mm0			; mm1 : Cl
	pmaddwd mm0,mm6
	packssdw mm0,mm7
	pmaddwd mm0,mm6
	psrld mm0,2
	packuswb mm0,mm7     ; mm0: Csat

	; Cf = (Csat*sat + Cl*(255-sat))/256	
	punpcklwd mm0,mm0
	punpckldq mm0,mm0    ; mm0: csat csat|csat csat 

	pmullw mm0,mm2			; Csat*sat ->mm0
	pmullw mm1,mm3			; Cl*(255-sat)
	paddd mm0,mm1 
	psrlw mm0,8	
	packuswb mm0,mm0

;	punpcklbw mm0,mm0 si on veut s'arreter a une saturation totale
;	punpcklwd mm0,mm0
	
	movd [edi],mm0 
	add edi,4
	dec ecx
	jne mmx_sat1

	pop ecx
	pop eax	
	pop esi
	pop edi
	pop ebp
	ret


; 8  : itime
; 12 : rtime
; 16 : buftmp (avec le dcalage) 
; 20 : pfond  (avec le dcalage)
; 24 : taille (en pixels)
; 28 : degrade (valeur)
mmx_scroll2:
	push ebp
	mov ebp,esp
	push edi
	push esi

	pxor mm7,mm7			; mm7 : 0
	movd mm0,[ebp+8]     ; mm0 : 00'00|00'0it
	movd mm1,[ebp+12]		; mm1 : 00'00|00'0rt
	mov edi,[ebp+16]
	mov esi,[ebp+20]
	mov ecx,[ebp+24]		; taille

	movd mm0,[ebp+8]     ; mm0 : 00'00|00'0it
	movd mm1,[ebp+12]		; mm1 : 00'00|00'0rt
	punpcklwd mm1,mm1		; mm1 : 00'00 |0rt'0rt
	punpcklwd mm0,mm1		; mm0 : 00 '00 |0rt'0 it
	punpckldq mm0,mm0		; mm0 : 0rt'0it | 0rt'0it
	movq mm4,mm0			; on sauve mm0
	movd mm6,[ebp+28]		; degrad
	punpcklwd mm6,mm6
	punpckldq mm6,mm6
	
mmx_l22:

	movd mm1,[esi]			; mm1 : 00'00|0 sr 'sg sb
	movd mm2,[esi+4]		; mm2 : 00'00|0 dr 'dg db
	punpcklbw mm1,mm7    ; mm1 : 00'0 sr| 0 sg '0 sb
	punpcklbw mm2,mm7		; mm2 : 00'0 dr| 0 dg '0 db

	movq mm3,mm2			; mm3 : 00'0 dr| 0 dg '0 db
	punpcklwd mm2,mm1		; mm2 : 0 sg'0 dg| 0 sb'0 db
	punpckhwd mm3,mm1		; mm3 : 0  0 0  0| 0 sr'0 dr

	pmaddwd mm3, mm0		; partie haute
	pmaddwd mm2, mm0		; partie basse

	psrld mm3,8
	psrld mm2,8

	packssdw mm2,mm3
	pmullw mm2,mm6
	psrlw mm2,8
	packuswb mm2,mm2		; finish
;	psubusb mm2,mm6		; ajoute dgrad
	movd [edi],mm2

	add edi,4
	add esi,4
	movq mm0,mm4
	dec ecx
	jne mmx_l22
	
	pop esi
	pop edi
	pop ebp
	ret

; 8  : itime
; 12 : rtime
; 16 : buftmp (avec le dcalage) 
; 20 : pfond  (avec le dcalage)
; 24 : taille (en pixels)
; 28 : degrade (valeur)
; 32 : colors
mmx_scroll3:
	push ebp
	mov ebp,esp
	push edi
	push esi

	push eax
	push ebx
	push ecx
	push edx

	pxor mm7,mm7			; mm7 : 0
	movd mm0,[ebp+8]     ; mm0 : 00'00|00'0it
	movd mm1,[ebp+12]		; mm1 : 00'00|00'0rt
	mov edi,[ebp+16]
	mov esi,[ebp+20]
	mov ecx,[ebp+24]		; taille

	movd mm0,[ebp+8]     ; mm0 : 00'00|00'0it
	movd mm1,[ebp+12]		; mm1 : 00'00|00'0rt
	punpcklwd mm1,mm1		; mm1 : 00'00 |0rt'0rt
	punpcklwd mm0,mm1		; mm0 : 00 '00 |0rt'0 it
	punpckldq mm0,mm0		; mm0 : 0rt'0it | 0rt'0it
	movq mm4,mm0			; on sauve mm0
	movd mm6,[ebp+28]		; degrad
	punpcklwd mm6,mm6
	mov edx,[ebp+32]
	punpckldq mm6,mm6


	; mm5 de libre	
mmx_l32:

	xor eax,eax
	xor ebx,ebx
	mov al,[esi]
	mov bl,[esi+1]
	shl eax,2
	shl ebx,2
	add eax,edx
	add ebx,edx

	movd mm1,[eax]			; mm1 : 00'00|0 sr 'sg sb
	movd mm2,[ebx]			; mm2 : 00'00|0 dr 'dg db
	punpcklbw mm1,mm7    ; mm1 : 00'0 sr| 0 sg '0 sb
	punpcklbw mm2,mm7		; mm2 : 00'0 dr| 0 dg '0 db

	movq mm3,mm2			; mm3 : 00'0 dr| 0 dg '0 db
	punpcklwd mm2,mm1		; mm2 : 0 sg'0 dg| 0 sb'0 db
	punpckhwd mm3,mm1		; mm3 : 0  0 0  0| 0 sr'0 dr

	pmaddwd mm3, mm0		; partie haute
	pmaddwd mm2, mm0		; partie basse

	psrld mm3,8
	psrld mm2,8

	packssdw mm2,mm3
	pmullw mm2,mm6
	psrlw mm2,8
	packuswb mm2,mm2		; finish
	movd [edi],mm2

	add edi,4
	inc esi
	movq mm0,mm4
	dec ecx
	jne mmx_l32

	pop edx
	pop ecx
	pop ebx
	pop eax
	
	pop esi
	pop edi
	pop ebp
	ret



; 8 : src
; 12 : dst
; 16 : nb de 2 pixels
mmx_quadcpy:
	push ebp
	mov ebp,esp
	push edi
	push esi

	mov esi, [ebp+8]
	mov edi, [ebp+12]	
	mov ecx, [ebp+16]
mmx_quadl1:
	movq mm0, [esi] ; 2 pixels
	movq [edi], mm0
	add esi,8
	add edi,8
	dec ecx
	jne mmx_quadl1

	pop esi
	pop edi
	pop ebp
	ret

; 8 : dest
; 12 : nb de 2 pixels
; 16 : couleur
mmx_quaddel:
	push ebp
	mov ebp,esp
	push edi
	
	mov edi, [ebp+8]	
	mov ecx, [ebp+12]
	movd mm0,[ebp+16]
	punpckldq mm0,mm0
mmx_quaddel1:
	movq [edi], mm0
	add edi,8
	dec ecx
	jne mmx_quaddel1

	pop edi
	pop ebp
	ret


; 8 : src
; 12 : dst
; 16 : nb de 2 pixels
; 20 : 0xFFFFFFFF
mmx_quadnegsub:
	push ebp
	mov ebp,esp
	push edi
	push esi

	mov esi, [ebp+8]
	mov edi, [ebp+12]	
	mov ecx, [ebp+16]
	movd mm2, [ebp+20]
	punpckldq mm2,mm2
mmx_quadnegsub1:
	movq mm1, [esi] ; 2 pixels
	movq mm0,mm2
	psubusb mm0,mm1	; neg
;	psubb mm0,mm1	; sub

	MOVQ            MM5, MM0        ; make a copy of MM0
	PSUBUSB         MM0, MM1        ; compute difference one way
	PSUBUSB         MM1, MM5        ; compute difference the other way
	POR             MM0, MM1        ; OR them together

	movq mm1,mm2
	psubusb mm1,mm0	; neg

	movq [edi], mm1

	add esi,8
	add edi,8
	dec ecx
	jne mmx_quadnegsub1

	pop esi
	pop edi
	pop ebp
	ret

; 8 : src
; 12 : dest
; 16 : nb de 2 pixels
; 20 : attenuation
mmx_addcol:
	push ebp
	mov ebp,esp
	push edi
	push esi

	mov esi, [ebp+8]
	mov edi, [ebp+12]
	mov ecx, [ebp+16]
	movd mm2,[ebp+20]
	punpckldq mm2,mm2
mmx_quadcol:
	movq mm0, [esi]
	movq mm1, [edi]
	psubusb mm0,mm2
	paddusb mm0,mm1
	movq [edi], mm0
	add edi,8
	add esi,8
	dec ecx
	jne mmx_quadcol

	pop esi
	pop edi
	pop ebp
	ret

; 8 : src
; 12 : dst
; 16 : nb de 2 pixels
; 20 : 0xFFFFFFFF
; 24 : alpha : 255 transparent
mmx_lettre:
	push ebp
	mov ebp,esp
	push edi
	push esi

	mov esi, [ebp+8]
	mov edi, [ebp+12]	
	mov ecx, [ebp+16]
	movd mm2, [ebp+20]
	punpckldq mm2,mm2
	movd mm3, [ebp+24]
	punpckldq mm3,mm3

mmx_lettre1:
	movq mm0, [esi] ; 2 pixels
	movq mm1,mm2
	psubusb mm1,mm0	; neg

	movq mm0,[edi]
	psubusb mm1, mm3
	paddusb mm0, mm1
	
	movq [edi],mm0

	add esi,8
	add edi,8
	dec ecx
	jne mmx_lettre1

	pop esi
	pop edi
	pop ebp
	ret

;void scanit(int off, int l, int iVx, int iVy, int wtex, 
;					  int iVXpad, int iVYpad, Uint32 *screen, Uint32 *tex, Uint32 d2)

; 8 :  l
; 12 : iVx
; 16 : iVy
; 20 : wtex
; 24 : iVXpad
; 28 : iVYpad
; 32 : screen
; 36 : tex
; 40 : d2
mmx_scanit:
	push ebp
	mov ebp,esp
	push edi 
	push esi
	push ecx
	push ebx

	mov ecx,[ebp+8]
	movd mm1,[ebp+12] ; mm1 : iVx
	movd mm2,[ebp+16] ; mm2 : iVy
	movd mm3,[ebp+20] ; mm3 : wtex
	movd mm4,[ebp+24] ; mm4 : iVXpad
	movd mm5,[ebp+28] ; mm5 : iVYpad

	mov edi,[ebp+32]
	mov esi,[ebp+36]
	movd mm6,[ebp+40]

	mov eax,1
	movd mm0,eax ; mm0 : 1

	punpckldq mm5,mm4 ; mm5 : iVXpad | iVYpad
	punpckldq mm2,mm1 ; mm2 :    iVx |    iVy
	punpckldq mm3,mm0 ; mm3 :      1 |   wtex
	; punpckldq mm6,mm6
	packssdw mm3,mm3
 
scanlp1:

	movq mm4,mm2      ; mm4 :    iVx |    iVy 
	psrad mm2, 16     ; mm2 :   iVxr |   iVyr
	packssdw mm2,mm2	

	pmaddwd mm2,mm3   ; mm1 : iVxr + wtex*iVyr 
	movd ebx,mm2

	paddd mm4,mm5
	movq mm2,mm4	

	movd mm1,[esi+ebx*4]
	movq mm0,mm6
	movd mm7,[edi]
	psubusb mm1,mm0
	paddusb mm1,mm7
	movd [edi],mm1


	
	add edi,4
	dec ecx
	jnz scanlp1
	
	pop ebx
	pop ecx	
	pop esi
	pop edi
	pop ebp
	ret

; end of func.asm
