// Moteur 3d de Ced

#include <vector>
#include <iostream>

#include <stdlib.h>
#include "effets.h"
#include "Render.h"
#include "lib3ds/material.h"
#include "Object.h"
#include "3DPath.h"


static inline Uint32 cmerge(const int src, const int dst, const int ALPHA)
{
        const int ret = ( src*(ALPHA) + dst*(255-ALPHA) ) >> 8;
        return ret;
}

static void LowDrawAlpha(Uint32 *screen, Uint32 *soff,
						 const int ycount, const int xcount)
{
	for (int y=0; y<ycount; y++) {
		for (int x=0; x<xcount; x++) {
			const Uint32 sc = *soff;    // image (source)
			const Uint32 dc = *screen;                // screen (dest)
			Uint32 Rsc = (sc&RMASK) >> RSHFT; Uint32 Gsc = (sc&GMASK) >> GSHFT;
			Uint32 Bsc = (sc&BMASK) >> BSHFT; 
			const Uint32 ALPHA = (sc&AMASK) >> ASHFT;
			
			Uint32 Rdc = (dc&RMASK) >> RSHFT; Uint32 Gdc = (dc&GMASK) >> GSHFT;
			Uint32 Bdc = (dc&BMASK) >> BSHFT;
			
			Uint32 Rfc = cmerge(Rsc, Rdc, ALPHA)<<RSHFT;
			Uint32 Gfc = cmerge(Gsc, Gdc, ALPHA)<<GSHFT;
			Uint32 Bfc = cmerge(Bsc, Bdc, ALPHA)<<BSHFT;
			
			const Uint32 ColorFinal = Rfc + Gfc + Bfc;
			
			*screen = ColorFinal;
			screen++; soff++;
		}
	}
}

generique::generique(Render *rd)
{
	this->rd = rd;
	scroll = rd->bind("delire.jpg");
	cache = rd->bind("cache.png");
	lastcall = 0;
	//mmx_quadcpy((Uint32*)(sdl_sprite->pixels)+320*320,temp->pixels,320*320/2);
	//mmx_quadcpy(sdl_flaque->pixels,(Uint32*)(sdl_sprite->pixels)+320*320,320*320/2);
	asm_emms();
}
 
generique::~generique() { }

void generique::go(Uint32 *screen, Uint32 time)
{
	//cout << "XXXXXXXXXXXXXXXXXXX"<<endl;
	SDL_Surface *scroll_s = rd->getTexture(scroll);
	SDL_Surface *cache_s  = rd->getTexture(cache);
	if(!cache_s) cout << "!!!!!*******!!!!!!!!" << endl;
	
	if(!lastcall) lastcall = time;
	int offset = (time - lastcall)/35;
	
	if(offset > 1218-480) offset = 1218-480;
	mmx_quadcpy((Uint32*)scroll_s->pixels+offset*640, screen, 640*480/2);
	asm_emms();
	LowDrawAlpha(screen,(Uint32*)(cache_s->pixels),200, 640);
}

