// un petit logo  afficher

#include "effets.h"

static inline
Uint32 *do_logo(Uint32 *src1, Uint32 *src2, Uint32 *src3, Uint32 *src4,
						const int level, const int SIZE_W, const int SIZE_H, Uint32 mask, int d);

// Constructeur
Logo::Logo(char text1[])
{
	// logo blur (chargement d'image)
	SDL_Surface *tmp_logo, *tmp_font, *font;
  // on charge l'image
	//tmp_logo = IMG_Load (PATH_2D "text1.png"); testload (tmp_logo);

	// charge la fonte
	tmp_font = IMG_Load (PATH_2D "font2.png"); testload(tmp_font);
	font = SDL_CreateRGBSurface (SDL_SWSURFACE, tmp_font->w, tmp_font->h, 
				     32,0xFF0000,
				     0xFF00, 0xFF,0xFF000000);
  SDL_BlitSurface (tmp_font,NULL, font, NULL);
	SDL_FreeSurface(tmp_font);

	// gnre le texte
	char *ptext=text1;
	char nbl = strlen(text1);
	int W = 64*nbl;
	int H = 64;
	tmp_logo = SDL_CreateRGBSurface (SDL_SWSURFACE, W, H, 32, 0xFF0000, 0xFF00, 0xFF,0xFF000000);
	LOCK_SURFACE(tmp_logo);
	LOCK_SURFACE(font);
	Uint32 *src = (Uint32 *)font->pixels;
	Uint32 *dst = (Uint32 *)tmp_logo->pixels;

 	Uint32 doff=0;
	for (int i=0; i<nbl; i++) {
  	Uint32 soff = (*(ptext)-'A')*(64*64);
  	for(int y=0; y<64; y++) {
    	for(int x=0; x<64; x++) {
    		if (*ptext!=' ') {
    			dst[doff+x+W*y] = src[soff++];
    		}
    		else {
    			dst[doff+x+W*y] = 0xFFFFFFFF;
    		}
    	}
    }
    ptext++;
    doff += 64;
	}

	UNLOCK_SURFACE(font);
	UNLOCK_SURFACE(tmp_logo);

  // on la fout dans un buffer
  logo1 = SDL_CreateRGBSurface (SDL_SWSURFACE, tmp_logo->w, tmp_logo->h, 
															 32,0xFF0000,
															 0xFF00, 0xFF,0xFF000000);
	logo2 = SDL_CreateRGBSurface (SDL_SWSURFACE, tmp_logo->w, tmp_logo->h, 
															 32,0xFF0000,
															 0xFF00, 0xFF,0xFF000000);
	logo3 = SDL_CreateRGBSurface (SDL_SWSURFACE, tmp_logo->w, tmp_logo->h, 
															 32,0xFF0000,
															 0xFF00, 0xFF,0xFF000000);
	logo4 = SDL_CreateRGBSurface (SDL_SWSURFACE, tmp_logo->w, tmp_logo->h, 
															 32,0xFF0000,
															 0xFF00, 0xFF,0xFF000000);
  SDL_BlitSurface (tmp_logo,NULL, logo1, NULL);
//  SDL_BlitSurface (font,NULL, logo1, NULL);
	SDL_FreeSurface(tmp_logo);
	SDL_FreeSurface(font);

	int SIZE_W = logo1->w;
	int SIZE_H = logo1->h;
	
	LOCK_SURFACE(logo1);
	LOCK_SURFACE(logo2);
	LOCK_SURFACE(logo3);
	LOCK_SURFACE(logo4);
	Uint32 *src1 = (Uint32 *)logo1->pixels;
	Uint32 *src2 = (Uint32 *)logo2->pixels;
	Uint32 *src3 = (Uint32 *)logo3->pixels;
	Uint32 *src4 = (Uint32 *)logo4->pixels;

	// rend le logo 
	Uint32 *dest = do_logo(src1, src2, src3, src4, 0, SIZE_W, SIZE_H, 0xFFFFFF,0);
	// le copie dans src4
	mmx_quadcpy(dest,src4,SIZE_H*SIZE_W/2);
	asm_emms();
	UNLOCK_SURFACE(logo4);
	UNLOCK_SURFACE(logo3);
	UNLOCK_SURFACE(logo2);
	UNLOCK_SURFACE(logo1);
	
	// calcule les coord de X1,Y1 pour centrer l'image
	CX1 = (640 - logo1->w)/2;
	CY1 = (480 - logo1->h)/2;
}

Logo::Logo(char text1[], char text2[])
{

	part = NULL; //new parts();

	// logo blur (chargement d'image)
	SDL_Surface *tmp_logo, *tmp_font, *font;
  // on charge l'image
	//tmp_logo = IMG_Load (PATH_2D "text1.png"); testload (tmp_logo);

	// charge la fonte
	tmp_font = IMG_Load (PATH_2D "font2.png"); testload(tmp_font);
	font = SDL_CreateRGBSurface (SDL_SWSURFACE, tmp_font->w, tmp_font->h, 
															 32,0xFF0000,
															 0xFF00, 0xFF,0xFF000000);
  SDL_BlitSurface (tmp_font,NULL, font, NULL);
	SDL_FreeSurface(tmp_font);

	// gnre le texte
	char *ptext=text1;
	char *ptext2 = text2;
	char nbl = strlen(text1);
	char nbl2 = strlen(text2);
	int W = 64* (nbl2>nbl?nbl2:nbl);
	int H = 64*2;
	tmp_logo = SDL_CreateRGBSurface (SDL_SWSURFACE, W, H, 32, 0xFF0000, 0xFF00, 0xFF,0xFF000000);
	LOCK_SURFACE(tmp_logo);
	LOCK_SURFACE(font);
	Uint32 *src = (Uint32 *)font->pixels;
	Uint32 *dst = (Uint32 *)tmp_logo->pixels;

 	Uint32 doff=0;
	for (int i=0; i<nbl; i++) {
  	Uint32 soff = (*(ptext)-'A')*(64*64);
  	for(int y=0; y<64; y++) {
    	for(int x=0; x<64; x++) {
    		if (*ptext!=' ') {
    			dst[doff+x+W*y] = src[soff++];
    		}
    		else {
    			dst[doff+x+W*y] = 0xFFFFFFFF;
    		}
    	}
    }
    ptext++;
    doff += 64;
	}


	doff = 64*W;
	for (int i=0; i<nbl2; i++) {
  	Uint32 soff = (*(ptext2)-'A')*(64*64);
  	for(int y=0; y<64; y++) {
    	for(int x=0; x<64; x++) {
    		if (*ptext2!=' ') {
    			dst[doff+x+W*y] = src[soff++];
    		}
    		else {
    			dst[doff+x+W*y] = 0xFFFFFFFF;
    		}
    	}
    }
    ptext2++;
    doff += 64;
	}


	UNLOCK_SURFACE(font);
	UNLOCK_SURFACE(tmp_logo);

  // on la fout dans un buffer
  logo1 = SDL_CreateRGBSurface (SDL_SWSURFACE, tmp_logo->w, tmp_logo->h, 
															 32,0xFF0000,
															 0xFF00, 0xFF,0xFF000000);
	logo2 = SDL_CreateRGBSurface (SDL_SWSURFACE, tmp_logo->w, tmp_logo->h, 
															 32,0xFF0000,
															 0xFF00, 0xFF,0xFF000000);
	logo3 = SDL_CreateRGBSurface (SDL_SWSURFACE, tmp_logo->w, tmp_logo->h, 
															 32,0xFF0000,
															 0xFF00, 0xFF,0xFF000000);
	logo4 = SDL_CreateRGBSurface (SDL_SWSURFACE, tmp_logo->w, tmp_logo->h, 
															 32,0xFF0000,
															 0xFF00, 0xFF,0xFF000000);
  SDL_BlitSurface (tmp_logo,NULL, logo1, NULL);
//  SDL_BlitSurface (font,NULL, logo1, NULL);
	SDL_FreeSurface(tmp_logo);
	SDL_FreeSurface(font);

	int SIZE_W = logo1->w;
	int SIZE_H = logo1->h;
	
	LOCK_SURFACE(logo1);
	LOCK_SURFACE(logo2);
	LOCK_SURFACE(logo3);
	LOCK_SURFACE(logo4);
	Uint32 *src1 = (Uint32 *)logo1->pixels;
	Uint32 *src2 = (Uint32 *)logo2->pixels;
	Uint32 *src3 = (Uint32 *)logo3->pixels;
	Uint32 *src4 = (Uint32 *)logo4->pixels;

	// rend le logo 
	Uint32 *dest = do_logo(src1, src2, src3, src4, 0, SIZE_W, SIZE_H, 0xFFFFFF,0);
	// le copie dans src4
	mmx_quadcpy(dest,src4,SIZE_H*SIZE_W/2);
	asm_emms();
	UNLOCK_SURFACE(logo4);
	UNLOCK_SURFACE(logo3);
	UNLOCK_SURFACE(logo2);
	UNLOCK_SURFACE(logo1);
	
	// calcule les coord de X1,Y1 pour centrer l'image
	CX1 = (640 - logo1->w)/2;
	CY1 = (480 - logo1->h)/2;
}


// Destructueur
Logo::~Logo()
{
	// On vire tout
	SDL_FreeSurface(logo1);
	SDL_FreeSurface(logo2);
	SDL_FreeSurface(logo3);
	SDL_FreeSurface(logo4);
}

static inline
Uint32 *do_logo(Uint32 *src1, Uint32 *src2, Uint32 *src3, Uint32 *src4,
						const int level, const int SIZE_W, const int SIZE_H, Uint32 mask, int d)
{

	Uint32 *tmp1=src3, *tmp2=src2, *tmp3; // pour echanger les pointeurs src et dst
	mmx_quaddel(src2,SIZE_W*SIZE_H/2,0xFFFFFF);
	mmx_quaddel(src3,SIZE_W*SIZE_H/2,0xFFFFFF);
	mmx_blur2 (src2+SIZE_W*3+3, src1+SIZE_W*3+3, SIZE_W-6, SIZE_H-6, 6*4, 6*4, SIZE_W*4);
	for (int i=0; i<level; i++) {
		mmx_blur2 (tmp1+SIZE_W*3+3, tmp2+SIZE_W*3+3, SIZE_W-6, SIZE_H-6, 6*4, 6*4, SIZE_W*4);
		tmp3 = tmp1; tmp1 = tmp2; tmp2 = tmp3; // echange src et dst
	}
	// mmx_quadnegsub(tmp2,tmp1,SIZE_W*SIZE_H/2,0x00FF0000 /*+ (a<<8)*/ + b);
	mmx_quadnegsub(tmp2,tmp1,SIZE_W*SIZE_H/2,mask);
	//mmx_addcol(src4,tmp1,SIZE_W*SIZE_H/2, d | (d<<8) | (d<<16));
	return tmp1; // sauve destination
}

void Logo::zoom(float time1, const int SIZE_W, const int SIZE_H, Uint32 *buffer, 
					Uint32 *dest, Uint32 d2, float deb, float speed)
{
 	float scale = deb + time1*speed;

	
 	fVector carre[4];
 	fVector vtex[4];

 	iVector icarre[4];
 	iVector ivtex[4];

 	float fx1 = (SIZE_W/2) * scale;
 	float fy1 = (SIZE_H/2) * scale;

 	carre[0][0] = -fx1; 	carre[0][1] = -fy1; 	carre[0][2] = 0;
 	carre[1][0] = -fx1; 	carre[1][1] = fy1; 	carre[1][2] = 0;
 	carre[2][0] = fx1; 	carre[2][1] = fy1; 	carre[2][2] = 0;
 	carre[3][0] = fx1; 	carre[3][1] = -fy1; 	carre[3][2] = 0;

 	vtex[0][0] = 0; 	    vtex[0][1] = 0; 	    vtex[0][2] = 0;
 	vtex[1][0] = 0; 	    vtex[1][1] = SIZE_H; 	vtex[1][2] = 0;
 	vtex[2][0] = SIZE_W; 	vtex[2][1] = SIZE_H; 	vtex[2][2] = 0;
 	vtex[3][0] = SIZE_W; 	vtex[3][1] = 0; 	    vtex[3][2] = 0;

 	for (int i=0; i<4; i++) {
 		for (int j=0; j<3; j++) {
 			icarre[i][j] = (int) (carre[i][j]*65536);
 			ivtex[i][j] = (int) (vtex[i][j]*65536);
 		}
 	}
 	render_tri( buffer, icarre, ivtex, dest, SIZE_W, SIZE_H, CULL_FACE  /* | BILINEAR_FILT*/ | TRANSPARENCY, 4, d2 );
}

void Logo::go(Uint32 *buffer, Uint32 time, int depth, int yscroll=0, int sep=4, float deb, float speed)
{
	int SIZE_W = logo1->w;
	int SIZE_H = logo1->h;
	
	int d2 = CLAMP(depth-255,0,255);
	int d3 = CLAMP(depth,0,255);


	float time1 = 1.0*time;
	
	LOCK_SURFACE(logo1);
	LOCK_SURFACE(logo2);
	LOCK_SURFACE(logo3);
	LOCK_SURFACE(logo4);
	Uint32 *src1 = (Uint32 *)logo1->pixels;
	Uint32 *src2 = (Uint32 *)logo2->pixels;
	Uint32 *src3 = (Uint32 *)logo3->pixels;
	Uint32 *src4 = (Uint32 *)logo4->pixels;

	int level = (int) (2+2*cos(0.005*time1));
	int a = (int) (128 - 64*cos(0.004*time1));
	int b = (int) (128 + 128*sin(0.002*time1));
	if (a>255) a=255;
	if (b>255) b=255;

	// rend le logo 
	Uint32 *dest = do_logo(src1, src2, src3, src4, level, SIZE_W, SIZE_H, a | (b<<8) | 0xFF0000, d3);

	d2 = d2|(d2<<8)|(d2<<16);
	d3 = d3|(d3<<8)|(d3<<16);

	int ydeb = CY1+yscroll;
	Uint32 off1 = CX1 + ydeb*640;
	Uint32 off = 0;
	int SIZE_H2 = SIZE_H;

	if ((sep&2)== 2) {
	    	asm_emms();
		zoom(time1, SIZE_W, SIZE_H, buffer, dest, d2, deb, speed);
	}

	if ( (sep&1) == 1) SIZE_H2 = SIZE_H/2;

	if ( ((sep&1)==1) || ((sep&4)==4) ) {
		for (int y1=ydeb; y1<SIZE_H2+ydeb; y1++) {
			if ( (y1>=0) && (y1<480) ) {
				mmx_addcol(dest+off,buffer+off1,SIZE_W/2,d2);
			}
			off += SIZE_W;
			off1 += SIZE_W; 
			off1 += CX1*2;
		}	
	}

	if ( (sep&1) ==1) {
  	ydeb = CY1-yscroll+SIZE_H2;
  	off1 = CX1 + ydeb*640;
  	//off = 0;

  	for (int y1=ydeb+SIZE_H2; y1<SIZE_H+ydeb; y1++) {
  		if ( (y1>=0) && (y1<480) ) {
  			mmx_addcol(dest+off,buffer+off1,SIZE_W/2,d2);
  		}
  		off += SIZE_W;
  		off1 += SIZE_W; 
  		off1 += CX1*2;
  	}	
	}
		
	
	asm_emms();
	UNLOCK_SURFACE(logo4);
	UNLOCK_SURFACE(logo3);
	UNLOCK_SURFACE(logo2);
	UNLOCK_SURFACE(logo1);
}
