// Affichage des chiffres avec zoom et tout

#include "effets.h"

// constructeur
XLettre::XLettre()
{
	// charge la fonte
	SDL_Surface *tmp_font;
	tmp_font = IMG_Load (PATH_2D "font2.png"); testload(tmp_font);
	font = SDL_CreateRGBSurface (SDL_SWSURFACE, tmp_font->w, tmp_font->h, 
															 32,0xFF0000,
															 0xFF00, 0xFF,0xFF000000);
	
	SDL_BlitSurface (tmp_font,NULL, font, NULL);	
	SDL_FreeSurface(tmp_font);
	W = font->w;
}

XLettre::~XLettre()
{
	SDL_FreeSurface(font);
}

// affichage
// 	retour: 
//		0 : ok
//		X : erreur
int XLettre::go (Uint32 *buffer, int xdest, int ydest, char text, uchar alpha)
{
	int xg=xdest, xd=xdest+W, yg=ydest, yd=ydest+W;
	int sxg=0, sxd=W, syg=0, syd=W;

	if ( (text<'A') || (text>'Z'+1) ) {
		return -1;
	}
	
	int nb = text - 'A';


	// clipping
	if ( (xdest<-W) || (xdest>639) ) {return -2;}
	if ( (ydest<-W) || (ydest>479) ) {return -2;}

	if (xdest<0) {
		xg = 0;
		sxg = -xdest;
	}
	else if (xdest>639-W) {
		xd = 640;
		sxd = 640 - xdest;
	}

	if (ydest<0) {
		yg = 0;
		syg = -ydest;
	}
	else if (ydest>479-W) {
		yd = 480;
		syd = 480 - ydest;
	}

  // **********************X***M***X
	//                    480 - X
	//													 M
	//                               480

	int soff = nb*(W*W) + (syg*W) + sxg;
	int doff = yg*640 + xg;
	const int sxadd = sxg + W - sxd;
	const int dxadd= xg + 640 - xd;

	#define MIN(a,b) (a<b)?a:b 
	const int ymax = MIN(yd-yg,syd-syg);
	const int xmax = MIN(xd-xg,sxd-sxg);
	#undef MIN

	int a = CLAMP(255 - alpha,0,255);
	const int calpha = a | (a<<8) | (a<<16) | (a<<24);

	// affichage
	LOCK_SURFACE(font);
	Uint32 *pfont = (Uint32 *) font->pixels;
	for (int y=0; y<ymax; y++) {
		//mmx_addcol (pfont+soff, buffer+doff, xmax/2);
		mmx_lettre (pfont+soff, buffer+doff, xmax/2, 0xFFFFFFFF, calpha);
		soff += xmax + sxadd;
		doff += xmax + dxadd;
	}
	asm_emms();
	UNLOCK_SURFACE(font);
	
	return 0;
}
// end of logo2.cc
