// Moteur 3d de Ced

#include <vector>
#include <iostream>

#include <stdlib.h>
#include "effets.h"
#include "Render.h"
#include "lib3ds/material.h"
#include "Object.h"
#include "3DPath.h"

// Constructeur
marche::marche(Render *rd)
{
	launchtime = 0;
	this->rd = rd;
	sprite1 = rd->bind("marche1.png");
	sprite2 = rd->bind("marche2.png");
	sprite3 = rd->bind("marche3.png");
	sprite4 = rd->bind("marche4.png");
}

// Destructeur
marche::~marche() { }

static inline Uint32 cmerge(const int src, const int dst, const int ALPHA)
{
        const int ret = ( src*(ALPHA) + dst*(255-ALPHA) ) >> 8;
        //assert (ret >= 0 && ret <= 255);        // to be removed
        return ret;
}

static void LowDrawAlpha(Uint32 *screen, Uint32 *soff,
			 const int ycount, const int xcount)
{
	for (int y=0; y<ycount; y++) {
		for (int x=0; x<xcount; x++) {
			const Uint32 sc = *soff;    // image (source)
			const Uint32 dc = *screen;                // screen (dest)
			Uint32 Rsc = (sc&RMASK) >> RSHFT; Uint32 Gsc = (sc&GMASK) >> GSHFT; 
			Uint32 Bsc = (sc&BMASK) >> BSHFT; 
			const Uint32 ALPHA = (sc&AMASK) >> ASHFT;
			
			Uint32 Rdc = (dc&RMASK) >> RSHFT; Uint32 Gdc = (dc&GMASK) >> GSHFT; 
			Uint32 Bdc = (dc&BMASK) >> BSHFT; 
			
			Uint32 Rfc = cmerge(Rsc, Rdc, ALPHA)<<RSHFT;
			Uint32 Gfc = cmerge(Gsc, Gdc, ALPHA)<<GSHFT;
			Uint32 Bfc = cmerge(Bsc, Bdc, ALPHA)<<BSHFT;
			
			const Uint32 ColorFinal = Rfc + Gfc + Bfc;
			
			*screen = ColorFinal;
			screen++; soff++;
		}
	}
}

// Calcule les coordonnes camera/objets et affichage
void marche::go(Uint32 *screen, Uint32 time)
{
	if(!launchtime)launchtime=time;
	Uint32 delta = time-launchtime;
	delta = (delta%799)/200 +1;

	SDL_Surface *sarah = NULL;
	switch(delta) {
	case 1:sarah = rd->getTexture(sprite1);break;
	case 2:sarah = rd->getTexture(sprite2);break;
	case 3:sarah = rd->getTexture(sprite3);break;
	case 4:sarah = rd->getTexture(sprite4);break;
	}
	assert(sarah);
	LowDrawAlpha(screen, (Uint32*)(sarah->pixels), 480, 640);
}
