; #define src	8(%ebp)
; #define sw	12(%ebp)
; #define dst	16(%ebp)
; #define dw	20(%ebp)
; #define w	24(%ebp)
; #define h	28(%ebp)
; #define cm	32(%ebp)
	
global mmx_blend_rgba_to_rgba
global mmx_blend_rgba_to_rgb
global mmx_add_blend_rgba_to_rgb
global mmx_add_blend_rgba_to_rgba
global mmx_findColorAdd
	
	;; 8:	 sc
	;; 12:	 dc
	;; 16:	 csub
mmx_findColorAdd:
	push ebp
	mov ebp,esp
;	push ebx

	movd mm2, [ebp+16]	; mm2:	 csub	
	movd mm0, [ebp+8]	;  source
	movd mm1, [ebp+12]	;  dest

;   test cvs
;	mov eax, 255		;  alpha        ; On ne tiens plus en compte l'alpha
;   	mov ebx, [ebp+8]	;		  dynamiquement
;	shr ebx, 24
;	sub eax, ebx		; 255 - alpha
;	movd mm2, eax 		; mm2:	 alpha
;	movd mm3, [ebp+16]	; mm3:	 csub
;	paddusb mm2,mm3		; mm2:	 alpha+csub

	punpcklbw mm2,mm2	; mm2:	 00'00|00'aa
	punpcklwd mm2,mm2	; mm2:	 00'00|aa'aa

	psubusb mm0, mm2	; mm0:	src - alpha
	paddusb mm0, mm1	; mm0:	dest + (src - alpha)

	movd eax, mm0		; return dest

;	pop ebx
	pop ebp
	ret	
		
m0X000000 db 0,0,0,0,0,0,255,0 
m10000000 db 0,0,0,0,0,0,0,1
m00XXXXXX db 255,255,255,255,255,255,0,0
mVX000000 db 0,0,0,0,0,0,255,127
mV0000000 db 0,0,0,0,0,0,0,128
m0XXX0XXX db 255,255,255,0,255,255,255,0
mX000X000 db 0,0,0,255,0,0,0,255
m10001000 db 0,0,0,1,0,0,0,1
m000V0V0V db 127,0,127,0,127,0,0,0
mI0000000 db 0,0,0,0,0,0,0,64
m0VVV0VVV db 127,127,127,0,127,127,127,0
c1        dw 01h,01h,01h,01h

; mmx_blend_rgba_to_rgba
mmx_blend_rgba_to_rgba:

; save registers 
	push ebp
	mov  ebp,esp
	;push ebx
	;push ecx
	;push edx
	;push edi
	;push esi
; set registers 
	mov edx,[ebp+28]	; h
	mov ebx,[ebp+24]	; w
	mov esi,[ebp+8]		; src
	mov edi,[ebp+16]	; dst
	shl ebx,2
	lea esi,[esi+ebx]	; src + 4w
	lea edi,[edi+ebx]	; dst + 4w
	neg ebx			; w
	neg ebx
	jz short @leave
	dec edx			; h--
	jz short @leave
; set mmx registers
	pxor mm4,mm4
	movq mm5,[m0X000000]
	movq mm6,[m00XXXXXX]
	movq mm7,[c1]

; h loop
	@loop:
		mov ecx,ebx		; w

	; w loop
		@MMX_loop:
		; Load source and destination
			movd mm1,[esi+ecx]	; src
			movd mm2,[edi+ecx]	; dst

		; Get alpha from source and target, a = src + (255 - dest)
			movq mm3,mm2		; mm3 = dst
			pxor mm3,mm6		; dst xor 00XXXXXX (255 - dest)
			paddusb mm3,mm1		; + src   ->> mm3
	
		; Unpack/copy to eight bytes
			punpcklbw mm3, mm3
			punpckhwd mm3, mm3
			punpckhdq mm3, mm3
			psrlw mm3,1		;  $1 ????

		; Unpack source and destination, bytes to words
			punpcklbw mm1,mm4
			punpcklbw mm2,mm4

		; Separate alpha channel
			movq mm0,mm1
			pand mm0,mm5

		; d = d + (a * ((s - d) + 0.5))
			psubw mm1,mm2		; s - d
			psllw mm1,1		; shift $1 ????
			paddw mm1,mm7		; Roundoff
			pmulhw mm1,mm3		; * a

		; Replace alpha channel with separated out version in mm0 and add
			pand mm1,mm6
			por mm1,mm0
			paddw mm2,mm1

		; Pack into lower 4 bytes and save
			packuswb mm2,mm4
			movd [edi+ecx], mm2
 
			sub ecx,4
			jns @MMX_loop

	; loop_end:
		mov ecx,[ebp+12]	; sw
		lea esi,[esi+ecx*4]
		mov ecx,[ebp+20]	; dw
		lea edi,[edi+ecx*4]
		dec edx
		jns @loop

; reset registers
@leave:
	emms
	;pop esi
	;pop edi
	;pop edx
	;pop ecx
	;pop ebx
	mov esp,ebp
	pop ebp
	ret




mmx_blend_rgba_to_rgb: 
; save registers 
	push ebp
	mov  ebp,esp
; set registers 
	mov eax,[ebp+12]	; sw		source width
	shl eax,2		; sw * 4	 = eax

	mov ebx,[ebp+24]	; w		width to blend
	shl ebx,2		; w * 4		 = ebx
	jz short @leave2	; leave if 0
	
	mov edx,[ebp+28]	; h		height to blend
	dec edx			; h--		 = edx
	jz short @leave2	; leave if 0
	
	mov esi,[ebp+8]		; src pointer
	mov edi,[ebp+16]	; dst pointer
	
	; lea esi,[esi+ebx]	; src = src + w
	; lea edi,[edi+ebx]	; dst = dst + w
	
        pxor mm4,mm4		; mm4 = 0x0000000000000000
        movq mm5,[c1]		; mm5 = 0x001H001H001H001H
	
	@loop2:
		mov ecx,ebx		; w
		@MMX_loop2:
		; Load source and destination
			movd mm1,[esi+ecx]	; mm1 = [src + w]
			movd mm2,[edi+ecx]	; mm2 = [dst + w]
			movq mm3,mm1		; mm3 = src
	
			punpcklbw mm3,mm3	; unpack src
			punpckhwd mm3,mm3
			punpckhdq mm3,mm3
			movq mm3, [ebp+32] 
			psllq mm3,24 
			;psrlw mm3,2
			; psrlq mm3,16
			punpcklbw mm1,mm4
			punpcklbw mm2,mm4
			psubw mm1,mm2
			psllw mm1,1
			pmulhw mm1,mm3
			paddw mm2,mm1
			packuswb mm2,mm4	; pack mm4 -> mm2
			movd [edi+ecx],mm2	; [dst + w] = mm2
			sub ecx,4		; w - 4
			jge @MMX_loop2
	; loop_end:
		add esi,eax		; src + sw	ligne suivante 

		mov ecx,[ebp+20]	; dw
		lea edi,[edi+ecx*4]	; dst + dw	ligne suivante
	
		dec edx			; h--
		jnz @loop2
; reset registers
@leave2:
	;emms
	mov esp,ebp
	pop ebp
	ret

; *************************************************************************

mmx_add_blend_rgba_to_rgb: 
; save registers 
	push ebp
	mov  ebp,esp
; set registers 
	mov eax,[ebp+12]	; sw		source width
	shl eax,2		; sw * 4	 = eax

	mov ebx,[ebp+24]	; w		width to blend
	shl ebx,2		; w * 4		 = ebx
	jz short @leave3	; leave if 0
	
	mov edx,[ebp+28]	; h		height to blend
	dec edx			; h--		 = edx
	jz short @leave3	; leave if 0
	
	mov esi,[ebp+8]		; src pointer
	mov edi,[ebp+16]	; dst pointer
	
	; lea esi,[esi+ebx]	; src = src + w
	; lea edi,[edi+ebx]	; dst = dst + w
	
        pxor mm4,mm4		; mm4 = 0x0000000000000000
        movq mm5,[c1]		; mm5 = 0x001H001H001H001H
	
	@loop3:
		mov ecx,ebx		; w
		@MMX_loop3:
		; Load source and destination
			movd mm1,[esi+ecx]	; mm1 = [src + w]
			movd mm2,[edi+ecx]	; mm2 = [dst + w]
			
			movq mm3,mm1		; mm3 = src
	
			punpcklbw mm3,mm3	; unpack src
			punpckhwd mm3,mm3
			punpckhdq mm3,mm3
			psrlw mm3,1
			psrlq mm3,16
			punpcklbw mm1,mm4
			punpcklbw mm2,mm4

			; d = d + (a * s) \*/"
			psllw mm1,1
			pmulhw mm1,mm3
			paddw mm2,mm1

			packuswb mm2,mm4	; pack mm4 -> mm2
			movd [edi+ecx],mm2	; [dst + w] = mm2
			sub ecx,4		; w - 4
	
			jge @MMX_loop3
	; loop_end:
		add esi,eax		; src + sw	ligne suivante 

		mov ecx,[ebp+20]	; dw
		lea edi,[edi+ecx*4]	; dst + dw	ligne suivante
	
		dec edx			; h--
		jnz @loop3
; reset registers
@leave3:
	;emms
	mov esp,ebp
	pop ebp
	ret


; *************************************************************************

mmx_add_blend_rgba_to_rgba: 
; save registers 
	push ebp
	mov  ebp,esp
; set registers 
	mov eax,[ebp+12]	; sw		source width
	shl eax,2		; sw * 4	 = eax

	mov ebx,[ebp+24]	; w		width to blend
	shl ebx,2		; w * 4		 = ebx
	jz short @leave4	; leave if 0
	
	mov edx,[ebp+28]	; h		height to blend
	dec edx			; h--		 = edx
	jz short @leave4	; leave if 0
	
	mov esi,[ebp+8]		; src pointer
	mov edi,[ebp+16]	; dst pointer
	
	; lea esi,[esi+ebx]	; src = src + w
	; lea edi,[edi+ebx]	; dst = dst + w
	
        pxor mm4,mm4		; mm4 = 0x0000000000000000
        movq mm5,[c1]		; mm5 = 0x001H001H001H001H
	
	@loop4:
		mov ecx,ebx		; w
		@MMX_loop4:
		; Load source and destination
			movd mm1,[esi+ecx]	; mm1 = [src + w]
			movd mm2,[edi+ecx]	; mm2 = [dst + w]
			
			movq mm3,mm1		; mm3 = src
	
			punpcklbw mm3,mm3	; unpack src
			punpckhwd mm3,mm3
			punpckhdq mm3,mm3
			psrlw mm3,1
			
			; Make the alpha value that gets multiplied to the"
			; alpha channels 0x7fff, so the resulting alpha value is"
			; the sum of the source and destination alpha values."
			por mm3,mm5 
			
			punpcklbw mm1,mm4
			punpcklbw mm2,mm4

			; d = d + (a * s) \*/"
			psllw mm1,1
			pmulhw mm1,mm3
			paddw mm2,mm1

			packuswb mm2,mm4	; pack mm4 -> mm2
			movd [edi+ecx],mm2	; [dst + w] = mm2
			sub ecx,4		; w - 4
	
			jge @MMX_loop4
	; loop_end:
		add esi,eax		; src + sw	ligne suivante 

		mov ecx,[ebp+20]	; dw
		lea edi,[edi+ecx*4]	; dst + dw	ligne suivante
	
		dec edx			; h--
		jnz @loop4
; reset registers
@leave4:
	;emms
	mov esp,ebp
	pop ebp
	ret

