// Moteur 3d de Ced

#include <vector>
#include <iostream>

#include <stdlib.h>
#include "effets.h"
#include "Render.h"
#include "3DPath.h"
#include <stdio.h>

// Constructeur
move_cam::move_cam(Render *rd)
{
	this->rd = rd;
	char buf[256];

	FILE *conf = fopen(PATH_OTHER "camera.cfg","r");
	int line = 0;
	if(!conf) {
		cout << "[** ERROR **] missing data/other/camera.cfg" << endl;
		path.push(      0,  0.0,0.0,-2000.0,   0.0,0.0,0.0,  0.0,1.0,0.0);
		path.push(9999999,  0.0,0.0,-2000.0,   0.0,0.0,0.0,  0.0,1.0,0.0);
	} else while(!feof(conf)) {
		line++;
		pos_t p;
		fgets(buf,255,conf);
		if( sscanf(buf,"%d %f %f %f %f %f %f %f %f %f",&p.time,
				   &p.eye[0],&p.eye[1],&p.eye[2],
				   &p.ref[0],&p.ref[1],&p.ref[2],
				   &p.up[0],&p.up[1],&p.up[2]) == 10 ) {
			path.push(p);
			//cout << "new cam conf line" << endl;
		}
		else if(buf[0]!='#') cout << "[** WARNING **] invalid line ["<<line<<"] in camera.cfg" << endl;
	}

	fclose(conf);
	/*
	//avion
	path.push(    0,  3000,   0, 3000,   0,0,0,  0,1,0);
	path.push( 5000,     0,3000, 3000,   0,0,0,  0,1,0);
	path.push(10000, -3000,   0, 3000,   0,0,0,  0,1,0);

	// fireball
	//path.push(    0,   0.0,   0.0, -800.0,   0,0,0,   0,1,0);
	//path.push( 2000,   0.0, 800.0, -800.0,   0,0,0,   0,1,0);
	//path.push( 4000, 800.0,   0.0,    0.0,   0,0,0,   0,1,0);

	// scroll_miroir
	const float offset = 480.0*3;
	path.push(    0,  0.0,  offset, -800.0,   0, offset,0,   0,1,0);
	path.push( 2000,  0.0,     0.0, -2000.0,   0,      0,0,   0,1,0);
	path.push( 4000,  0.0, -offset, -800.0,   0,-offset,0,   0,1,0);
	*/
}

// Destructeur
move_cam::~move_cam() { }

// Calcule les coordonnes camera/objets et affichage
void move_cam::go(Uint32 time)
{
	pos_t pos;
	if(!path.getpos(time,pos)) {
		fVector eye = {0.0,0.0,-1000.0};
		fVector ref = {0.0,0.0,0.0};
		fVector up = {0.0,1.0,0.0};
		rd->LookAt(eye,ref,up);
	} else {
	  rd->LookAt(pos.eye,pos.ref,pos.up);
	  // marche pas
	  //rd->LookAt(pos.eye, pos.ref, -M_PI/2);
	}
}
