// Moteur 3d de Ced

#include "effets.h"

// Constructeur
move_tex::move_tex( float txw, float txh, float w, float h )
{
	xangle = 0.0;
	yangle = 0.0;
	zangle = 0.0;
	ztrans = 0.0;

	bzero( texplan, 4*2*3*4 );
	texplan[0][0][1] = txh-1.0;
	texplan[0][1][0] = txw-1.0;
	texplan[0][1][1] = txh-1.0;
	texplan[0][2][0] = txw-1.0;

	texplan[1][0][1] = txh-1.0;
	texplan[1][1][0] = txw-1.0;

	bzero( plan, 4*2*3*4 );
	plan[0][0][0] = -w/2;
	plan[0][0][1] =  h/2-1.0;
	plan[0][1][0] =  w/2-1.0;
	plan[0][1][1] =  h/2-1.0;
	plan[0][2][0] =  w/2-1.0;
	plan[0][2][1] = -h/2;
	plan[0][3][0] = -w/2;
	plan[0][3][1] = -h/2;

	plan[1][0][0] = -w/2;
	plan[1][0][1] =  h/2-1.0;
	plan[1][1][0] =  w/2-1.0;
	plan[1][1][1] = -h/2;
	plan[1][2][0] = -w/2;
	plan[1][2][1] = -h/2;

	// pre translation
	px1 = 0; py1 = 0; pz1 = 0;

}

// Destructeur
move_tex::~move_tex() { }

// Calcule les coordonnes camera/objets et affichage
void move_tex::go(Uint32 *screen, Uint32 *buffer, Uint32 time)
{
	xangle = time*0.0005;
	yangle = time*0.0003;
	zangle = time*0.0008;	
	ztrans = 10+time*0.8; 

	if (px1<75.0) px1 ++;
	if (py1<75.0) py1 ++;
	
	// ################## MATRICE MOUVEMENTS ############# //
	f_make_identity_matrix( tm );
	//f_trans_matrix( tm, px1, py1, -10.0 );

	f_make_xyzrot_matrix(rm, xangle, yangle, zangle);

	f_ConcatMatrices( rm, tm, m );

	f_trans_matrix( m, 0, 0, ztrans );
	// ################## FIN MATRICE #################### //

	asm_emms();
	for(int i=0; i<4; i++ ){
	  f_XformVector( m, plan[0][i], ntri[i] );
	  float z = 1000.0 / (ntri[i][2] + 500);
	  ntri[i][0] *= z;
	  ntri[i][1] *= z;
	}

	for (int i=0; i<4; i++) {
	  for (int j=0; j<2; j++) {
	    intri[i][j] = (int) (ntri[i][j]*65536);
	    itexplan[0][i][j] = (int) (texplan[0][i][j]*65536);
	  }
	}
	const int options = CULL_FACE /* |TRANSPARENCY */ | BILINEAR_FILT ;
	render_tri( screen, intri, itexplan[0], buffer, 640, 480, options, 4 );
}

// end of move_tex.cc
