// Cube rempli d'toiles...
// Genre de particules quoi...

#include <string>
#include "effets.h"
#include "assert.h"

static parts *instance;

// ************
// Constructeur
// ************

parts *parts::getInstance() {
		return instance;
}

// Simplification d'ecriture  mettre ailleurs ventuellement...
static inline Uint32 ConvertPixel(const Uint32 src, 
		const Uint32 srcformat, const Uint32 srcshift, const Uint32 SHIFT)
{
	const Uint32 ret = ( (src&srcformat) >> srcshift ) << SHIFT;
	return ret;
}

// Calcul offset
static int co(int y, int x, int W)
{
  return x+ (y*W);
}

static Uint32 Moy(Uint32 *old, int x, int y, int W, Uint32 MASK)
{
  Uint32 a =
    (old[co(y *2, x*2, W) ]&MASK) + 
    (old[co(y   *2, (x*2)+1, W) ]&MASK) + 
    (old[co(y*2+1, x*2, W)]&MASK) + 
    (old[co(y*2+1, (x*2)+1, W)]&MASK) ;
  const float LIGHT = 0.9;
  float b = (a*LIGHT) /4.0;
  int i = (int) b;

  int IMASK = MASK;
  if (i>IMASK) i=IMASK;
  if (i<IMASK>>8) i = (IMASK>>8);
  return i&IMASK;
} 

parts::parts(Render *rd, char* path)
{
	this->rd = rd;
	instance = this;
	Xcam = 0.0;
	Ycam = 0.0;
	Zcam = 0.0;
	Xang = 0.0;
	Yang = 0.0;
	Zang = 0.0;

	SDL_Surface *partextmp = IMG_Load(path);
	if( !partextmp ){printf("Couldn't open ... %s\n",path ); fflush(stdout);}
	// Allocation des surfaces
	for (int i=0; i<NB_MIP; i++) {
	  int W = partextmp->w>>i; if (W==0) W=1;
	  int H = partextmp->h>>i; if (H==0) H=1;
	  StarMip[i] = SDL_CreateRGBSurface (SDL_SWSURFACE, W, H, 32,0xFF0000,
					 0xFF00, 0xFF,0xFF000000);
	}
	partex = StarMip[0];

	LOCK_SURFACE(partextmp);
	LOCK_SURFACE(partex);

	Uint32 *src = (Uint32 *)partextmp->pixels;
	Uint32 *dst = (Uint32 *)partex->pixels;
	for (int i=0; i<partextmp->w*partextmp->h; i++) {
	  SDL_PixelFormat &sf = *(partextmp->format);
	  assert (partextmp->format != 0);
	  assert (partextmp->format->BytesPerPixel == 4);

	  int point = 
	    ConvertPixel(src[i], sf.Rmask, sf.Rshift, RSHFT) + 
	    ConvertPixel(src[i], sf.Gmask, sf.Gshift, GSHFT) +
	    ConvertPixel(src[i], sf.Bmask, sf.Bshift, BSHFT) +
	    ConvertPixel(src[i], sf.Amask, sf.Ashift, ASHFT);

	  dst[i] = findColorAdd(point, 0, 0);

	  assert (dst != 0);
	}

	UNLOCK_SURFACE(partex);
	UNLOCK_SURFACE(partextmp);
	SDL_FreeSurface (partextmp);

	// Cration du MipMap
	for (int i=1; i<NB_MIP; i++) {
	  SDL_Surface *Smip = StarMip[i];
	  SDL_Surface *Sold = StarMip[i-1];
	  LOCK_SURFACE(Smip);
	  LOCK_SURFACE(Sold);
	  Uint32 *mip = (Uint32*) Smip->pixels;
	  Uint32 *old = (Uint32*) Sold->pixels;
	  int W = Smip->w;
	  int H = Smip->h;
	  int offset = 0;
	  for (int y=0; y<H; y++) {
	    for (int x=0; x<W; x++) {
	      Uint32 Red = Moy(old, x, y, Sold->w, RMASK);
	      Uint32 Green = Moy(old, x, y, Sold->w, GMASK);
	      Uint32 Blue = Moy(old, x, y, Sold->w, BMASK);
	      mip[offset++] = Red | Green | Blue;
	    }
	  }
	  UNLOCK_SURFACE(Sold);
	  UNLOCK_SURFACE(Smip);
	}

	fMatrix tm, rm, m;
	fVector t_part;

	// position originale des sprites
	float f = 0;
	for (int i=0; i<NB_PLOT; i++) {
	  f += 2*M_PI/NB_PLOT;

	  f_make_identity_matrix( rm );
	  f_append_xrot_matrix( rm, 0 );
	  f_append_yrot_matrix( rm, 0 );
	  f_append_zrot_matrix( rm, f );
	  
	  
	  f_make_identity_matrix( tm );
	  f_trans_matrix( tm, 800, 0, 0 );
	  
	  // d'abord la rotation
	  // ensuite la translation
	  f_ConcatMatrices( rm, tm, m );

	  float R=0; const int IG=20;
	  for (int t=0; t<IG; t++) {
	    R += rand()%400;
	  }
	  R /= IG;

	  float a = rand()%1000;
	  t_part[0] = R*sin(a);
	  t_part[1] = 0;
	  t_part[2] = R*cos(a);
	  f_XformVector( m, t_part, plot[i] );
	  
	}
}

// ***********
// Destructeur
// ***********

parts::~parts()
{
  for (int i=1; i<NB_MIP; i++) {
    assert(StarMip[i]!=0);
    SDL_FreeSurface(StarMip[i]);
    partex = 0;
  }
}

// ********************
// Fonctions de l'effet
// ********************
void parts::go( Uint32 *buffer, Uint32 time )
{

	  /*  for( int i=0; i<NB_PLOT; i++) {
    rd->push(1,&plot[i],NULL,0,TRANSPARENCY);
    }*/

	rd->push_matrix();
	rd->rotate(M_PI/2, time/2000.0, 0.0);
	for( int i=0; i<NB_PLOT; i++) {
		rd->push(1,&plot[i],NULL,0,TRANSPARENCY);
	}
	rd->pop_matrix();
}

void parts::putPart2(Uint32 *pscreen, iVector pos)
{
	pos[0] = pos[0]>>16;
	pos[1] = pos[1]>>16;
	pos[2] = pos[2]>>16;

	float z = pos[2];
	//const int CLIPZ = 0.001;
	// Rendu
	const int DF=30;
	float a = 255/DF;
	float p = 255;
	float attenuate = -a*z + p;
	const int att = (const int) CLAMP(attenuate,0,255);
	
	const float tmp = 1000.0/(z+800);
	
	putPart(pscreen, (int) pos[0] + 320, (int) pos[1] + 240, 
		(int) (1024*tmp - 450), att, 0x2  );
}

// ********************************
// Fonctions d'affichage bas niveau
// ********************************

bool parts::do_clip(int &sleft, int &sright, int &count,
			 int &dleft_add, int &dright_add,
			 int &t, const int SIZE,
			 const int DRIGHT_LIM, const int DLEFT_LIM=0)
{
  sleft = 0; sright = SIZE;

  if ( t >= DRIGHT_LIM ) {return false;} // ----|----|-xxx
  if ( t >= DRIGHT_LIM - SIZE ) {		  // ----|---x|xx--
    sright = DRIGHT_LIM-t;	
  }

  if ( t < DLEFT_LIM - SIZE ) {		  // xxx-|----|----
    return false;
  } 
  if ( t < DLEFT_LIM ) {		  // --xx|x---|----
    sleft = DLEFT_LIM - t;
  }

  count = sright-sleft;
  if (count <= 0) { return false; }

  dleft_add = DLEFT_LIM + t;
  if (dleft_add < DLEFT_LIM) {dleft_add = DLEFT_LIM;}
  dright_add = DRIGHT_LIM - (dleft_add + count);

  assert (dright_add >=0);
//	if (dright_add < 0) dright_add = 0;

  return true;
}

inline Uint32 parts::cmerge(const int src, const int dst, const int ALPHA) const 
{
  const int ret = ( src*(ALPHA) + dst*(255-ALPHA) ) >> 8;
  assert (ret >= 0 && ret <= 255);	// to be removed
  return ret;
}

inline Uint32 parts::cadd(const int src, const int dst, int sub) const
{
  int rsub = src - sub;
  int ret = dst + CLAMP(rsub,0,255);
  if (ret > 255) ret = 255;
  assert (ret >= 0 && ret <= 255);	// to be removed
  return ret;
}

// findColorAdd: dtermine la couleur finale en fonction de l'image source et
//               de l'image de destination
// le pixel source est assombrie de csub, puis ajout  la destination.
// Les composantes Rouges Vertes et Bleues sont traites sparments.
inline Uint32 parts::findColorAdd(const Uint32 sc, const Uint32 dc, const Uint32 csub) const
{
  Uint32 Rsc = (sc&RMASK) >> RSHFT; Uint32 Gsc = (sc&GMASK) >> GSHFT; 
  Uint32 Bsc = (sc&BMASK) >> BSHFT; 
  Uint32 alpha = 255 - ( (sc&AMASK) >> ASHFT );
  alpha += csub;

  Uint32 Rdc = (dc&RMASK) >> RSHFT; Uint32 Gdc = (dc&GMASK) >> GSHFT; 
  Uint32 Bdc = (dc&BMASK) >> BSHFT; 

  Uint32 Rfc = cadd(Rsc, Rdc, alpha)<<RSHFT;
  Uint32 Gfc = cadd(Gsc, Gdc, alpha)<<GSHFT;
  Uint32 Bfc = cadd(Bsc, Bdc, alpha)<<BSHFT;
      
  return Rfc + Gfc + Bfc;
}

// z>=256 (bilinear filtering)
// sub: 0 ajoute  fond   (color substract)
//      255 transparent
// on fait tout en ajout
void parts::LowDrawAlphaAddBiFilt(Uint32 doff, Uint32 soff, 
			    const int ycount, const int xcount, 
			    const int xdadd,
			    const int z,    // 256*trop grand
			    const int csub)
{
  const int W = partex->w;
  const int H = partex->h;
  const int W4 = W*4;

  Uint32* pixels = (Uint32*) partex->pixels;
  Uint32 zy = 0;
  int csub2 = csub+(csub<<8)+(csub<<16);
  Uint32 *sptr = pscreen+doff;
  for (int y=0; y<ycount; y++) {
    Uint32 zx = 0;

    int zyi = (zy>>8);
    int zyf = zy&255;
    Uint32 zy2 = soff + zyi*W;
    if (zyi>=H-1) return; 
    
    Uint32 *soff2 = pixels +  zy2;

    // on fait toute une scanline d'un coup
    mmx_pixfilt2(sptr, soff2, W4, z, zyf, csub2, zx, xcount);

    zy += z;
    sptr += 640; // XXX pour etre propre, avoir la taille de l'cran serait mieux
  }
  asm_emms();
}


// normal (pas de mip ni bifilt)
// sub: 0 ajoute  fond   (color substract)
//      255 transparent
// on fait tout en ajout
void parts::LowDrawAlphaAdd(Uint32 doff, Uint32 soff, 
			    const int ycount, const int xcount, 
			    const int xdadd,
			    const int z,    // 256*trop grand
			    const int csub)
{
  const int W = partex->w;

  Uint32* pixels = (Uint32*) partex->pixels;
  Uint32 zy = 0;
  for (int y=0; y<ycount; y++) {
    Uint32 zx = 0;

    int zyi = (zy>>8);
    //    if (zyi>=partex->h) return;

    Uint32 zy2 = soff + zyi*W;
    for (int x=0; x<xcount; x++) {
      Uint32 soff2 = (zx>>8) + zy2;
      const Uint32 sc = pixels[soff2];	// image (source)
      const Uint32 dc = pscreen[doff];	// screen (dest)
 
      pscreen[doff++] = mmx_findColorAdd(sc,dc, csub);
      zx += z;
    }
    zy += z;
    doff += xdadd;
  }
  asm_emms();
}

// z<256 (mipmapping)
// sub: 0 ajoute  fond   (color substract)
//      255 transparent
// on fait tout en ajout
void parts::LowDrawAlphaAddMipMap(Uint32 doff, Uint32 soff, Uint32 soff2,
			    const int ycount, const int xcount, 
			    const int xdadd,
			    const int z,    // 256*trop grand
			    const int csub, const int depth)
{
  const int W = partex->w;
  const int W_ = partex2->w;

  const int idepth = 255-depth;

  Uint32* pixels = (Uint32*) partex->pixels;
  Uint32* pixels_ = (Uint32*) partex2->pixels;
  Uint32 zy = 0;
  for (int y=0; y<ycount; y++) {
    Uint32 zx = 0;

    int zyi = (zy>>8);
    int zyi_ = (zy>>9);
    //    if (zyi>=partex->h) return;

    Uint32 zy2 = soff + zyi*W;
    Uint32 zy2_ = soff2 + zyi_*W_;
    for (int x=0; x<xcount; x++) {
      Uint32 src_off = (zx>>8) + zy2;
      Uint32 src_off_ = (zx>>9) + zy2_;
      const Uint32 sc = pixels[src_off];
      const Uint32 sc_ = pixels_[src_off_];
      const Uint32 scrf = ( (sc&RMASK)*depth + (sc_&RMASK)*idepth ) >> 8;
      const Uint32 scgf = ( (sc&GMASK)*depth + (sc_&GMASK)*idepth ) >> 8;
      const Uint32 scbf = ( (sc&BMASK)*depth + (sc_&BMASK)*idepth ) >> 8;

      const Uint32 scf = (scrf&RMASK) + (scgf&GMASK) + (scbf&BMASK);    // image (source)
      const Uint32 dc = pscreen[doff];	// screen (dest)
 
      pscreen[doff++] = mmx_findColorAdd(scf,dc, csub);
      zx += z;
    }
    zy += z;
    doff += xdadd;
  }
  asm_emms();
}



void parts::LowDrawAlpha(Uint32 doff, Uint32 soff,
			 const int ycount, const int xcount, 
			 const int xsadd, const int xdadd )
{
  Uint32* pixels = (Uint32*) partex->pixels;
  for (int y=0; y<ycount; y++) {
    for (int x=0; x<xcount; x++) {
      const Uint32 sc = pixels[soff];	// image (source)
      const Uint32 dc = pscreen[doff];	// screen (dest)
      Uint32 Rsc = (sc&RMASK) >> RSHFT; Uint32 Gsc = (sc&GMASK) >> GSHFT; 
      Uint32 Bsc = (sc&BMASK) >> BSHFT; 
      const Uint32 ALPHA = (sc&AMASK) >> ASHFT;

      Uint32 Rdc = (dc&RMASK) >> RSHFT; Uint32 Gdc = (dc&GMASK) >> GSHFT; 
      Uint32 Bdc = (dc&BMASK) >> BSHFT; 

      Uint32 Rfc = cmerge(Rsc, Rdc, ALPHA)<<RSHFT;
      Uint32 Gfc = cmerge(Gsc, Gdc, ALPHA)<<GSHFT;
      Uint32 Bfc = cmerge(Bsc, Bdc, ALPHA)<<BSHFT;

      const Uint32 ColorFinal = Rfc + Gfc + Bfc;

      pscreen[doff] = ColorFinal;
      doff++; soff++;
    }
    soff += xsadd;
    doff += xdadd;
  }
}

// depth: 0..256  0: mip1
//               256: mip2
// sort of trilinear filtering
int parts::CalcMip(int Z, float &fZ, int &depth) const
{
  int mipLevel = 0;
  depth = 0;
  if (Z<256) {
    for (mipLevel=1; mipLevel<NB_MIP; mipLevel++) {  // NB_MIP - 1 car on a l'image suivante 
      int Z2 = 256>>mipLevel;
      int Z3 = 256>>(mipLevel-1);
      fZ *= 2;
      if (Z>=Z2 && Z<Z3) {
	//depth = ( (Z-Z2)*256 ) / ( Z3-Z2 );
	return mipLevel;
      }
    }
  }
  return mipLevel;
}

bool parts::prep_draw( int &X, int &Y,
		      Uint32 &doff, Uint32 &soff, int &ycount, int &xcount, int &xdadd,
		      float &fZ, Uint32 &soff2)
{
  const int SW = 640;
  const int SH = 480;

  int oldW= partex->w; int oldH= partex->h;
  int W = (int) (oldW*fZ); int H = (int) (oldH*fZ);

  // center of sprite
  X -= W/2;
  Y -= H/2;

  int xsl, xsr, xdla, xdra;
  int ysl, ysr, ydla, ydra;

  bool is_clipX = do_clip(xsl, xsr, xcount, xdla, xdra, X, W, SW);
  if (is_clipX==false) { return false; }
  bool is_clipY = do_clip(ysl, ysr, ycount, ydla, ydra, Y, H, SH);
  if (is_clipY==false) { return false; }

  xdadd = xdla+xdra;
  assert (xdadd >= 0);
  
  doff=xdla + ydla*SW;

  // puis retrouver pixel sur ecran
  const float invZ = 1.0/fZ;
  xsl = (int) ( xsl*invZ );
  ysl = (int) ( ysl*invZ );

  if (xsl<0 || xsl>=oldW || ysl<0 || ysl>=oldH) return false;

  soff= xsl + ysl*oldW;
  soff2 = (xsl>>1) + (ysl>>1)*(oldW>>1);

  return true;
}

// Affiche une particule depuis son centre
void parts::putPart(Uint32* screen_buffer, int X, int Y, const int Z, const int INV_POWA, const int options)
{
  float fZ = Z/256.0;

  int depth = -1;
  const bool is_mipmap = options&MIPMAP != 0;
  if (is_mipmap) {
    int mipLevel = CalcMip(Z, fZ, depth);
    partex = StarMip[mipLevel];
    //partex2 = StarMip[mipLevel+1];
  }
  else {
    partex = StarMip[0];
    //partex2 = 0;
  }

  int X_ = X, Y_ = Y;
  Uint32 doff, soff, soff2;  // dest, src1, src2 (mipmap)
  int xcount, ycount;
  int xdadd;
  if (!prep_draw(X_,Y_,doff,soff,ycount,xcount,xdadd,fZ, soff2)) return;

  assert  (screen_buffer!=0);
  pscreen = screen_buffer;

  // Lock screen before drawing
  LOCK_SURFACE(partex);
  LowDrawAlphaAddBiFilt(doff, soff, ycount, xcount, xdadd, (int)(256.0/fZ), INV_POWA);
  UNLOCK_SURFACE(partex);
}


