/* Quaternions */

// je suis pas un expert
// il s'agit d'un test

#include <math.h>
#include <iostream>
#include "quat.h"
#include "f3Dutils.h"

void Quat::CreateFromAxis(float X, float Y, float Z, float angle)
{
  const float cos_a = cos (angle * 0.5);
  const float sin_a = sin (angle * 0.5);

  w = cos_a;
  x = X * sin_a;
  y = Y * sin_a;
  z = Z * sin_a;
}

void Quat::CreateFromEuler( float ax, float ay, float az)
{
  Quat qy,qz;
  CreateFromAxis(1,0,0, ax);  // qx
  qy.CreateFromAxis(0,1,0, ay);
  qz.CreateFromAxis(0,0,1, az);

  mult(qy);
  mult(qz);
}

void Quat::mult( Quat q2)
{
  Quat q1;
  q1.x = x;
  q1.y = y;
  q1.z = z;
  q1.w = w;

  /*w = q1.w*q2.w - q1.x*q2.x - q1.y*q2.y - q1.z*q2.z;
  x = q1.w*q2.x + q1.x*q2.w + q1.y*q2.z - q1.z*q2.y;
  y = q1.w*q2.y + q1.y*q2.w + q1.z*q2.x - q1.x*q2.z;
  z = q1.w*q2.z + q1.z*q2.w + q1.x*q2.y - q1.y*q2.x;*/

  w = q1.w*q2.w + q1.x*q2.x + q1.y*q2.y + q1.z*q2.z;
  x = q1.w*q2.x + q1.x*q2.w + q1.y*q2.z + q1.z*q2.y;
  y = q1.w*q2.y + q1.y*q2.w + q1.z*q2.x + q1.x*q2.z;
  z = q1.w*q2.z + q1.z*q2.w + q1.x*q2.y + q1.y*q2.x;
}

void Quat::ToMatrix(fMatrix M)
{
  float xx = x*x;
  float xy = x*y;
  float xz = x*z;
  float xw = x*w;

  float yy = y*y;
  float yz = y*z;
  float yw = y*w;

  float zz = z*z;
  float zw = z*w;

  // 0 4 8
  // 1 5 9
  // 2 6 10
  // 3 7 11

  M[0]  = 1 - 2 * ( yy + zz );
  M[1]  =     2 * ( xy - zw );
  M[2]  =     2 * ( xz + yw );

  M[4]  =     2 * ( xy + zw );
  M[5]  = 1 - 2 * ( xx + zz );
  M[6]  =     2 * ( yz - xw );

  M[8]  =     2 * ( xz - yw );
  M[9]  =     2 * ( yz + xw );
  M[10] = 1 - 2 * ( xx + yy );

  M[3] = M[7] = M[11] = 0;
}

//  0<t<1, OMEGA = angle (A,B)
void Quat::Slerp(const Quat &A, const Quat &B, 
		 const float t)
{
  const float a = A.x * B.x + A.y * B.y + A.z * B.z + A.w * B.w;
  const float OMEGA = acos(a);

  const float LIM = 0.00000001;
  float scale1, scale2;
  if (fabs(OMEGA) <= LIM) {
    scale1 = 1-t;
    scale2 = t;
  }
  else {
    const float sinO = sin (OMEGA);
    scale1 = sin( OMEGA * (1-t) ) / sinO;
    scale2 = sin( OMEGA * t     ) / sinO;
    //   cout << scale1 << " " << scale2 << " " << t << endl;
  }

  x = A.x * scale1 + B.x * scale2;
  y = A.y * scale1 + B.y * scale2;
  z = A.z * scale1 + B.z * scale2;
  w = A.w * scale1 + B.w * scale2;
}
