/* Du sable */

#include <math.h>

#include "effets.h"
#include "blend.h"

#include "sable1.h"

#define ZMAX 1024
#define FOV	512.0
#define FOH 280.0
const int  LIFETOTMAX = (1 *1000);
const int  LIFETOTMIN = (   200);

int Sable::nb_inf;

void Sable::gen_star(t_s1 *s,float ft1)
{
  s->p0[0] = ( (float) ( (random()%1) - 5)/1000.0 )*FOV;
  s->p0[1] = ( (float) ( (random()%1) - 5)/1000.0 )*FOH;
  s->p0[2] = random()%ZMAX/50 + ZMAX/2;

  s->v0[0] = ((random()%2)-1.5)*0.02;
  s->v0[2] = (random()%1)*0.004;
  s->v0[1] = ((random()%1)-1)*0.002;

  s->a0[0] = 0;
  s->a0[1] = -0.0000;
  s->a0[2] = 0;

  s->lifetot = ((random()%(LIFETOTMAX-LIFETOTMIN))+LIFETOTMIN); // dure de vie en ms
  s->lifedeb = ft1;
  s->life = 0;

  s->intensite = 0;
  s->img = (random()%4)*32*32;
}

Sable::Sable(int nb, int cx, int cy)
{
  this->cx = cx; 
  this->cy = cy;
  part = new parts(0, PATH_2D "sable2.png");

  nb_star = nb;
  s1 = new t_s1[nb_star];
  // initialisation du sable
  for (int i=0; i<nb_star; i++) {
    gen_star(s1+i,random()%LIFETOTMAX);
  }
}

Sable::Sable(Sable *sable)
{
  if (this == sable) { 
    // se truc ne devrait pas arriver
    cout << "oups" << endl;
  }

  nb_inf++;

  cx = sable->cx;
  cy = sable->cy;
  sprite = sable->sprite;

  s1 = new t_s1[nb_star];
  // initialisation du sable
  for (int i=0; i<nb_star; i++) {
    gen_star(s1+i,random()%LIFETOTMAX);
  }
}

void Sable::pixel(int x, int y, Uint32 f,Uint32 *buffer, t_s1 *s)
{
  part->putPart(buffer, x, y, 32, f);
  asm_emms();
}

void Sable::update_star(t_s1 *s, float ft1)
{
  if (s->life>s->lifetot) { gen_star(s,ft1); }

  if (s->life < s->lifetot/5) {
    s->intensite = (float) s->life / (float) (s->lifetot/5);
  }
  else {
    s->intensite = 1 - (float) (s->life - s->lifetot/5)/ (float) ((s->lifetot*4)/5);
  }

  float t = ft1 - s->lifedeb;
  if (t>0) {
    s->life = t;
    float px = ((s->a0[0]*t + s->v0[0])*t) + s->p0[0]; 
    float py = ((s->a0[1]*t + s->v0[1])*t) + s->p0[1]; 
    float pz = ((s->a0[2]*t + s->v0[2])*t) + s->p0[2]; 

    s->p[0] = px;
    s->p[1] = py;
    s->p[2] = pz;
  } else {s->intensite = 0;}
}

// affiche tout ca  l'cran
int Sable::go(Uint32 time, Uint32 *buffer)
{
  float ft1 = (float) time*1.0;

  // update les particles
  for (int i=0; i<nb_star; i++) {
    update_star(s1+i, ft1);
  }

  // affichage
  for (int i=	0; i<nb_star; i++) {
    const float CMAX = 255.0;
    float fx=s1[i].p[0], fy=s1[i].p[1], fz=s1[i].p[2];
    int x=(int) (fx/fz) + 320 + cx, y=(int) (fy/fz) + 240 + cy;
    float force = 1 - s1[i].intensite;
    int c1 = (int) (CMAX * (force));
    if (c1>255) c1 = 255;
    if (c1<0) c1 = 0;
    pixel(x,y,c1, buffer,s1+i);
  }
  //mmx_blur(buffer, 639*479*4);
  //asm_emms();
  return 0;
}

Sable::~Sable()
{
  nb_inf--;
  delete[] s1;
  if (nb_inf == 0) {
    delete part;
  }
}
