// Moteur 3d de Ced

#include <vector>
#include <iostream>

#include <stdlib.h>
#include "effets.h"
#include "Render.h"
#include "lib3ds/material.h"
#include "Object.h"
#include "3DPath.h"

// Constructeur
sarah_feu::sarah_feu(Render *rd)
{
	launchtime = 0;
	this->rd = rd;
	sprite1 = rd->bind("buste-bg.jpg");
	sprite2 = rd->bind("buste-main.png");
}

// Destructeur
sarah_feu::~sarah_feu() { }

static inline Uint32 cmerge(const int src, const int dst, const int ALPHA)
{
        const int ret = ( src*(ALPHA) + dst*(255-ALPHA) ) >> 8;
        //assert (ret >= 0 && ret <= 255);        // to be removed
        return ret;
}

static void LowDrawAlpha(Uint32 *screen, Uint32 *soff,
						 const int ycount, const int xcount)
{
	for (int y=0; y<ycount; y++) {
		for (int x=0; x<xcount; x++) {
			const Uint32 sc = *soff;    // image (source)
			const Uint32 dc = *screen;                // screen (dest)
			Uint32 Rsc = (sc&RMASK) >> RSHFT; Uint32 Gsc = (sc&GMASK) >> GSHFT; 
			Uint32 Bsc = (sc&BMASK) >> BSHFT; 
			const Uint32 ALPHA = (sc&AMASK) >> ASHFT;
			
			Uint32 Rdc = (dc&RMASK) >> RSHFT; Uint32 Gdc = (dc&GMASK) >> GSHFT; 
			Uint32 Bdc = (dc&BMASK) >> BSHFT; 
			
			Uint32 Rfc = cmerge(Rsc, Rdc, ALPHA)<<RSHFT;
			Uint32 Gfc = cmerge(Gsc, Gdc, ALPHA)<<GSHFT;
			Uint32 Bfc = cmerge(Bsc, Bdc, ALPHA)<<BSHFT;
			
			const Uint32 ColorFinal = Rfc + Gfc + Bfc;
			
			*screen = ColorFinal;
			screen++; soff++;
		}
	}
}

// Calcule les coordonnes camera/objets et affichage
void sarah_feu::go(Uint32 *screen, Uint32 time)
{
	if(!launchtime)launchtime=time;
	Uint32 delta = time-launchtime;
	if(delta > 3000) delta=3000;
	delta = ((3000-delta)*480)/3000;
	
	SDL_Surface *sarah = rd->getTexture(sprite1);
	SDL_Surface *main = rd->getTexture(sprite2);
	mmx_quadcpy(sarah->pixels,screen,640*480/2);
	asm_emms();
	if(delta<480)
		LowDrawAlpha(screen+delta*640, (Uint32*)main->pixels, 480-delta, 640);
}
