BITS 32

global mmx_pixfilt2

; void pix_filt(Uint32 *screen, Uint32 *pa, Uint32 *pc, int dx, int dy, int d2)

; 8  : screen  
; 12 : soff	:	soff = pixels + zy2
; 16 : W	:	pc = pa+W
; 20 : z	:	zx += z
; 24 : dy
; 28 : d2	:	 transparence
; 32 : zxi	:	 (todo:	 zx:	 x<<8) 
; 36 : xcount
; 40 : 

align 16
	_FULL dd 0xFFFFFFFF,0xFFFFFFFF

mmx_pixfilt2:	
	push ebp
	mov ebp,esp
	push esi
	push edi
	push ebx
	
	; used: mm0, mm1, mm2, mm3, mm7, ebx, eax, edx, esi, edi

	mov edx, [ebp+32]	; edx:	zx
	mov edi,[ebp+8]		; edi:	screen
	mov ecx, [ebp+36]	; ecx:	xcount
	;; loop
_loop:	
	mov eax, edx		; eax:	zx
	shr eax,6		; eax:	zxi 8 - 2
	;shl eax,2		; eax*4, int
	and eax, 0xFFFFFFFC
	
	mov esi, [ebp+12]	; soff
	add esi, eax		; pc
	movq mm0, [esi] 	; mm0: b || a

	pxor mm7,mm7	
	movq mm1, mm0			; mm1: b || a
	punpcklbw mm1, mm7   ; mm1: 0'aa|0'ar||0'ag|0'ab
	punpckhbw mm0, mm7   ; mm0: 0'ba|0'br||0'bg|0'bb  

	mov eax, edx
	and eax, 255		; eax:	exf
	movd mm2,eax	; mm2: 0'0|0'0||0'0|0'dx
	mov ebx,255
	sub bl,al		; bx: idx 
	punpcklwd mm2,mm2		; mm2: 0'0|0'0||0'dx|0'dx
	punpckldq mm2,mm2		; mm2: 0'dx|0'dx||0'dx|0'dx
	movq mm3,mm2			; sauve mm2

	pmullw mm0,mm2			; mm0: ba*dx|br*dx||bg*dx|bb*dx  

	movd mm2,ebx			; mm2: 0'0|0'0||0'0|0'idx
	punpcklwd mm2,mm2		; mm2: 0'0|0'0||0'idx|0'idx
	punpckldq mm2,mm2		; mm2: 0'idx|0'idx||0'idx|0'idx

	pmullw mm1,mm2			; mm1: aa*idx|ar*idx||ag*idx|ab*idx

	paddusw mm0,mm1			; mm0: ba*dx+aa*idx|br*dx+ar*idx ||
					;      bg*dx+ag*idx|bb*dx+ab*idx

	mov ebx,255
	sub bl,[ebp+24]		; bx: idy
	movd mm2,ebx			; mm2: 0'0|0'0||0'0|0'idy 
	punpcklwd mm2,mm2		; mm2: 0'0|0'0||0'idy|0'idy
	punpckldq mm2,mm2		; mm2: 0'idy|0'idy||0'idy|0'idy

	psrlw mm0,8
	pmullw mm0,mm2			; mm0: a1*idy|r1*idy||g1*idy|b1*idy

	; deuxime ligne

	add esi,[ebp+16]
	movq mm1, [esi]		; mm1: d || c
	
	movq mm2,mm1			; mm2: d || c
	punpcklbw mm2, mm7	; mm2: 0'ca|0'cr||0'cg|0'cb
	punpckhbw mm1, mm7	; mm1: 0'da|0'dr||0'dg|0'db
	
	movd mm3,eax		; mm3: 0'0|0'0||0'0|0'dx
	mov ebx,255
	sub bl,al		; bx: idx 
	punpcklwd mm3,mm3		; mm3: 0'0|0'0||0'dx|0'dx
	punpckldq mm3,mm3		; mm3: 0'dx|0'dx||0'dx|0'dx

	pmullw mm1,mm3			; mm1: da*dx|dr*dx||dg*dx|db*dx  

	movd mm3,ebx			; mm3: 0'0|0'0||0'dx|0'idx
	punpcklwd mm3,mm3		; mm3: 0'0|0'0||0'idx|0'idx
	punpckldq mm3,mm3		; mm3: 0'idx|0'idx||0'idx|0'idx

	pmullw mm2,mm3			; mm2: ca*idx|cr*idx||cg*idx|cb*idx

	paddusw mm1,mm2		; mm1: da*dx+ca*idx|dr*dx+cr*idx ||
				;		 dg*dx+cg*idx|db*dx+cb*idx

	movd mm3, [ebp+24]	; mm3: 0'0|0'0||0'0|0'dy
	punpcklwd mm3,mm3		; mm3: 0'0|0'0||0'dy|0'dy
	punpckldq mm3,mm3		; mm3: 0'dy|0'dy||0'dy|0'dy

	psrlw mm1,8
	pmullw mm1,mm3			; mm1: a2*dy|r2*dy||g2*dy|b2*dy

	paddusw mm0,mm1		; mm0: a|r||g|b

	psrlw mm0,8			; mm0 : 0'a|0'r||0'g|0'b
	packuswb mm0,mm0

	
	;  s'occupe de la transparence

	movd mm1, [edi]		;  screen
	movd mm2, [ebp+28]	;  d2
	psubusb mm0,mm2

	paddusb mm1,mm0		;  ajoute couleur 
	
	movd [edi],mm1

	add edx,[ebp+20]	; zx+=z
	add edi,4		; point suivant
	dec ecx
	jnz NEAR _loop
	
	pop ebx
	pop edi
	pop esi
	pop ebp
	ret
