// Moteur 3d de Ced

#include <vector>
#include <iostream>

#include <stdlib.h>
#include "effets.h"
#include "Render.h"
#include "lib3ds/material.h"
#include "Object.h"
#include "3DPath.h"

static fVector scm_pos[4] = {{-320, 640,0},
							 { 320, 640,0},
							 { 320,-640,0},
							 {-320,-640,0}};
static fVector scm_tex[4] = {{ 0.0, 0.0, 0.0},
							 { 1.0, 0.0, 0.0},
							 { 1.0, 1.0, 0.0},
							 { 0.0, 1.0, 0.0}};
static fVector flq_pos[4] = {{-320,   0,0},
							 { 320,   0,0},
							 { 320,-640,0},
							 {-320,-640,0}};

static inline Uint32 cmerge(const int src, const int dst, const int ALPHA)
{
        const int ret = ( src*(ALPHA) + dst*(255-ALPHA) ) >> 8;
        //assert (ret >= 0 && ret <= 255);        // to be removed
        return ret;
}

static void LowDrawAlpha(Uint32 *screen, Uint32 *soff,
						 const int ycount, const int xcount)
{
	for (int y=0; y<ycount; y++) {
		for (int x=0; x<xcount; x++) {
			const Uint32 sc = *soff;    // image (source)
			const Uint32 dc = *screen;                // screen (dest)
			Uint32 Rsc = (sc&RMASK) >> RSHFT; Uint32 Gsc = (sc&GMASK) >> GSHFT; 
			Uint32 Bsc = (sc&BMASK) >> BSHFT; 
			const Uint32 ALPHA = (sc&AMASK) >> ASHFT;
			
			Uint32 Rdc = (dc&RMASK) >> RSHFT; Uint32 Gdc = (dc&GMASK) >> GSHFT; 
			Uint32 Bdc = (dc&BMASK) >> BSHFT; 
			
			Uint32 Rfc = cmerge(Rsc, Rdc, ALPHA)<<RSHFT;
			Uint32 Gfc = cmerge(Gsc, Gdc, ALPHA)<<GSHFT;
			Uint32 Bfc = cmerge(Bsc, Bdc, ALPHA)<<BSHFT;
			
			const Uint32 ColorFinal = Rfc + Gfc + Bfc;
			
			*screen = ColorFinal;
			screen++; soff++;
		}
	}
}

scroll_miroir::scroll_miroir(Render *rd)
{
	wave = new waves(320, 320, 200, -100, 50, 10, 10);
	this->rd = rd;
	sprite = rd->bind("scroll_flaque.png");
	flaque = rd->bind("degrade3.png");
	sdl_sprite = rd->getTexture(sprite);
	sdl_flaque = rd->getTexture(flaque);
	cout << "sdl_sprite  w "<< sdl_sprite->w<<" h "<<sdl_sprite->h<<endl;
	temp = SDL_CreateRGBSurface(SDL_SWSURFACE, 320, 320, 32,0xFF0000, 0xFF00, 0xFF,0xFF000000);
	wavetemp = SDL_CreateRGBSurface(SDL_SWSURFACE, 320, 320, 32,0xFF0000, 0xFF00, 0xFF,0xFF000000);
	mmx_quadcpy((Uint32*)(sdl_sprite->pixels)+320*320,temp->pixels,320*320/2);
	//mmx_quadcpy(sdl_flaque->pixels,(Uint32*)(sdl_sprite->pixels)+320*320,320*320/2);
	asm_emms();
}
 
scroll_miroir::~scroll_miroir() { }

void scroll_miroir::go(Uint32 *screen, Uint32 time)
{
	
	rd->push(4, scm_pos, scm_tex, sprite, 0);
	//rd->push(4, flq_pos, scm_tex, flaque, 0);
	wave->go((Uint32*)sdl_flaque->pixels, (Uint32*)wavetemp->pixels, time);
	mmx_quadcpy(wavetemp->pixels,(Uint32*)(sdl_sprite->pixels)+320*320,320*320/2);
	asm_emms();
	//wave->go((Uint32*)temp->pixels, (Uint32*)wavetemp->pixels, time);
	LowDrawAlpha((Uint32*)(sdl_sprite->pixels)+320*320, (Uint32*)temp->pixels, 320, 320);
	
	//mmxblend(temp->pixels, 320, 320,
	//	   (Uint32*)(sdl_sprite->pixels)+320*320, 320, 320,
	//	   0, 0, 0, 0, 320, 320, 0, 0 );
	
}

