/* Un joli petit scroll dans le dsert */

#include "effets.h"

// prepare le degrad
void genere_degrade(int *degrade);

// putain de constructeur
scrolld::scrolld(SDL_Surface *scr)
{
	// on charge l'image initiale
	SDL_Surface *fondtmp,*nuagestmp;
	fondtmp = IMG_Load (PATH_2D "dunes2.jpg"); testload (fondtmp);
	nuagestmp = IMG_Load (PATH_2D "ciel_desert2.png"); testload (nuagestmp);
	fond = SDL_CreateRGBSurface (SDL_SWSURFACE, 1280, 320, 32,0xFF0000,
                               0xFF00, 0xFF,0xFF000000);
	nuages = SDL_CreateRGBSurface (SDL_SWSURFACE, 640, 160, 8, 0, 0, 0, 0);

  SDL_BlitSurface (fondtmp,NULL, fond, NULL);

	// recopie la palette
	LOCK_SURFACE(nuages);
	LOCK_SURFACE(nuagestmp);
	LOCK_SURFACE(fond);
	for (int i=0; i<256; i++) {
			colors[i] = nuagestmp->format->palette->colors[i].b + 
									(nuagestmp->format->palette->colors[i].g<<8) + 
									(nuagestmp->format->palette->colors[i].r<<16) + 
									(0x7F<<24);
	}

	// puis les donnes
	Uint8 *pnuagestmp = (Uint8 *) nuagestmp->pixels;
	Uint8 *pnuages = (Uint8 *) nuages->pixels;
	for (int i=0; i<640*160; i++) {
		pnuages[i] = pnuagestmp[i];
	}

	// met un alpha acceptable pour la saturation
	Uint32 *pfond = (Uint32 *) fond->pixels;
	for (int i=0; i<1280*320; i++) {
		pfond[i] = pfond[i]&0x7FFFFFFF;
	}
	UNLOCK_SURFACE(nuages);
	UNLOCK_SURFACE(nuagestmp);
	UNLOCK_SURFACE(fond);

	SDL_FreeSurface (fondtmp);
	SDL_FreeSurface (nuagestmp);

  // prepare le degrad
	genere_degrade(degrade);
}

static
void blur(int *src, int *dst)
{
	const int prof = 6;	
	int *prec = new int[prof], *suiv = new int[prof];
	for (int i=0; i<480; i++) {
		for (int j=0; j<prof; j++) {
			prec[j]=CLAMP(i-1-j,0,479);
			suiv[j]=CLAMP(i+1+j,0,479);
		}
		int c=src[i];
		for (int j=0; j<prof; j++) {
			c += src[prec[j]] + src[suiv[j]];
		}
		c = c / (2*prof + 1);
		dst[i] = CLAMP(c,0,255);
	}
}

void genere_degrade(int *degrade)
{

	int d2[480];

	for (int i=0; i<480; i++) {
		d2[i] = 32;
	}


	for (int i=0; i<20; i++) {
		int pos = rand()%480;
		
		int c = 32;
		for (int j=0; j<5; j++) {
			c += rand()%256;
		}
		c /= 5;
		int seg = rand()%5+1;
		for (int h=0; h<seg; h++) d2[pos+h] = 512 + c;
	}

	int *t1=d2, *t2=degrade,*t3;
	for (int i=0; i<7; i++) {
		blur(t1,t2);	
		t3=t1; t1=t2; t2=t3;
	}

	for (int i=0; i<480; i++) {
		degrade[i] = CLAMP(d2[i],0,255);
	}

}


int scrolld::go(const Uint32 time, Uint32 *buffer)
{
	float t = time;
	int itime2 = (int) (t*0.05);
	static float time1=0;
	static float time2=0;

	if (time1<=640) {
		time1 = 0.000001*t*t;
		time2 = 0.6*time1;
	}

	Uint32 *buftmp; // = buffer + (160*640);
	Uint32 itime = (int) time1;		// partie entire
	Uint32 rtime = (int) ((time1-itime)*256.0); // partie dcimale * 256
	Uint32 irtime = 255 - rtime;

	int itimeb = (int) time2;
	int rtimeb = (int) ((time2-itimeb)*256.0); // partie dcimale * 256
	int irtimeb = 255 - rtimeb;

	int sat = time-10000;
	if (sat>255) sat=511-sat;
	if (sat<0) sat=0;
	// sat = cos(t*0.01)*127 + 128;
	sat = (sat<<16)|(sat);

	Uint32 ajout1 = 1;
	ajout1 = (ajout1<<16)|ajout1;

	// nuages
  buftmp = buffer;
	LOCK_SURFACE(nuages);
	Uint8 *pnuages = (Uint8 *) (nuages->pixels);

	int offdest = itimeb%640;
	int taille = 639 - offdest;
	int offdestb = 0;
	int tailleb = offdest+1;

	for (int y=0; y<160; y++) {
		int at;
		if (itime2<1024) {
			at = (degrade[y]*itime2)>>4;
			if (at>255) at=255;
		} else {at=255;}	

		mmx_scroll3(rtimeb,irtimeb, buftmp, pnuages+offdest, taille, at,colors);
		mmx_scroll3(rtimeb,irtimeb, buftmp+taille, pnuages+offdestb, tailleb, at,colors);

		buftmp += 640;
		offdest += 640;
		offdestb += 640;
	}
	UNLOCK_SURFACE(nuages);

	// fond
	LOCK_SURFACE(fond);
	Uint32 *pfond = (Uint32 *) (fond->pixels);
	offdest = itime;
	for (int y=0; y<320; y++) {
		if (itime2<1024) {
			int at = (degrade[y+160]*itime2)>>4;
			if (at>255) at=255;
			mmx_scroll2(rtime, irtime, buftmp, pfond+offdest, 640, at);
		}
		else {
			mmx_scroll(rtime, irtime, buftmp, pfond+offdest, 640);
		}

		offdest += 1280; 
		buftmp += 640;
	}

	// sature les pixels
	buftmp = buffer;
	if (sat!=0)
			mmx_sat (buftmp, 640*480, sat, ajout1); 	

/*	buftmp = buffer;
	for (int i=0; i<480; i++) {
		for (int j=0; j<50; j++) {
			buftmp[j] = degrade[i]<<16;
		}
		buftmp+=640;
	}
*/
	asm_emms();
	UNLOCK_SURFACE(fond);
	
	return 0;
}

scrolld::~scrolld()
{
	SDL_FreeSurface(fond);
	SDL_FreeSurface(nuages);
}
