// petit starfield  la con

#include "effets.h"

// constructeur
STAR3D::STAR3D(int Nb_Stars = 40)
{
	NBSTAR = Nb_Stars;	
	star = new iVector[NBSTAR];
	init_stars();
}

void STAR3D::init_stars()
{
	for (int i=0; i<NBSTAR; i++) {
		star[i][0] = ( rand()%640 - 320 ) * SCALEX;
		star[i][1] = ( rand()%480 - 240 ) * SCALEX;
		star[i][2] = rand()%ZMAX + ZMIN;
	}
}

// destructeur
STAR3D::~STAR3D(void)
{
	delete(star);
}

void STAR3D::go(Uint32 *buffer, Uint32 time, int Nb_Stars = -1)
{
	int zadd = (int) ( cos(time*0.0005)*128 );
	int xadd = (int) ( cos(time*0.001)*10000 );
	int yadd = (int) ( sin(time*0.001)*10000 );
	int nbstar = Nb_Stars;
	if (nbstar==-1) nbstar=NBSTAR;
	for (int i=0; i<nbstar; i++) {
		int z = (star[i][2] + zadd)%(ZMAX-ZMIN);
		if (z<0) z += (ZMAX-ZMIN);
		z += ZMIN;	
		int x = (star[i][0] + xadd + XMAX)%(XMAX*2) - XMAX;
		int y = (star[i][1] + yadd + YMAX)%(YMAX*2)	- YMAX;

		int xe = x/z + 320;
		int ye = y/z + 240;

		if ( (xe>=0) && (xe<640) && (ye>=0) && (ye<480) ) {
			int intensity = 255 - ( (z-ZMIN) << 8 ) / (ZMAX-ZMIN) ;
			Uint32 c = (intensity) | (intensity<<8) | (intensity<<16);
			buffer[xe+ye*640] = c;
		}
	}	
}

// end of star3D.cc
