// Stargate

#include <vector>
#include <iostream>

#include <stdlib.h>
#include "effets.h"

iVector mapping[4] = { {   0, 256, 0 },
					   { 256, 256, 0 },
					   { 256,   0, 0 },
					   {   0,   0, 0 } };

fVector vertex[4] = { {   0.0, 256.0, 0.0 },
					  { 256.0, 256.0, 0.0 },
					  { 256.0,   0.0, 0.0 },
					  {   0.0,   0.0, 0.0 } };

stargate::stargate()
{
  /* Utils vars */
  f_make_identity_matrix( m );
  xangle = 0;
  yangle = 0;
  zangle = 0;
  
  // charge texture
  myloadedtexture = IMG_Load(PATH_2D "stargate.png");
  if( !myloadedtexture ) {
    printf("La texture est pas la !!!!\n");
    exit(1);
  } else {
    mytexture = SDL_CreateRGBSurface (SDL_SWSURFACE, 256, 256, 32,
				      0xFF0000, 0xFF00, 0xFF,0xFF000000);
    SDL_BlitSurface (myloadedtexture,NULL, mytexture, NULL);
    SDL_FreeSurface(myloadedtexture);
  }

  for (int i=0; i<4; i++) {
    for (int j=0; j<3; j++) {
		mapping[i][j] *= 65536;
    }
  }
}

// Destructeur
stargate::~stargate()
{
	// libre les textures
	SDL_FreeSurface(mytexture);
}

// Calcule les coordonnes camera/objets et affichage
void stargate::go(Uint32 *screen, Uint32 time)
{
  //CalcFPS( time );

  xangle = 0; //(float) time*0.0024;
  yangle = 0; //(float) time*0.0016;
  zangle = 0; //(float) time*0.0016;	

  float T = M_PI / 4000;
  //xangle = 0; //-M_PI/2;
  yangle =  time*T + M_PI;
  //zangle = 0;
  //zangle = time*T + M_PI;
  //Zang -= 0.013;
  //Zcam = 100*cos(time*0.001);
  float xcam = 500*sin(time*T);
  float ycam = 0; //800*cos(time*T);
  float zcam = 500*cos(time*T); //1-time*0.4;

  //cout << yangle << endl;

  fMatrix tm, rm, m;

  
  // ################## MATRICE MOUVEMENTS ############# //
  f_make_identity_matrix( tm );
  f_trans_matrix( tm, -xcam, -ycam, -zcam);

  f_make_identity_matrix( rm );
  f_append_xrot_matrix( rm, xangle );
  f_append_yrot_matrix( rm, -yangle );
  f_append_zrot_matrix( rm, zangle );

  f_ConcatMatrices( rm, tm, m );

  //f_trans_matrix( m, -150.0, 0.0, 0.0 );
  // ################## FIN MATRICE #################### //
  
  for(int i=0; i<4; i++ ){
	  f_XformVector( m, vertex[i], ntri[i] );
  }
  
  // projection
  const float CLIPZ = 0.001;
  for (int i=0; i<4; i++) {
	  
	  if( ntri[i][2] <= CLIPZ ) return;
	  float z = 400.0 / (ntri[i][2] + 10.0);
	  ntri[i][0] *= z;
	  ntri[i][1] *= z;
	  
	  for (int j=0; j<3; j++) {
		  intri[i][j] = (int) (ntri[i][j]*65536.0);	  
	  }
  }

  render_tri( screen, intri, mapping, (Uint32*)mytexture->pixels, mytexture->w, mytexture->h,
			  0 /*| CULL_FACE | BILINEAR_FILT*/ , 4 );
  asm_emms();  
}

