// Moteur 3d de Ced

#include "effets.h"

#define MAX_SPRITES 200

static fVector triangle[3] = {{ -32.0, -32.0, 0.0 },
			      {   0.0,  31.0, 0.0 },
			      {  31.0, -32.0, 0.0 }};

static fVector spritex[3]  = {{   0.0,   0.0, 0.0 },
                              {  31.0,  63.0, 0.0 },
                              {  63.0,   0.0, 0.0 }};

static fVector sprite[MAX_SPRITES][3];
static float   multip[MAX_SPRITES][3];

static Uint32 temptexture[64*64*4];


void render_trialpha( Uint32 *screen, fVector vertex[], fVector vtex[],
                      Uint32 *tex, int wtex, int htex, Uint32 opts );

// Constructeur
toto::toto( )
{
	xangle = 0.0;
	yangle = 0.0;
	zangle = 0.0;
	ztrans = 0.0;

	fMatrix m;

	for( int i=0; i<MAX_SPRITES; i++ ){

		f_make_identity_matrix( m );
		f_append_xrot_matrix( m, M_PI*(rand()%1000)/1000.0 );
		f_append_yrot_matrix( m, M_PI*(rand()%1000)/1000.0 );
		f_append_zrot_matrix( m, M_PI*(rand()%1000)/1000.0 );

		f_trans_matrix( m, (rand()%10000)/10.0 - 500.0,
				   (rand()%10000)/10.0 - 500.0,
				   (rand()%10000)/10.0 - 500.0 );	

		for( int j=0; j<3; j++ ){
			f_XformVector( m, triangle[j], sprite[i][j] );
		}
	}

	Uint32 alpha = 128;
	for( int i=0; i<64; i++ )
		for( int j=0; j<64; j++ )
			temptexture[i*64+j]= //0x7F00FF00;
					     (((i*4)&0xFF)<<16) |
					     (((j*4)&0xFF)<<8) |
					     ((255-j*4)&0xFF) |
					     ((alpha&0xFF)<<24);

	for( int i=0; i<MAX_SPRITES; i++ )
		for( int j=0; j<3; j++ )
			multip[i][j] = (rand()%2000)/1000.0 -1.0;

	//	SDL_VideoInfo *popol = (SDL_VideoInfo *)SDL_GetVideoInfo();
	//	printf("Amask %x\n",popol->vfmt->Amask);

}

// Destructeur
toto::~toto() { }

// Calcule les coordonnes camera/objets et affichage
void toto::go( Uint32 *buffer, Uint32 time)
{
	fMatrix m;
	fVector tmp[3];

	xangle += 0.05;
	yangle += 0.03;
	zangle += 0.08;
	//ztrans += 10;

	for( int i=0; i<MAX_SPRITES; i++ ){

		// ################## MATRICE MOUVEMENTS ############# //
		//f_make_identity_matrix( tm );
		//f_trans_matrix( tm, px1, py1, -10.0 );

		f_make_identity_matrix( m );
		f_append_xrot_matrix( m, xangle * (multip[i][0]) );
		f_append_yrot_matrix( m, yangle * (multip[i][1]) );
		f_append_zrot_matrix( m, zangle * (multip[i][2]) );

		//f_ConcatMatrices( rm, tm, m );

		//f_trans_matrix( m, 0.0, 0.0, 0.0 );
		// ################## FIN MATRICE #################### //


		for( int j=0; j<3; j++ ){
    	f_XformVector( m, sprite[i][j], tmp[j] );
			if( tmp[j][2] < 0.1 ) goto pabon;			
			tmp[j][0] *= 500.0/(tmp[j][2]+500.0);
			tmp[j][1] *= 500.0/(tmp[j][2]+500.0);
    }		
		render_trialpha( buffer, tmp, spritex, temptexture, 64, 64, 0 );

		pabon:
			{}
	}

}

// Rendu de l'image
void render_trialpha( Uint32 *screen, fVector vertex[], fVector vtex[],
		      Uint32 *tex, int wtex, int htex, Uint32 opts )
{

	Uint32 tmpcol;
	Uint32 couleur;
	unsigned char alpha;

	htex -= 1;

	float VAx,VAy,VBx,VBy,VCx,VCy;
	float  Ax, Ay, Bx, By, Cx, Cy;
	float Yit1,Yit2,Yit3;

	float  Xpad1=0.0,  Xpad2=0.0,  Xpad3=0.0;
	float VXpad1=0.0, VXpad2=0.0, VXpad3=0.0;
	float VYpad1=0.0, VYpad2=0.0, VYpad3=0.0;
	float VXpad,VYpad;

	float Xit;

	float  x1, x2;
	float Vx1,Vx2;
	float Vy1,Vy2;
	float  x, y;
	float Vx,Vy;

	int posy, posx;
	
	// Polygones en dehors de l'ecran totalement
	if( (vertex[0][VECT_X] < -320.0) &&
	    (vertex[1][VECT_X] < -320.0) &&
	    (vertex[2][VECT_X] < -320.0) ) return;
	if( (vertex[0][VECT_X] >  319.0) &&
	    (vertex[1][VECT_X] >  319.0) &&
	    (vertex[2][VECT_X] >  319.0) ) return;
        if( (vertex[0][VECT_Y] < -240.0) &&
            (vertex[1][VECT_Y] < -240.0) &&
            (vertex[2][VECT_Y] < -240.0) ) return;
        if( (vertex[0][VECT_Y] >  239.0) &&
            (vertex[1][VECT_Y] >  239.0) &&
            (vertex[2][VECT_Y] >  239.0) ) return;

	if( opts & CULL_FACE ){
		//  (x1-x2)*(y2-y3) - (x2-x3)*(y1-y2)
		if( (vertex[0][VECT_X] - vertex[1][VECT_X]) *
		    (vertex[1][VECT_Y] - vertex[2][VECT_Y]) -
    	            (vertex[1][VECT_X] - vertex[2][VECT_X]) *
		    (vertex[0][VECT_Y] - vertex[1][VECT_Y]) < 0.0 )
			return;
	}

	if( vertex[0][VECT_Y] <= vertex[1][VECT_Y] ) {  // 0 <= 1
		if( vertex[2][VECT_Y] >= vertex[1][VECT_Y] ){ // 0 <= 1 <= 2
			Ax = vertex[0][VECT_X];
			Ay = vertex[0][VECT_Y];
			Bx = vertex[1][VECT_X];
                        By = vertex[1][VECT_Y];
			Cx = vertex[2][VECT_X];
                        Cy = vertex[2][VECT_Y];
			VAx = vtex[0][VECT_X];
			VAy = vtex[0][VECT_Y];
                        VBx = vtex[1][VECT_X];
                        VBy = vtex[1][VECT_Y];
                        VCx = vtex[2][VECT_X];
                        VCy = vtex[2][VECT_Y];
		} else if( vertex[2][VECT_Y] <= vertex[0][VECT_Y] ){ // 2 <= 0 <= 1
			Ax = vertex[2][VECT_X];
                        Ay = vertex[2][VECT_Y];
                        Bx = vertex[0][VECT_X];
                        By = vertex[0][VECT_Y];
                        Cx = vertex[1][VECT_X];
                        Cy = vertex[1][VECT_Y];
                        VAx = vtex[2][VECT_X];
                        VAy = vtex[2][VECT_Y];
                        VBx = vtex[0][VECT_X];
                        VBy = vtex[0][VECT_Y];
                        VCx = vtex[1][VECT_X];
                        VCy = vtex[1][VECT_Y];
                } else { // 0 <= 2 <= 1
                        Ax = vertex[0][VECT_X];
                        Ay = vertex[0][VECT_Y];
                        Bx = vertex[2][VECT_X];
                        By = vertex[2][VECT_Y];
                        Cx = vertex[1][VECT_X];
                        Cy = vertex[1][VECT_Y];
                        VAx = vtex[0][VECT_X];
                        VAy = vtex[0][VECT_Y];
                        VBx = vtex[2][VECT_X];
                        VBy = vtex[2][VECT_Y];
                        VCx = vtex[1][VECT_X];
                        VCy = vtex[1][VECT_Y];
		}
	} else { // 1 < 0
		if( vertex[2][VECT_Y] >= vertex[0][VECT_Y] ){ // 1 < 0 <= 2
                        Ax = vertex[1][VECT_X];
                        Ay = vertex[1][VECT_Y];
                        Bx = vertex[0][VECT_X];
                        By = vertex[0][VECT_Y];
                        Cx = vertex[2][VECT_X];
                        Cy = vertex[2][VECT_Y];
                        VAx = vtex[1][VECT_X];
                        VAy = vtex[1][VECT_Y];
                        VBx = vtex[0][VECT_X];
                        VBy = vtex[0][VECT_Y];
                        VCx = vtex[2][VECT_X];
                        VCy = vtex[2][VECT_Y];

		} else if( vertex[2][VECT_Y] <= vertex[1][VECT_Y] ){ // 2 <= 1 < 0
			Ax = vertex[2][VECT_X];
                        Ay = vertex[2][VECT_Y];
                        Bx = vertex[1][VECT_X];
                        By = vertex[1][VECT_Y];
                        Cx = vertex[0][VECT_X];
                        Cy = vertex[0][VECT_Y];
			VAx = vtex[2][VECT_X];
                        VAy = vtex[2][VECT_Y];
                        VBx = vtex[1][VECT_X];
                        VBy = vtex[1][VECT_Y];
                        VCx = vtex[0][VECT_X];
                        VCy = vtex[0][VECT_Y];
                } else { // 1 <= 2 < 0
			Ax = vertex[1][VECT_X];
                        Ay = vertex[1][VECT_Y];
                        Bx = vertex[2][VECT_X];
                        By = vertex[2][VECT_Y];
                        Cx = vertex[0][VECT_X];
                        Cy = vertex[0][VECT_Y];
                        VAx = vtex[1][VECT_X];
                        VAy = vtex[1][VECT_Y];
                        VBx = vtex[2][VECT_X];
                        VBy = vtex[2][VECT_Y];
                        VCx = vtex[0][VECT_X];
                        VCy = vtex[0][VECT_Y];
                }
	}


	Yit1 = By - Ay;
	Yit2 = Cy - Ay;
	Yit3 = Cy - By;
	
	Xpad1 = (Bx - Ax) / (Yit1+1.0);
	Xpad2 = (Cx - Ax) / (Yit2+1.0);
	Xpad3 = (Cx - Bx) / (Yit3+1.0);

	VXpad1 = (VBx - VAx) / (Yit1+1.0);
        VYpad1 = (VBy - VAy) / (Yit1+1.0);
        VXpad2 = (VCx - VAx) / (Yit2+1.0);
        VYpad2 = (VCy - VAy) / (Yit2+1.0);
        VXpad3 = (VCx - VBx) / (Yit3+1.0);
        VYpad3 = (VCy - VBy) / (Yit3+1.0);
	
	Vx1 = Vx2 = VAx;
	x1 = x2 = Ax;
	Vy1 = Vy2 = VAy;
	y = Ay;


//#define ALPHA screen[ posy + posx ] = tex[ (int)Vx + (int)Vy * wtex ];
#ifndef ALPHA
#define ALPHA couleur = tex[ (int)Vx + (int)Vy * wtex ]; \
                                alpha = couleur>>24; \
                                tmpcol = screen[ posy + posx ]; \
                                screen[posy+posx] = \
     /*( (tmpcol&0x000000FF) - (((tmpcol&0x000000FF)-(couleur&0x000000FF))*alpha)/255 ) |*/ \
     ( (tmpcol&0x0000FF00) - (((tmpcol&0x0000FF00)-(couleur&0x0000FF00))*alpha)/255 ) /*|*/ \
     /*( (tmpcol&0x00FF0000) - (((tmpcol&0x00FF0000)-(couleur&0x00FF0000))*alpha)/255 )*/; \
//	printf("* %x %x %x *",tmpcol,couleur, screen[posy+posx]);

#endif
/*col * (255 - alpha) / 255    +   col2 * alpha / 255
  col - col*alpha/255 + col2*alpha/255
  col - (col+col2) *alpha / 255*/

	//if( Yit1 >= 1.0 )
	for( y = Ay ; y < By ; y += 1.0 ) {
		Xit = x2 - x1;
		Vx = Vx1;
		VXpad = (Vx2 - Vx1)/fabs(Xit);
		Vy = Vy1;
		VYpad = (Vy2 - Vy1)/fabs(Xit);
		
		if( y <  -240.0 ) {goto suite1;}
		if( y >=  240.0 ) {goto suite1;}
		posy = (640*240 + 320) + (int)y * 640;
		if( Xit >= 0.0 )
			for( x = x1 ; x <= x2; x += 1.0, Vx += VXpad, Vy += VYpad ) {
				posx = (int)x;
				if( (posx >= 320) || (posx < -320) ) continue;
				ALPHA
			}
		else
			for( x = x1 ; x >= x2; x -= 1.0, Vx += VXpad, Vy += VYpad ) {
				posx = (int)x;
                                if( (posx >= 320) || (posx < -320) ) continue;
				//screen[ posy + posx ] = tex[ (int)Vx + (int)Vy * wtex ];
				ALPHA
			}
		suite1:
		x1 += Xpad1;
		x2 += Xpad2;
		Vx1 += VXpad1;
		Vx2 += VXpad2;
		Vy1 += VYpad1;
		Vy2 += VYpad2;
	}

	Vx1 = VBx;
	Vy1 = VBy;
	//if( Yit3 >= 1.0 )
	for( x1 = Bx/*, y = By*/ ; y <= Cy ; y += 1.0 ) {
		Xit = x2 - x1;

		Vx = Vx1;
                VXpad = (Vx2 - Vx1)/fabs(Xit);
                Vy = Vy1;
                VYpad = (Vy2 - Vy1)/fabs(Xit);

		if( y <  -240.0 ) {goto suite2;}
                if( y >=  240.0 ) {goto suite2;}
		posy = (640*240 + 320) + (int)y * 640;
		if( Xit >= 0.0 )
			for( x = x1 ; x <= x2; x += 1.0, Vx += VXpad, Vy += VYpad ) {
				posx = (int)x;
                                if( (posx >= 320) || (posx < -320) ) continue;
                                //screen[ posy + posx ] =  tex[ (int)Vx + (int)Vy * wtex ];
				ALPHA
			}
		else
			for( x = x1 ; x >= x2; x -= 1.0, Vx += VXpad, Vy += VYpad ) {
				posx = (int)x;
                                if( (posx >= 320) || (posx < -320) ) continue;
                                //screen[ posy + posx ] = tex[ (int)Vx + (int)Vy * wtex ];
				ALPHA
			}
		suite2:
		x1 += Xpad3;
		x2 += Xpad2;

		Vx1 += VXpad3;
                Vx2 += VXpad2;
                Vy1 += VYpad3;
                Vy2 += VYpad2;

	}

}

// end of 3d.cc
