// Fait des vagues sur une images
#include "SDL.h"
#include <effets.h>

typedef int Sint32;

// Constructeur. L'effet travaillera sur une image de taille W x H. La
// vague est centr en CX x CY, avec une longueur de vague L et une
// vitesse S. La vague a une amplitude de A pixels.
waves::waves (int w, int h, int cx, int cy, int l, int s, int a)
{
    int t, x, y;
    Sint32 dec;
    sintbl = new Sint32[256];
    dtbl = new Uint8[w * h];
    speed = s;
    width = w;
    size = w * h;
    ampl = a;
    for (y = 0; y < h; y++)
	for (x = 0; x < w; x++)
	  {
	    dtbl[y*w+x] = (Uint8) (sqrt ((cx-x)*(cx-x) + (cy-y)*(cy-y)) / l * 255);
	  }
    for (t = 0; t < 256; t++)
      {
	dec = (Sint32) (sin ((double) t * 2 * M_PI / 256) * ampl);
	sintbl[t] = dec * w + dec;
      }
}

// Fait le menage.
waves::~waves (void)
{
    delete sintbl;
}

// Calcule l'effet au temps T dans l'image DST  partir de SRC.
void
waves::go (Uint32 *src, Uint32 *dst, Uint32 t)
{
    Uint8 ph;
    register Uint8 *d;
    Sint32 i, s, dec, w;
    ph = t / speed;
    d = dtbl;
    w = width;
    s = size - w * (ampl + 1);
    src += w * (ampl + 1);
    dst += w * (ampl + 1);
    //for (i = 0; i < s; i++)
    for (i = w * (ampl + 1); i < s; i++)
      {
	dec = sintbl[(*d++ + ph) & 0xff];
	//if (i + dec > s) dec = s - i;
	//if (i + dec < 0) dec = -i;
	*dst++ = *(src++ + dec);
      }
}
