// Z2.cc

#include "effets.h"

void fzoom(Uint32 *src, Uint32 *dst, int SW, int DW,
					int sx1, int sx2, int dx1, int dx2, 
					int sy1, int sy2, int dy1, int dy2)
{

	float dx = ( (sx2-sx1))/ (dx2-dx1);
	float dy = ( (sy2-sy1))/ (dy2-dy1);

	float X=0, Y=0;

	for (int y=dy1; y<dy2; y++) {	
		X = 0;
		for (int x=dx1; x<dx2; x++) {
			dst[x+y*DW] = src[ (int) X + (int) Y *SW];
			X += dx;
		}
		Y += dy;
	}
}


// constructeur
Z2::Z2()
{
	tmp1 = SDL_CreateRGBSurface (SDL_SWSURFACE, 256, 256, 32,0xFF0000,
                               0xFF00, 0xFF,0xFF000000);	

	FOCUS = 256;

	SDL_Surface *loadtmp = IMG_Load (PATH_2D "nops3.png"); testload (loadtmp);
	SDL_Surface *load = SDL_CreateRGBSurface (SDL_SWSURFACE, 128, 128, 32,0xFF0000,
                      						         0xFF00, 0xFF,0xFF000000);

	SDL_BlitSurface (loadtmp, NULL, load, NULL);

	LOCK_SURFACE(load);
	Uint32 *tmp = (Uint32 *)load->pixels;
	for (int i=0; i<128*128; i++) {
		text[i] = tmp[i];
	}
	UNLOCK_SURFACE(load);

	SDL_FreeSurface(loadtmp);
	SDL_FreeSurface(load);
	
	// normalize tout
	racine();
}

// normalise les vect
void Z2::racine()
{
	int off=0;
	for (int y=0; y<256; y++) {
		for (int x=0; x<256; x++) {
			double ix = (x-128), iy = (y-128), iz = FOCUS; 
			double lenght = ix*ix + iy*iy + iz*iz;
			double invl = sqrt(lenght);
			pcalcx[off] = (int) ( 512.0 * ix / invl ); 
			pcalcy[off] = (int) ( 512.0 * iy / invl ); 
			pcalcz[off] = (int) ( 512.0 * invl / iz ); 
			off++;
		}
	}
}

// destructeur
Z2::~Z2()
{
	// SDL_FreeSurface(tmp1);
}

// lance le truc
void Z2::go(int time)
{
	LOCK_SURFACE(tmp1);
	Uint32 *dst = (Uint32 *)tmp1->pixels;
	Uint32 doff = 0;

	float fc1 = cos(time*0.0005); 
	float fc2 = cos(time*0.0005+1.0); 
	float fs1 = sin(time*0.0005+0.9); 
	int t = (int) (512 + 256*fc1);
	int xrot = (int) (200*fc2);
	int yrot = (int) (120*fs1); 

	for (int y=0; y<256; y++) {
		for (int x=0; x<256; x++) {
			//int u = (pcalcx[ ((x+xrot)&255) +(((y+yrot)&255)  <<8)]*t)>>9;
			//int v = (pcalcy[ ((x+xrot)&255) +(((y+yrot)&255)  <<8)]*t)>>9;
			double ix = (x-128), iy = (y-128), iz = FOCUS; 
			double lenght = (ix*ix + iy*iy + iz*iz);
			double invl = (int) sqrt(lenght);
			int u = (int) ( 512*(ix+xrot) / invl ); 
			int v = (int) ( 512*(iy+yrot) / invl ); 

			  //pcalcz[off] = (int) ( (invl<<5) / iz ); 

			u = (u*t)>>10;
			v = (v*t)>>10;
			u = u & 127;
			v = v & 127;
			dst[doff++] = text[u+(v<<7)];
		}
	}
	UNLOCK_SURFACE(tmp1);
}

// affich text
void Z2::affich(Uint32 *buffer, int time)
{
	int ydec2 = (int) ( cos(time*0.002)*(480-256)/2) ;
	int ydec = (int) ( cos(time*0.003)*(480-256)/2) ;
	int xdec = (int) ( sin(time*0.002)*35);
	int xdec2 = (int) ( sin(time*0.003)*35);
	int offs = 0;
	int offd = 319+ 159-128  +xdec + 640*(240-128+ydec);
	int offd2 = 319+ 159-128  +xdec2 + 640*(240-128+ydec2);

	LOCK_SURFACE(tmp1);
	Uint32 *src = (Uint32 *)tmp1->pixels;
	for (int y=0; y<256; y++) {
		/*for (int x=0; x<256; x++) {
			buffer[offd++] = src[offs++];
		}*/
		int c = (-y+128)&511;
		if (c>255) c=511-c;
		c = CLAMP(c,0,255);
		int d = abs(xdec);
		mmx_addcol (src+offs, buffer+offd, 128, c|(d<<8)|(c<<16));
		mmx_addcol (src+offs, buffer+offd2, 128, c|(d<<8)|(c<<16));
		offd += 640; offs+=256; offd2 +=640;
	}
	asm_emms();
	UNLOCK_SURFACE(tmp1);

	//zoom(Uint32 *src, Uint32 *dst, int SW, int DW,
	//				int sx1, int sx2, int dx1, int dx2, 
	//				int sy1, int sy2, int dy1, int dy2)

	fzoom(buffer, text2, 640, 128,
					0, 640, 0, 128, 
					0, 480, 0, 128);
	int c = 0xFE;
	//mmx_addcol (text2, text, 128*128/2, c|(c<<8)|(c<<16));
	mmx_lettre (text2, text, 128*128/2, 0x22EEFF, (c<<16)|(c<<8)|c);
	asm_emms();

	// SDL_Delay(1000);

}

// end of Z2.cc
